unit ADKVideo;
{
 projet ADK-ISO (c)2002-2003 Paul TOTH <tothpaul@free.fr>

 http://www.web-synergy.net/naug-land/

}

interface

uses
 Windows,Messages,SysUtils,
// MiniDX,DXError,
 ADKDepth,ADKData;

var
 MouseButton:integer;
 MouseX:integer;
 MouseY:integer;
 MouseDown:boolean;


procedure SetupDX;
procedure CloseDX;
function ProcessMessages:boolean;
procedure Invalidate;

implementation

uses
 ADKRender,ADKGUI,ADKMemo, ADKScreens;

var
 HWnd :THandle;
 {
 DDraw:IDirectDraw2;
 DPrim:IDirectDrawSurface;
 DBack:IDirectDrawSurface;
 }
 DragInvent:boolean;
 Blink:cardinal;
 Caret:boolean;
 Edit :string;
 Cursor:integer;

procedure Paint;
var
 dc:HDC;
  t:cardinal;
  c:char;
 ts:TSize;
begin
 if Focus=nil then exit;

 inc(FrameCount);

// effacer l'cran
 ADKScreen.Clear(0);

// positionner la carte en la centrant sur le joueur
 ScrollX:=ADKScreen.Width  div 2-Focus.Left;
 ScrollY:=ADKScreen.Height div 2-Focus.Top;
// afficher la carte
 RenderMap;
// verrouiller l'cran en mise  jour
 if ADKScreen.Lock then
 try
  // afficher l'interface utilisateur
  RenderGUI;
 finally
  ADKScreen.UnLock;
 end;

// texte de la zone de chat
 dc:=ADKScreen.GetDC;
 try
  //RenderMemo(dc);
  Chat.DrawText(dc);
  SetBkMode(dc,TRANSPARENT);
  SetTextColor(dc,$ffffff);
  TextOut(dc,4,ADKScreen.Height-18,@Edit[1],Length(Edit));
  t:=GetTickCount;
  if Blink=0 then
   Blink:=t
  else begin
   while (t-Blink>500) do begin
    inc(Blink,500);
    Caret:=not Caret;
   end;
  end;
  if Caret then begin
   if Cursor>Length(Edit) then c:=' ' else c:=Edit[Cursor];
   SetBkMode(dc,OPAQUE);
   SetBkColor(dc,$ffffff);
   SetTextColor(dc,0);
   GetTextExtentPoint(dc,@Edit[1],Cursor-1,ts);
   TextOut(dc,4+ts.cx,ADKScreen.Height-18,@c,1);
  end;
 finally
  ADKScreen.ReleaseDC;
 end;

// fentre d'inventaire
 if Invent then begin
  if ADKScreen.Lock then
  try
   RenderInvent;
  finally
   ADKScreen.UnLock;
  end;
 end;

// fin de rendu
 ADKScreen.Flip;
end;

procedure OnMouseDown(x,y,button:integer);
begin
 MouseButton:=button;
 MouseX:=x;
 MouseY:=y;
 if Invent then begin
  if (x>ipos.x)and(x<ipos.x+isize.x)
  and(y>ipos.y) and(y<ipos.y+isize.y) then begin
   DragInvent:=True;
  end;
 end else begin
  if not GUIMouseDown(x,y,button) then begin
   MouseDown:=True;
   Focus.OnClick(x,y,button);
  end;
 end;
end;

procedure OnDblClick(x,y,button:integer);
begin
 GUIDblClick(x,y,button);
end;

procedure MouseUp;
begin
 DragInvent:=False;
 MouseDown:=False;
 GUIMouseUp;
end;

procedure MouseMove(x,y:integer);
begin
 if DragInvent then begin
  inc(ipos.x,x-MouseX);
  inc(ipos.y,y-MouseY);
  if ipos.x<0 then ipos.x:=0;
  if ipos.y<0 then ipos.y:=0;
  if ipos.x+isize.x>=ADKScreen.Width then ipos.x:=ADKScreen.Width-isize.x;
  if ipos.y+isize.y>=ADKScreen.Height then ipos.y:=ADKScreen.Height-isize.y;
 end;
 GUIMouseMove(x-MouseX,y-MouseY);
 MouseX:=x;
 MouseY:=y;
end;

function WndProc(hWnd,Msg,wParam,lParam:integer):integer; stdcall;
begin
 Result:=DefWindowProc(hWnd, msg, wParam, lParam);
 case Msg of
  WM_PAINT         : Paint; // -> ADKRender.pas
  WM_LBUTTONDOWN   : OnMouseDown(LOWORD(lParam),HIWORD(lParam),0); 
  WM_RBUTTONDOWN   : OnMouseDown(LOWORD(lParam),HIWORD(lParam),1);
  WM_LBUTTONDBLCLK : OnDblClick(LOWORD(lParam),HIWORD(lParam),0);
  WM_RBUTTONDBLCLK : OnDblClick(LOWORD(lParam),HIWORD(lParam),1);
  WM_LBUTTONUP,
  WM_RBUTTONUP     : MouseUp;
  WM_MOUSEMOVE     : MouseMove(LOWORD(lParam),HIWORD(lParam));
  WM_KEYDOWN       : begin
                      Caret:=True;
                      case wParam of
                       VK_RETURN   : begin Chat.Lines.add(Edit); Edit:=''; Cursor:=1; end;
                       VK_ESCAPE   : DestroyWindow(Hwnd);
                       VK_RIGHT    : if Cursor<=Length(Edit) then inc(Cursor);
                       VK_LEFT     : if Cursor>1 then dec(Cursor);
                       VK_DELETE   : Delete(Edit,Cursor,1);
                       VK_BACK     : if Cursor>1 then begin
                                      dec(Cursor);
                                      Delete(Edit,Cursor,1);
                                     end;
                       VK_HOME     : Cursor:=1;
                       VK_END      : if Cursor<Length(Edit) then Cursor:=Length(Edit)+1;
                       //ord('A')..ord('Z') : begin Insert(Char(wParam),Edit,Cursor); inc(Cursor); end;
                       ord('A')    : Alpha:=not Alpha;
                       VK_TAB      : Invent:=True;
                      end;
                     end;
  WM_KEYUP         : if wParam=VK_TAB then Invent:=False;
  WM_CHAR          : if wParam in [32..255] then begin
                      Insert(Char(wParam),Edit,Cursor);
                      inc(Cursor);
                     end;
  WM_DESTROY       : PostQuitMessage(0);
 end;
end;

procedure SetupDX;
const
 ClassName='ADK_DirectX_Window';
var
 wc:TWndClass;
// DD:IUnknown;
// SD:TDDSurfaceDesc;
begin
// Class Windows
 FillChar(wc,SizeOf(wc),0);
 wc.style:=CS_DBLCLKS;
 wc.lpfnWndProc:=@WndProc;
 wc.hInstance:=hInstance;
 wc.hCursor:=LoadCursor(0,IDC_ARROW);//LoadCursor(0,IDC_CROSS);
 wc.lpszClassName:=ClassName;
 if RegisterClass(wc)=0 then begin
  MessageBox(0,pchar('RegisterClass : Erreur Windows #'+IntToStr(GetLastError)),'Walker',0);
  halt;
 end;
// Create window
 HWnd:=CreateWindowEx(0,ClassName,'Walker',WS_POPUP or WS_VISIBLE or WS_CLIPCHILDREN,0,0,GWidth,GHeight,0,0,hInstance,nil);
 if HWnd=0 then begin
  MessageBox(0,pchar('CreateWindowEx : Erreur Windows #'+IntToStr(GetLastError)),'Walker',0);
  halt;
 end;
// ADKScreen:=TADKScreenGDI.Create(HWnd);
// ADKScreen:=TADKScreenDX.Create(HWnd,False);
 ADKScreen:=TADKScreen3D.Create(HWnd,True);
 ADKScreen.SetSize(GWidth,GHeight,GDepth);

 Edit:='Zone de saisie...';
 Cursor:=Length(Edit)+1;
end;

procedure CloseDX;
begin
{
 DBack:=nil;
 DPrim:=nil;
 DDraw.RestoreDisplayMode;
 DDraw:=nil;
}
 ADKScreen.Free;
 ADKScreen:=nil;
end;

function ProcessMessages:boolean;
var
 msg:TMsg;
begin
 while PeekMessage(Msg,0,0,0,pm_remove) do begin
  if msg.message=WM_QUIT then begin
   Result:=False;
   exit;
  end;
  TranslateMessage(msg); { Translates virtual key codes. }
  DispatchMessage(msg);  { Dispatches message to window. }
 end;
 Result:=True;
end;

procedure Invalidate;
begin
 InvalidateRect(Hwnd,nil,False);
end;

end.
