unit CommonData;

{
 projet ADK-ISO (c)2002-2003 Paul TOTH <tothpaul@free.fr>

 http://www.web-synergy.net/naug-land/

}

interface

uses
  SysUtils, Classes, Forms, ImgList, Controls, IniFiles, StdCtrls, Dialogs,
  ComCtrls,EditMaps,ADKMaps;

type
  TData = class(TDataModule)
    ImageList1: TImageList;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Data: TData;
  Root: String;
  Ini : TIniFile;

procedure SaveCheckBox(ACheckBox:TCheckBox);
procedure LoadCheckBox(ACheckBox:TCheckBox);
procedure SaveDialog(ADialog:TOpenDialog);
procedure LoadDialog(ADialog:TOpenDialog);

resourcestring
 ALLFilter='Tous les fichiers (*.*)|*.*';
 IMLFilter='Bibliothque d''images (*.IML)|*.IML';
 LBAFilter='Bibliothque d''images (*.LBA)|*.LBA';
 MA2Filter='Anciennes carte ADK (*.MA2)|*.MA2';
 ADKFilter='Cartes Isomtriques ADK (*.ADK)|*.ADK';

const
 ObstacleNames:array[TObstacle] of string=(
  '(aucun)', 'Special',
  'Standard', 'Fort', 'Glace', 'Boueux', 'Sable', 'Eau (taille)',
  'Eau (paule)', 'Eau (profonde)',
  'Petit trou', 'Trou moyen', 'Trou noir', 'Ravin',
  'Petit mur', 'Mur moyen', 'Grand mur',
  'Meuble (bas)', 'Meuble (haut)', 'Porte', 'Grille', 'Herse'
 );

implementation

uses ImageTrees;

{$R *.dfm}

procedure SaveCheckBox(ACheckBox:TCheckBox);
begin
 ini.WriteBool(GetParentForm(ACheckBox).Name,ACheckBox.Name,ACheckBox.Checked);
end;

procedure LoadCheckBox(ACheckBox:TCheckBox);
begin
 ACheckBox.Checked:=ini.ReadBool(GetParentForm(ACheckBox).Name,ACheckBox.Name,ACheckBox.Checked);
end;

procedure SaveDialog(ADialog:TOpenDialog);
begin
 ini.WriteString('Dialogs',ADialog.Owner.Name,ADialog.InitialDir);
end;

procedure LoadDialog(ADialog:TOpenDialog);
begin
 ADialog.InitialDir:=ini.ReadString('Dialogs',ADialog.Owner.Name,root);
end;

initialization
 root:=ExtractFilePath(Application.ExeName);
 Ini:=TIniFile.Create(ChangeFileExt(Application.ExeName,'.INI'));
finalization
 Ini.Free;
end.
