unit FlipperProperites;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, CheckLst;

type
  TFlipperOption=(foActive,foTrue,foFalse);

  TFlipper=class
   Option:TFlipperOption;
   Flag  :integer;
   SetOn :integer;
   SetOff:integer;
   Flip  :integer;
   Rect  :TRect;
  end;

  TFlipperProperties = class(TForm)
    clb: TCheckListBox;
    Tabs: TTabControl;
    OK: TButton;
    Annuler: TButton;
    Label2: TLabel;
    cbActive: TComboBox;
    cbFlags: TComboBox;
    Label11: TLabel;
    procedure clbClickCheck(Sender: TObject);
    procedure TabsChange(Sender: TObject);
    procedure cbActiveChange(Sender: TObject);
  private
    { Private declarations }
    fOn,fOff,fFlip:integer;
    procedure Init;
  public
    { Public declarations }
   function Execute:boolean;
   procedure Edit(Flipper:TFlipper);
   procedure SetFlipper(Flipper:TFlipper);
   function GetFlipper:TFlipper;
  end;

var
  FlipperProperties: TFlipperProperties;

implementation

uses IsoMap1;

{$R *.dfm}

procedure TFlipperProperties.Init;
begin
 cbFlags.Items.Assign(MainForm.clbSwitches.Items);
 clb.Items.Assign(cbFlags.Items);
 Tabs.TabIndex:=0;
end;

function TFlipperProperties.Execute:boolean;
begin
 Init;
 cbActive.ItemIndex:=0;
 fOn:=0;
 fOff:=0;
 fFlip:=0;
 Result:=ShowModal=mrOK;
end;

procedure TFlipperProperties.Edit(Flipper:TFlipper);
begin
 Init;
 cbActive.ItemIndex:=ord(Flipper.Option);
 cbFlags.ItemIndex:=MainForm.MapFrame1.EditMap.FlagIndex(Flipper.Flag);
 fOn:=Flipper.SetOn;
 fOff:=Flipper.SetOff;
 fFlip:=Flipper.Flip;
 TabsChange(Self);
 if ShowModal=mrOK then SetFlipper(Flipper);
end;

procedure TFlipperProperties.clbClickCheck(Sender: TObject);
var
 i,m:integer;
 p:^integer;
begin
 i:=clb.ItemIndex;
 if i<0 then exit;
 m:=MainForm.MapFrame1.EditMap.FlagMask(i);
 case Tabs.TabIndex of
  0: p:=@fOn;
  1: p:=@fOff;
  2: p:=@fFlip;
  else exit;
 end;
 if clb.Checked[i] then
  p^:=p^ or m
 else
  p^:=p^ and (not m);
end;

procedure TFlipperProperties.TabsChange(Sender: TObject);
var
 i,m:integer;
 p1:integer;
 p2:integer;
begin
 case Tabs.TabIndex of
  0: begin
   p1:=fOn;
   p2:=fOff or fFlip;
  end;
  1: begin
   p1:=fOff;
   p2:=fOn or fFlip;
  end;
  2: begin
   p1:=fFlip;
   p2:=fOn or fOff;
  end;
  else exit;
 end;
 for i:=0 to clb.Items.Count-1 do begin
  m:=MainForm.MapFrame1.EditMap.FlagMask(i);
  clb.Checked[i]:=(p1 and m)>0;
  clb.ItemEnabled[i]:=(p2 and m)=0;
 end;
 clb.Invalidate;
end;

procedure TFlipperProperties.cbActiveChange(Sender: TObject);
var
 ok:boolean;
begin
 ok:=cbActive.ItemIndex>0;
 cbFlags.Enabled:=ok;
end;

procedure TFlipperProperties.SetFlipper(Flipper:TFlipper);
var
 i:integer;
begin
 Flipper.Option:=TFlipperOption(cbActive.ItemIndex);
 i:=cbFlags.ItemIndex;
 if i<0 then
  Flipper.Flag:=0
 else
  Flipper.Flag:=MainForm.MapFrame1.EditMap.FlagMask(i);
 Flipper.SetOn:=fOn;
 Flipper.SetOff:=fOff;
 Flipper.Flip:=fFlip;
end;

function TFlipperProperties.GetFlipper:TFlipper;
begin
 Result:=TFlipper.Create;
 SetFlipper(Result);
end;

end.
