unit Teleports;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TTeleportOption=(toActive,toTrue,toFalse);
  TTeleportation=class
   Target:string;
   Option:TTeleportOption;
   Flag  :integer;
   Rect  :TRect;
  end;
  TReception=class
   Name:string;
   Rect:TRect;
  end;

  TTeleportProperties = class(TForm)
    Label1: TLabel;
    OK: TButton;
    Annuler: TButton;
    cbTarget: TComboBox;
    Label2: TLabel;
    cbActive: TComboBox;
    cbFlags: TComboBox;
    Label11: TLabel;
    procedure cbActiveChange(Sender: TObject);
  private
    { Private declarations }
    procedure Init;
  public
    { Public declarations }
    function Execute:boolean;
    procedure Edit(Teleportation:TTeleportation);
    procedure SetTeleportation(Teleportation:TTeleportation);
    function GetTeleportation:TTeleportation;
  end;

var
  TeleportProperties: TTeleportProperties;

implementation

uses IsoMap1;

{$R *.dfm}

procedure TTeleportProperties.Init;
begin
 cbTarget.Items.Assign(MainForm.lbReception.Items);
 cbFlags.Items.Clear;
 cbFlags.Items.AddStrings(MainForm.clbSwitches.Items);
end;

function TTeleportProperties.Execute:boolean;
begin
 Init;
 cbTarget.Text:='';
 cbActive.ItemIndex:=0;
 Result:=(ShowModal=mrOk);
end;

procedure TTeleportProperties.Edit(Teleportation:TTeleportation);
begin
 Init;
 cbTarget.Text:=Teleportation.Target;
 cbActive.ItemIndex:=integer(Teleportation.Option);
 cbFlags.ItemIndex:=MainForm.MapFrame1.EditMap.FlagIndex(Teleportation.Flag);
 cbFlags.Enabled:=cbActive.ItemIndex>0;
 if ShowModal=mrOk then begin
  SetTeleportation(Teleportation);
 end;
end;

procedure TTeleportProperties.cbActiveChange(Sender: TObject);
begin
 cbFlags.Enabled:=cbActive.ItemIndex>0;
end;

procedure TTeleportProperties.SetTeleportation(Teleportation:TTeleportation);
var
 i:integer;
begin
 Teleportation.Target:=cbTarget.Text;
 Teleportation.Option:=TTeleportOption(cbActive.ItemIndex);
 i:=cbFlags.ItemIndex;
 if i<0 then
  Teleportation.Flag:=0
 else
  Teleportation.Flag:=MainForm.MapFrame1.EditMap.FlagMask(i);
end;

function TTeleportProperties.GetTeleportation:TTeleportation;
begin
 Result:=TTeleportation.Create;
 SetTeleportation(Result);
end;


end.
