unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ADKServer, ADKClient, ADKSession,
  ADKData,Definitions, ADKWSA;

type
  TForm1 = class(TForm)
    ADKClient1: TADKClient;
    ADKServer1: TADKServer;
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    Label1: TLabel;
    Memo2: TMemo;
    Label2: TLabel;
    Button3: TButton;
    Button4: TButton;
    Edit1: TEdit;
    Button5: TButton;
    ADKDispatchWSA1: TADKDispatchWSA;
    ADKProvideWSA1: TADKProvideWSA;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure DispatchStart(Sender: TObject);
    procedure DispatchStop(Sender: TObject);
    procedure DispatchEnter(Sender: TObject; Session: TADKSession);
    procedure DispatchLeave(Sender: TObject; Session: TADKSession);
    procedure DispatchError(Sender: TObject; Msg: String);
    procedure ADKServer1Logon(Sender: TObject; Session: TADKSession; Name,
      Password: String);
    procedure ADKServer1Logout(Sender: TObject; Session: TADKSession);
    procedure ADKServer1Message(Sender: TObject; Session: TADKSession;
      Msg: String);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure ProvideConnect(Sender: TObject);
    procedure ProvideClose(Sender: TObject);
    procedure ProvideError(Sender: TObject; Msg: String);
    procedure ADKClient1Negociate(Sender: TObject;
      const Value: TNegociate);
    procedure ADKClient1ServerInfo(Sender: TObject;
      const Value: TServerInfo);
    procedure ADKClient1StartGame(Sender: TObject);
    procedure ADKClient1Message(Sender: TObject; Text: String;
      const Attr: TTextAttr);
    procedure ADKClient1LoadMap(Sender: TObject; Map: String);
    procedure ADKClient1Ping(Sender: TObject; Delay: Cardinal);
    procedure ADKClient1PlayerInfo(Sender: TObject;
      const Value: TPersonnage);
    procedure ADKClient1EndGame(Sender: TObject; const Reason: String);
    procedure DispatchRead(Sender: TObject; Session: TADKSession;
      Count: Integer);
    procedure ProvideRead(Sender: TObject; Count: Integer);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
  private
    { Dclarations prives }
    StartTime:TDateTime;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
 StartTime:=Now;
 ADKServer1.Start;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 ADKServer1.Stop;
end;

procedure TForm1.DispatchStart(Sender: TObject);
begin
 memo1.lines.add('Accs server ouvert');
 label1.tag:=0;
end;

procedure TForm1.DispatchStop(Sender: TObject);
begin
 memo1.lines.add('Accs serveur ferm');
end;

procedure TForm1.DispatchEnter(Sender: TObject;
  Session: TADKSession);
begin
 memo1.lines.Add('Nouvelle session '+session.Name);
 Session.Negociate('Serveur',1,False);
 Session.ServerInfo(StartTime,Now,1,10);
end;

procedure TForm1.DispatchLeave(Sender: TObject;
  Session: TADKSession);
begin
 memo1.lines.add('Fin de session '+Session.Name);
end;

procedure TForm1.DispatchError(Sender: TObject; Msg: String);
begin
 memo1.Lines.add(msg);
end;

var
 Tufour:TPlayerInfo=(
  CaractAdd:(
   Name:'Tufour'
  );
 );

procedure TForm1.ADKServer1Logon(Sender: TObject; Session: TADKSession;
  Name, Password: String);
begin
 memo1.lines.add('login de '+Name+' mot de passe = '+Password);
 Session.PlayerInfo(Tufour);
end;

procedure TForm1.ADKServer1Logout(Sender: TObject; Session: TADKSession);
begin
 memo1.lines.Add('Bye '+Session.Name);
end;

procedure TForm1.ADKServer1Message(Sender: TObject; Session: TADKSession;
  Msg: String);
begin
 memo1.lines.Add(msg);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 ADKClient1.Provider.Open;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 ADKClient1.Provider.Close;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 ADKClient1.Ping;
end;

procedure TForm1.ProvideConnect(Sender: TObject);
begin
 memo2.lines.add('client connect au serveur');
 label2.tag:=0;
end;

procedure TForm1.ProvideClose(Sender: TObject);
begin
 memo2.lines.Add('client dconnect par le serveur');
end;

procedure TForm1.ProvideError(Sender: TObject; Msg: String);
begin
 memo2.lines.Add(msg);
end;

procedure TForm1.ADKClient1Negociate(Sender: TObject;
  const Value: TNegociate);
begin
 memo2.lines.Add('ngociation avec '+Value.Server);
end;

procedure TForm1.ADKClient1ServerInfo(Sender: TObject;
  const Value: TServerInfo);
begin
 memo2.lines.Add('Serveur dmarr  '+DateTimeToStr(Value.StartDate));
 ADKClient1.Logon('Tom','cat');
end;

procedure TForm1.ADKClient1StartGame(Sender: TObject);
begin
 memo2.Lines.Add('le jeu a commenc');
end;

procedure TForm1.ADKClient1Message(Sender: TObject; Text: String;
  const Attr: TTextAttr);
begin
 memo2.lines.Add(Text);
end;

procedure TForm1.ADKClient1LoadMap(Sender: TObject; Map: String);
begin
 memo2.Lines.Add('Carte '+Map);
end;

procedure TForm1.ADKClient1Ping(Sender: TObject; Delay: Cardinal);
begin
 memo2.Lines.Add('ping en '+IntToStr(Delay)+'ms');
end;

procedure TForm1.ADKClient1PlayerInfo(Sender: TObject;
  const Value: TPersonnage);
begin
 memo2.Lines.Add('welcome '+Value.CaractAdd.Name);
end;

procedure TForm1.ADKClient1EndGame(Sender: TObject; const Reason: String);
begin
 memo2.lines.Add('fin de la partie');
end;

procedure TForm1.DispatchRead(Sender: TObject; Session: TADKSession;
  Count: Integer);
begin
 label1.Tag:=Label1.tag+count;
 label1.Caption:=IntToStr(Label1.Tag)+' octets reus';
end;

procedure TForm1.ProvideRead(Sender: TObject; Count: Integer);
begin
 label2.Tag:=Label2.tag+count;
 label2.Caption:=IntToStr(Label2.Tag)+' octets reus';
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
 if key=#13 then begin
  ADKClient1.Say(Edit1.Text);
  edit1.text:='';
 end;
end;

end.
