unit DXError;
{$i-}
interface

uses
 Windows,SysUtils,ShellAPI;

type
 EDXError=class(Exception)
 end;

procedure CheckDD(Error:integer; Msg:string);
function DXErrorString(Value: HResult) : string;

const
  DDERR_ALREADYINITIALIZED                = HResult($88760000 + 5);
  DDERR_CANNOTATTACHSURFACE               = HResult($88760000 + 10);
  DDERR_CANNOTDETACHSURFACE               = HResult($88760000 + 20);
  DDERR_CURRENTLYNOTAVAIL                 = HResult($88760000 + 40);
  DDERR_EXCEPTION                         = HResult($88760000 + 55);
  DDERR_GENERIC                           = HResult(E_FAIL);
  DDERR_HEIGHTALIGN                       = HResult($88760000 + 90);
  DDERR_INCOMPATIBLEPRIMARY               = HResult($88760000 + 95);
  DDERR_INVALIDCAPS                       = HResult($88760000 + 100);
  DDERR_INVALIDCLIPLIST                   = HResult($88760000 + 110);
  DDERR_INVALIDMODE                       = HResult($88760000 + 120);
  DDERR_INVALIDOBJECT                     = HResult($88760000 + 130);
  DDERR_INVALIDPARAMS                     = HResult(E_INVALIDARG);
  DDERR_INVALIDPIXELFORMAT                = HResult($88760000 + 145);
  DDERR_INVALIDRECT                       = HResult($88760000 + 150);
  DDERR_LOCKEDSURFACES                    = HResult($88760000 + 160);
  DDERR_NO3D                              = HResult($88760000 + 170);
  DDERR_NOALPHAHW                         = HResult($88760000 + 180);
  DDERR_NOSTEREOHARDWARE                  = HResult($88760000 + 181);
  DDERR_NOSURFACELEFT                     = HResult($88760000 + 182);
  DDERR_NOCLIPLIST                        = HResult($88760000 + 205);
  DDERR_NOCOLORCONVHW                     = HResult($88760000 + 210);
  DDERR_NOCOOPERATIVELEVELSET             = HResult($88760000 + 212);
  DDERR_NOCOLORKEY                        = HResult($88760000 + 215);
  DDERR_NOCOLORKEYHW                      = HResult($88760000 + 220);
  DDERR_NODIRECTDRAWSUPPORT               = HResult($88760000 + 222);
  DDERR_NOEXCLUSIVEMODE                   = HResult($88760000 + 225);
  DDERR_NOFLIPHW                          = HResult($88760000 + 230);
  DDERR_NOGDI                             = HResult($88760000 + 240);
  DDERR_NOMIRRORHW                        = HResult($88760000 + 250);
  DDERR_NOTFOUND                          = HResult($88760000 + 255);
  DDERR_NOOVERLAYHW                       = HResult($88760000 + 260);
  DDERR_OVERLAPPINGRECTS                  = HResult($88760000 + 270);
  DDERR_NORASTEROPHW                      = HResult($88760000 + 280);
  DDERR_NOROTATIONHW                      = HResult($88760000 + 290);
  DDERR_NOSTRETCHHW                       = HResult($88760000 + 310);
  DDERR_NOT4BITCOLOR                      = HResult($88760000 + 316);
  DDERR_NOT4BITCOLORINDEX                 = HResult($88760000 + 317);
  DDERR_NOT8BITCOLOR                      = HResult($88760000 + 320);
  DDERR_NOTEXTUREHW                       = HResult($88760000 + 330);
  DDERR_NOVSYNCHW                         = HResult($88760000 + 335);
  DDERR_NOZBUFFERHW                       = HResult($88760000 + 340);
  DDERR_NOZOVERLAYHW                      = HResult($88760000 + 350);
  DDERR_OUTOFCAPS                         = HResult($88760000 + 360);
  DDERR_OUTOFMEMORY                       = HResult(E_OUTOFMEMORY);
  DDERR_OUTOFVIDEOMEMORY                  = HResult($88760000 + 380);
  DDERR_OVERLAYCANTCLIP                   = HResult($88760000 + 382);
  DDERR_OVERLAYCOLORKEYONLYONEACTIVE      = HResult($88760000 + 384);
  DDERR_PALETTEBUSY                       = HResult($88760000 + 387);
  DDERR_COLORKEYNOTSET                    = HResult($88760000 + 400);
  DDERR_SURFACEALREADYATTACHED            = HResult($88760000 + 410);
  DDERR_SURFACEALREADYDEPENDENT           = HResult($88760000 + 420);
  DDERR_SURFACEBUSY                       = HResult($88760000 + 430);
  DDERR_CANTLOCKSURFACE                   = HResult($88760000 + 435);
  DDERR_SURFACEISOBSCURED                 = HResult($88760000 + 440);
  DDERR_SURFACELOST                       = HResult($88760000 + 450);
  DDERR_SURFACENOTATTACHED                = HResult($88760000 + 460);
  DDERR_TOOBIGHEIGHT                      = HResult($88760000 + 470);
  DDERR_TOOBIGSIZE                        = HResult($88760000 + 480);
  DDERR_TOOBIGWIDTH                       = HResult($88760000 + 490);
  DDERR_UNSUPPORTED                       = HResult(E_NOTIMPL);
  DDERR_UNSUPPORTEDFORMAT                 = HResult($88760000 + 510);
  DDERR_UNSUPPORTEDMASK                   = HResult($88760000 + 520);
  DDERR_INVALIDSTREAM                     = HResult($88760000 + 521);
  DDERR_VERTICALBLANKINPROGRESS           = HResult($88760000 + 537);
  DDERR_WASSTILLDRAWING                   = HResult($88760000 + 540);
  DDERR_DDSCAPSCOMPLEXREQUIRED            = HResult($88760000 + 542);
  DDERR_XALIGN                            = HResult($88760000 + 560);
  DDERR_INVALIDDIRECTDRAWGUID             = HResult($88760000 + 561);
  DDERR_DIRECTDRAWALREADYCREATED          = HResult($88760000 + 562);
  DDERR_NODIRECTDRAWHW                    = HResult($88760000 + 563);
  DDERR_PRIMARYSURFACEALREADYEXISTS       = HResult($88760000 + 564);
  DDERR_NOEMULATION                       = HResult($88760000 + 565);
  DDERR_REGIONTOOSMALL                    = HResult($88760000 + 566);
  DDERR_CLIPPERISUSINGHWND                = HResult($88760000 + 567);
  DDERR_NOCLIPPERATTACHED                 = HResult($88760000 + 568);
  DDERR_NOHWND                            = HResult($88760000 + 569);
  DDERR_HWNDSUBCLASSED                    = HResult($88760000 + 570);
  DDERR_HWNDALREADYSET                    = HResult($88760000 + 571);
  DDERR_NOPALETTEATTACHED                 = HResult($88760000 + 572);
  DDERR_NOPALETTEHW                       = HResult($88760000 + 573);
  DDERR_BLTFASTCANTCLIP                   = HResult($88760000 + 574);
  DDERR_NOBLTHW                           = HResult($88760000 + 575);
  DDERR_NODDROPSHW                        = HResult($88760000 + 576);
  DDERR_OVERLAYNOTVISIBLE                 = HResult($88760000 + 577);
  DDERR_NOOVERLAYDEST                     = HResult($88760000 + 578);
  DDERR_INVALIDPOSITION                   = HResult($88760000 + 579);
  DDERR_NOTAOVERLAYSURFACE                = HResult($88760000 + 580);
  DDERR_EXCLUSIVEMODEALREADYSET           = HResult($88760000 + 581);
  DDERR_NOTFLIPPABLE                      = HResult($88760000 + 582);
  DDERR_CANTDUPLICATE                     = HResult($88760000 + 583);
  DDERR_NOTLOCKED                         = HResult($88760000 + 584);
  DDERR_CANTCREATEDC                      = HResult($88760000 + 585);
  DDERR_NODC                              = HResult($88760000 + 586);
  DDERR_WRONGMODE                         = HResult($88760000 + 587);
  DDERR_IMPLICITLYCREATED                 = HResult($88760000 + 588);
  DDERR_NOTPALETTIZED                     = HResult($88760000 + 589);
  DDERR_UNSUPPORTEDMODE                   = HResult($88760000 + 590);
  DDERR_NOMIPMAPHW                        = HResult($88760000 + 591);
  DDERR_INVALIDSURFACETYPE                = HResult($88760000 + 592);
  DDERR_NOOPTIMIZEHW                      = HResult($88760000 + 600);
  DDERR_NOTLOADED                         = HResult($88760000 + 601);
  DDERR_NOFOCUSWINDOW                     = HResult($88760000 + 602);
  DDERR_NOTONMIPMAPSUBLEVEL               = HResult($88760000 + 603);
  DDERR_DCALREADYCREATED                  = HResult($88760000 + 620);
  DDERR_NONONLOCALVIDMEM                  = HResult($88760000 + 630);
  DDERR_CANTPAGELOCK                      = HResult($88760000 + 640);
  DDERR_CANTPAGEUNLOCK                    = HResult($88760000 + 660);
  DDERR_NOTPAGELOCKED                     = HResult($88760000 + 680);
  DDERR_MOREDATA                          = HResult($88760000 + 690);
  DDERR_EXPIRED                           = HResult($88760000 + 691);
  DDERR_TESTFINISHED                      = HResult($88760000 + 692);
  DDERR_NEWMODE                           = HResult($88760000 + 693);
  DDERR_D3DNOTINITIALIZED                 = HResult($88760000 + 694);
  DDERR_VIDEONOTACTIVE                    = HResult($88760000 + 695);
  DDERR_NOMONITORINFORMATION              = HResult($88760000 + 696);
  DDERR_NODRIVERSUPPORT                   = HResult($88760000 + 697);
  DDERR_DEVICEDOESNTOWNSURFACE            = HResult($88760000 + 699);
  DDERR_NOTINITIALIZED                    = HResult(CO_E_NOTINITIALIZED);

implementation

//------------------------------------------------------//
// function gnrique testant la valeur retourne par DirectDraw
procedure CheckDD(Error:integer; Msg:string);
var
 s:string;
 f:textfile;
begin
 if Error=0 then exit;
 s:=ExtractFilePath(ParamStr(0))+'DXError.log';
 msg:=msg+' ('+DXErrorString(Error)+')';
 assignfile(f,s);
 append(f);
 if ioresult<>0 then begin
  rewrite(f);
  writeln(f,'Rapport d''erreur DirectDraw (vous pouvez supprimer ce fichier)');
  writeln(f,'---------------------------------------------------------------');
 end;
 writeln(f,FormatDateTime('dd/mm/yy hh:nn ',now),msg);
 closefile(f);
 ShellExecute(0,'open',pchar(s),nil,nil,SW_SHOW);
 halt;// raise EDXError.Create(msg);
end;

function DXErrorString(Value: HResult) : string;
begin
  case Value of
    0: Result := 'The request completed successfully.';
    DDERR_ALREADYINITIALIZED: Result := 'This object is already initialized.';
    DDERR_BLTFASTCANTCLIP: Result := ' if a clipper object is attached to the source surface passed into a BltFast call.';
    DDERR_CANNOTATTACHSURFACE: Result := 'This surface can not be attached to the requested surface.';
    DDERR_CANNOTDETACHSURFACE: Result := 'This surface can not be detached from the requested surface.';
    DDERR_CANTCREATEDC: Result := 'Windows can not create any more DCs.';
    DDERR_CANTDUPLICATE: Result := 'Cannot duplicate primary & 3D surfaces, or surfaces that are implicitly created.';
    DDERR_CLIPPERISUSINGHWND: Result := 'An attempt was made to set a cliplist for a clipper object that is already monitoring an hwnd.';
    DDERR_COLORKEYNOTSET: Result := 'No src color key specified for this operation.';
    DDERR_CURRENTLYNOTAVAIL: Result := 'Support is currently not available.';
    DDERR_DIRECTDRAWALREADYCREATED: Result := 'A DirectDraw object representing this driver has already been created for this process.';
    DDERR_EXCEPTION: Result := 'An exception was encountered while performing the requested operation.';
    DDERR_EXCLUSIVEMODEALREADYSET: Result := 'An attempt was made to set the cooperative level when it was already set to exclusive.';
    DDERR_GENERIC: Result := 'Generic failure.';
    DDERR_HEIGHTALIGN: Result := 'Height of rectangle provided is not a multiple of reqd alignment.';
    DDERR_HWNDALREADYSET: Result := 'The CooperativeLevel HWND has already been set. It can not be reset while the process has surfaces or palettes created.';
    DDERR_HWNDSUBCLASSED: Result := 'HWND used by DirectDraw CooperativeLevel has been subclassed, this prevents DirectDraw from restoring state.';
    DDERR_IMPLICITLYCREATED: Result := 'This surface can not be restored because it is an implicitly created surface.';
    DDERR_INCOMPATIBLEPRIMARY: Result := 'Unable to match primary surface creation request with existing primary surface.';
    DDERR_INVALIDCAPS: Result := 'One or more of the caps bits passed to the callback are incorrect.';
    DDERR_INVALIDCLIPLIST: Result := 'DirectDraw does not support the provided cliplist.';
    DDERR_INVALIDDIRECTDRAWGUID: Result := 'The GUID passed to DirectDrawCreate is not a valid DirectDraw driver identifier.';
    DDERR_INVALIDMODE: Result := 'DirectDraw does not support the requested mode.';
    DDERR_INVALIDOBJECT: Result := 'DirectDraw received a pointer that was an invalid DIRECTDRAW object.';
    DDERR_INVALIDPARAMS: Result := 'One or more of the parameters passed to the function are incorrect.';
    DDERR_INVALIDPIXELFORMAT: Result := 'The pixel format was invalid as specified.';
    DDERR_INVALIDPOSITION: Result := 'Returned when the position of the overlay on the destination is no longer legal for that destination.';
    DDERR_INVALIDRECT: Result := 'Rectangle provided was invalid.';
    DDERR_LOCKEDSURFACES: Result := 'Operation could not be carried out because one or more surfaces are locked.';
    DDERR_NO3D: Result := 'There is no 3D present.';
    DDERR_NOALPHAHW: Result := 'Operation could not be carried out because there is no alpha accleration hardware present or available.';
    DDERR_NOBLTHW: Result := 'No blitter hardware present.';
    DDERR_NOCLIPLIST: Result := 'No cliplist available.';
    DDERR_NOCLIPPERATTACHED: Result := 'No clipper object attached to surface object.';
    DDERR_NOCOLORCONVHW: Result := 'Operation could not be carried out because there is no color conversion hardware present or available.';
    DDERR_NOCOLORKEY: Result := 'Surface does not currently have a color key';
    DDERR_NOCOLORKEYHW: Result := 'Operation could not be carried out because there is no hardware support of the destination color key.';
    DDERR_NOCOOPERATIVELEVELSET: Result := 'Create function called without DirectDraw object method SetCooperativeLevel being called.';
    DDERR_NODC: Result := 'No DC was ever created for this surface.';
    DDERR_NODDROPSHW: Result := 'No DirectDraw ROP hardware.';
    DDERR_NODIRECTDRAWHW: Result := 'A hardware-only DirectDraw object creation was attempted but the driver did not support any hardware.';
    DDERR_NOEMULATION: Result := 'Software emulation not available.';
    DDERR_NOEXCLUSIVEMODE: Result := 'Operation requires the application to have exclusive mode but the application does not have exclusive mode.';
    DDERR_NOFLIPHW: Result := 'Flipping visible surfaces is not supported.';
    DDERR_NOGDI: Result := 'There is no GDI present.';
    DDERR_NOHWND: Result := 'Clipper notification requires an HWND or no HWND has previously been set as the CooperativeLevel HWND.';
    DDERR_NOMIRRORHW: Result := 'Operation could not be carried out because there is no hardware present or available.';
    DDERR_NOOVERLAYDEST: Result := 'Returned when GetOverlayPosition is called on an overlay that UpdateOverlay has never been called on to establish a destination.';
    DDERR_NOOVERLAYHW: Result := 'Operation could not be carried out because there is no overlay hardware present or available.';
    DDERR_NOPALETTEATTACHED: Result := 'No palette object attached to this surface.';
    DDERR_NOPALETTEHW: Result := 'No hardware support for 16 or 256 color palettes.';
    DDERR_NORASTEROPHW: Result := 'Operation could not be carried out because there is no appropriate raster op hardware present or available.';
    DDERR_NOROTATIONHW: Result := 'Operation could not be carried out because there is no rotation hardware present or available.';
    DDERR_NOSTRETCHHW: Result := 'Operation could not be carried out because there is no hardware support for stretching.';
    DDERR_NOT4BITCOLOR: Result := 'DirectDrawSurface is not in 4 bit color palette and the requested operation requires 4 bit color palette.';
    DDERR_NOT4BITCOLORINDEX: Result := 'DirectDrawSurface is not in 4 bit color index palette and the requested operation requires 4 bit color index palette.';
    DDERR_NOT8BITCOLOR: Result := 'DirectDrawSurface is not in 8 bit color mode and the requested operation requires 8 bit color.';
    DDERR_NOTAOVERLAYSURFACE: Result := 'Returned when an overlay member is called for a non-overlay surface.';
    DDERR_NOTEXTUREHW: Result := 'Operation could not be carried out because there is no texture mapping hardware present or available.';
    DDERR_NOTFLIPPABLE: Result := 'An attempt has been made to flip a surface that is not flippable.';
    DDERR_NOTFOUND: Result := 'Requested item was not found.';
    DDERR_NOTLOCKED: Result := 'Surface was not locked.  An attempt to unlock a surface that was not locked at all, or by this process, has been attempted.';
    DDERR_NOTPALETTIZED: Result := 'The surface being used is not a palette-based surface.';
    DDERR_NOVSYNCHW: Result := 'Operation could not be carried out because there is no hardware support for vertical blank synchronized operations.';
    DDERR_NOZBUFFERHW: Result := 'Operation could not be carried out because there is no hardware support for zbuffer blitting.';
    DDERR_NOZOVERLAYHW: Result := 'Overlay surfaces could not be z layered based on their BltOrder because the hardware does not support z layering of overlays.';
    DDERR_OUTOFCAPS: Result := 'The hardware needed for the requested operation has already been allocated.';
    DDERR_OUTOFMEMORY: Result := 'DirectDraw does not have enough memory to perform the operation.';
    DDERR_OUTOFVIDEOMEMORY: Result := 'DirectDraw does not have enough memory to perform the operation.';
    DDERR_OVERLAYCANTCLIP: Result := 'The hardware does not support clipped overlays.';
    DDERR_OVERLAYCOLORKEYONLYONEACTIVE: Result := 'Can only have ony color key active at one time for overlays.';
    DDERR_OVERLAYNOTVISIBLE: Result := 'Returned when GetOverlayPosition is called on a hidden overlay.';
    DDERR_PALETTEBUSY: Result := 'Access to this palette is being refused because the palette is already locked by another thread.';
    DDERR_PRIMARYSURFACEALREADYEXISTS: Result := 'This process already has created a primary surface.';
    DDERR_REGIONTOOSMALL: Result := 'Region passed to Clipper::GetClipList is too small.';
    DDERR_SURFACEALREADYATTACHED: Result := 'This surface is already attached to the surface it is being attached to.';
    DDERR_SURFACEALREADYDEPENDENT: Result := 'This surface is already a dependency of the surface it is being made a dependency of.';
    DDERR_SURFACEBUSY: Result := 'Access to this surface is being refused because the surface is already locked by another thread.';
    DDERR_SURFACEISOBSCURED: Result := 'Access to surface refused because the surface is obscured.';
    DDERR_SURFACELOST: Result := 'Access to this surface is being refused because the surface memory is gone. The DirectDrawSurface object representing this surface should have Restore called on it.';
    DDERR_SURFACENOTATTACHED: Result := 'The requested surface is not attached.';
    DDERR_TOOBIGHEIGHT: Result := 'Height requested by DirectDraw is too large.';
    DDERR_TOOBIGSIZE: Result := 'Size requested by DirectDraw is too large, but the individual height and width are OK.';
    DDERR_TOOBIGWIDTH: Result := 'Width requested by DirectDraw is too large.';
    DDERR_UNSUPPORTED: Result := 'Action not supported.';
    DDERR_UNSUPPORTEDFORMAT: Result := 'FOURCC format requested is unsupported by DirectDraw.';
    DDERR_UNSUPPORTEDMASK: Result := 'Bitmask in the pixel format requested is unsupported by DirectDraw.';
    DDERR_VERTICALBLANKINPROGRESS: Result := 'Vertical blank is in progress.';
    DDERR_WASSTILLDRAWING: Result := 'Informs DirectDraw that the previous Blt which is transfering information to or from this Surface is incomplete.';
    DDERR_WRONGMODE: Result := 'This surface can not be restored because it was created in a different mode.';
    DDERR_XALIGN: Result := 'Rectangle provided was not horizontally aligned on required boundary.';
    // new:
    DDERR_OVERLAPPINGRECTS: Result := 'Operation could not be carried out because the source and destination rectangles are on the same surface and overlap each other.';
    DDERR_INVALIDSTREAM: Result := 'The specified stream contains invalid data';
    DDERR_UNSUPPORTEDMODE: Result := 'The display is currently in an unsupported mode';
    DDERR_NOMIPMAPHW: Result := 'Operation could not be carried out because there is no mip-map texture mapping hardware present or available.';
    DDERR_INVALIDSURFACETYPE: Result := 'The requested action could not be performed because the surface was of the wrong type.';
    DDERR_NOOPTIMIZEHW: Result := 'Device does not support optimized surfaces, therefore no video memory optimized surfaces';
    DDERR_NOTLOADED: Result := 'Surface is an optimized surface, but has not yet been allocated any memory';
    DDERR_NOFOCUSWINDOW: Result := 'Attempt was made to create or set a device window without first setting the focus window';
    DDERR_DCALREADYCREATED: Result := 'A DC has already been returned for this surface. Only one DC can be retrieved per surface.';
    DDERR_NONONLOCALVIDMEM: Result := 'An attempt was made to allocate non-local video memory from a device that does not support non-local video memory.';
    DDERR_CANTPAGELOCK: Result := 'The attempt to page lock a surface failed.';
    DDERR_CANTPAGEUNLOCK: Result := 'The attempt to page unlock a surface failed.';
    DDERR_NOTPAGELOCKED: Result := 'An attempt was made to page unlock a surface with no outstanding page locks.';
    DDERR_MOREDATA: Result := 'There is more data available than the specified buffer size could hold';
    DDERR_EXPIRED: Result := 'The data has expired and is therefore no longer valid.';
    DDERR_VIDEONOTACTIVE: Result := 'The video port is not active';
    DDERR_DEVICEDOESNTOWNSURFACE: Result := 'Surfaces created by one direct draw device cannot be used directly by another direct draw device.';
    DDERR_NOTINITIALIZED: Result := 'An attempt was made to invoke an interface member of a DirectDraw object created by CoCreateInstance() before it was initialized.';
    else Result := 'Unrecognized Error';
  end;
end;

initialization
 if FileExists('dxerror.log') then begin
  ShellExecute(0,'open','dxerror.log',nil,nil,SW_SHOW);
//  halt;
 end;
end.
