unit ADKData;
{
 projet ADK-ISO (c)2002-2003 Paul TOTH <tothpaul@free.fr>

 http://www.web-synergy.net/naug-land/

}

interface

uses
 Windows,Classes,
 ADKObjects, ADKMaps,ADKImages,ADKSprites,ADKWalkers;

var
 Map:TADKWalkableMap;                 // carte en cours
 ImageLib:TADKImageLib;               // bibliothque d'images
 ObjectList:TList; // liste des objets
 WalkerList:TList;                    // liste des sprites ordonns (en Y)
 Focus:TWalker;                       // le sprite ayant le focus (le joueur)
 Alpha:boolean=true;                  // activer l'alphablending sur le joueur
 DayLight:integer;

procedure InitData;
procedure FreeData;
function LoadSkin(Name:string):TADKSprite;

implementation

var
 Skins:TStringList;

function LoadSkin(Name:string):TADKSprite;
var
 i:integer;
begin
 i:=Skins.IndexOf(Name);
 if i<0 then i:=Skins.AddObject('Name',TADKSprite.Create(Name));
 Result:=TADKSprite(Skins.Objects[i]);
end;

procedure InitData;
begin
 Skins:=TStringList.Create;

 ImageLib:=TADKImageLib.Create;
 Map:=TADKWalkableMap.Create;

end;

procedure FreeData;
var
 i:integer;
begin
 ImageLib.Free;
 Map.Free;
// for i:=WalkerList.Count-1 downto 0 do TWalker(WalkerList[i]).Free;
 WalkerList.Clear;
 ObjectList.Clear;
 for i:=0 to Skins.Count-1 do TADKSprite(Skins.Objects[i]).Free;
 Skins.Free;
end;

initialization
 ObjectList:=TList.create;
 WalkerList:=TList.Create;
finalization
 ObjectList.Free;
 WalkerList.Free;
end.
