unit ADKRender;

{
 projet ADK-ISO (c)2002-2003 Paul TOTH <tothpaul@free.fr>

 http://www.web-synergy.net/naug-land/

}

interface

uses
 Windows,Classes,SysUtils,Math,
 ADKObjects,
 ADKMaps,ADKImages,ADKSprites,ADKWalkers,ADKParticules,
 ADKDepth,ADKData,ADKScreens;

procedure RenderMap;
procedure Idle(ms:cardinal);

var
// DIB  :pchar;   // pointeur sur la mmoire video (coin suprieur gauche)
// Pitch:integer; // nombre de pixels sur un ligne (visibles ou pas - souvent un multiple de 2)

 ScrollX:integer; // dfilement de l'ensemble des lments graphiques
 ScrollY:integer;

 DrawCount:integer;     // compteur d'affiche d'images
 FrameCount:cardinal;   // compteur de frames
 FrameTicks:cardinal;   // ticks du dernier calcul
 FramesPerSec:cardinal; // valeur de FrameCount mise  jour toutes les secondes

 ImageFlip:integer;
 ImageText:string;
 ImageRequest:boolean;

var
 ClientRect:TRect;
 DrawX:integer;
 DrawY:integer;
 DrawRect:TRect;
 DrawSize:TPoint;

// calcule DrawRect d'aprs ClientRect, DrawX, DrawY et DrawSize
function ClipRect:boolean;
// inverse DrawRect pour les images en mirroring horizontal
procedure SwapRect;

implementation

uses MiniDX;

function ClipRect:boolean;
begin
 Result:=False;
 if DrawX>=ClientRect.Left then
  DrawRect.Left:=0
 else begin
  Result:=True;
  DrawRect.Left:=ClientRect.Left-DrawX;
 end;
 if DrawY>=ClientRect.Top then
  DrawRect.Top:=0
 else begin
  Result:=True;
  DrawRect.Top:=ClientRect.Top-DrawY;
 end;
 if DrawX+DrawSize.X<ClientRect.Right then
  DrawRect.Right:=DrawSize.X
 else begin
  Result:=True;
  DrawRect.Right:=ClientRect.Right-DrawX;
 end;
 if DrawY+DrawSize.Y<ClientRect.Bottom then
  DrawRect.Bottom:=DrawSize.Y
 else begin
  Result:=True;
  DrawRect.Bottom:=ClientRect.Bottom-DrawY;
 end;
end;

procedure SwapRect;
var
 Left:integer;
begin
 Left:=DrawRect.Left;
 DrawRect.Left:=DrawSize.X-DrawRect.Right;
 DrawRect.Right:=DrawSize.X-Left;
end;

procedure FlipRect;
var
 Top:integer;
begin
 Top:=DrawRect.Top;
 DrawRect.Top:=DrawSize.Y-DrawRect.Bottom;
 DrawRect.Bottom:=DrawSize.Y-Top;
end;

// afficher une image en tenant compte du clipping
var
 ObjectID  :integer;
 ObjectText:integer;

procedure Draw(Image:integer; Flags:TImageFlags);
var
 step:integer;
 ptch:integer;
 x,y:integer;
begin
 ptch:=ADKScreen.Pitch;
 if ((ifTextPanel in Flags)or(ifAutoFlip in Flags))
 and(DrawX<MousePos.X)and(DrawY<MousePos.Y)
 and(DrawX+DrawSize.X>MousePos.X)
 and(DrawY+DrawSize.Y>MousePos.Y) then begin
  if ifAutoFlip in Flags then ImageFlip:=ObjectID else ImageFlip:=-1;
  if ifTextPanel in Flags then begin
   ObjectText:=ObjectID;
   ImageRequest:=ifRequestText in Flags;
  end else begin
   ObjectText:=-1;
  end;
 end;
 x:=DrawX; // pour la lumire
 y:=DrawY;
 if ClipRect then begin
  if ifSwap in Flags then begin
   step:=-1;
   inc(DrawX,DrawSize.X-1);
   SwapRect;
  end else begin
   step:=+1;
  end;
  if ifFlip in Flags then begin
   ptch:=-ptch;
   inc(DrawY,DrawSize.Y-1);
   FlipRect;
  end;
  ImageLib.DrawRect(Image,ADKScreen.Pixels[DrawX,DrawY],ptch,step,DrawRect);
  inc(drawCount);
 end else begin
  if ifSwap in Flags then begin
   step:=-1;
   inc(DrawX,DrawSize.X-1);
  end else begin
   step:=+1;
  end;
  if ifFlip in Flags then begin
   ptch:=-ptch;
   inc(DrawY,DrawSize.Y-1);
  end;
  ImageLib.Draw(Image,ADKScreen.Pixels[DrawX,DrawY],ptch,step);
  inc(drawCount);
 end;
 if (ifLightSource in Flags)and(ADKScreen is TADKScreen3D) then begin
  with Map.Light(ObjectID)^ do
   TADKScreen3D(ADKScreen).Circle(x+Position.X,y+Position.Y,Radius,Color);
 end;
end;

procedure DrawArray(var Tab:TArrayData106; var Image:TImageData106);
var
 ox,oy:integer;
 ix,iy:integer;
 ax,ay:integer;
begin
 ox:=Image.Position.X+ScrollX-Map.Origin.X;
 oy:=Image.Position.Y+ScrollY-Map.Origin.Y;
 DrawSize:=ImageLib.Size[Image.Index];
 for ay:=0 to Tab.Height-1 do begin
  ix:=ox;
  iy:=oy;
  for ax:=0 to Tab.Width-1 do begin
   if ix>=ClientRect.Right  then break;
   if iy>=ClientRect.Bottom then break;
   if ((ix+DrawSize.X)>=ClientRect.Left)and((iy+DrawSize.Y)>=ClientRect.Top) then begin
    DrawX:=ix;
    DrawY:=iy;
    Draw(Image.Index,Image.Flags);
   end;
   inc(ix,Tab.Step.X);
   inc(iy,Tab.Step.Y);
  end;
  dec(ox,Tab.Step.X);
  inc(oy,Tab.Step.Y);
  if oy>ClientRect.Bottom then exit;
 end;
end;

// afficher une image, elle peut tre un tableau
procedure DrawImage(var Image:TImageData106);
begin
 try
  if ifNotFlag in Image.Flags then begin
   if (Image.Hidden and Map.Flags)<>0 then exit;
  end else begin
   if (Image.Hidden and (not Map.Flags))<>0 then exit;
  end;
  if ifArray in Image.Flags then begin
   DrawArray(Map.Arrays[Image.Data],Image);
  end else begin
   DrawX:=Image.Position.X+ScrollX-Map.Origin.X;
   if DrawX>=ClientRect.Right then exit;
   DrawY:=Image.Position.Y+ScrollY-Map.Origin.Y;
   if DrawY>=ClientRect.Bottom then exit;
   DrawSize:=ImageLib.Size[Image.Index];
   if DrawX+DrawSize.X<ClientRect.Left then exit;
   if DrawY+DrawSize.Y<ClientRect.Top then exit;
   Draw(Image.Index,Image.Flags);
  end;
 finally
  inc(ObjectID);
 end;
end;

// DrawImage2 affiche une image en intercallant au besoin les sprites
var
 TopObject:integer;

procedure DrawImage2(var Image:TImageData106);
var
 obj:TADKObject;
   i:integer;
begin
// afficher tous les sprites qui sont derrire l'image
 for i:=TopObject to ObjectList.count-1 do begin
  obj:=TADKObject(ObjectList[i]);
  if Map.Origin.y+obj.BaseLine>Image.Position.Y+Image.BaseLine then break; // le sprite est devant l'image
  inc(TopObject);
  obj.Draw;
 end;
 DrawImage(Image);
end;

// affichage de l'cran de jeu

function SortObjects(s1,s2:pointer):integer;
begin
 result:=TADKObject(s1).BaseLine-TADKObject(s2).BaseLine;
 if result=0 then Result:=integer(s1)-integer(s2); // vite le clignotement entre 2 sprites ayant la mme BaseLine
end;

procedure DrawPos(Pos:TPoint;color:integer);
var
 p:TPoint;
 i,j:integer;
begin
 p:=GridToScreen(Pos);
 inc(p.x,ScrollX);
 inc(p.y,ScrollY);
 for i:=0 to 4 do begin
  j:=i div 2;
  ADKScreen.PutPixel(p.x+i,p.y+j,color);
  ADKScreen.PutPixel(p.x-i,p.y+j,color);
  ADKScreen.PutPixel(p.x+i,p.y+48-j,color);
  ADKScreen.PutPixel(p.x-i,p.y+48-j,color);
  ADKScreen.PutPixel(p.x-48+i,p.y+24-j,color);
  ADKScreen.PutPixel(p.x-48+i,p.y+24+j,color);
  ADKScreen.PutPixel(p.x+48-i,p.y+24-j,color);
  ADKScreen.PutPixel(p.x+48-i,p.y+24+j,color);
 end;
end;

const
 kx=48;
 ky=24;
var
 dc:HDC;
procedure Quad(x,y:integer);
begin
 MoveToEx(dc,x   ,y-ky,nil);
 LineTo(dc,x+kx,y   );
 LineTo(dc,x   ,y+ky);
 LineTo(dc,x-kx,y   );
 LineTo(dc,x   ,y-ky);
end;

procedure Quads(x,y,dy:integer);
var
 i:integer;
begin
 if y+2*ky<0 then exit;
 if y>ADKScreen.Height then exit;
 Quads(x,y+dy,dy);
 i:=x; while x+2*kx>0 do begin Quad(x,y); dec(x,2*kx); end;
 x:=i; while x<ADKSCreen.Width do begin Quad(x,y); inc(x,2*kx); end;
end;

var
 cs128:array[0..255] of integer;

procedure InitMath;
var
 i:integer;
begin
 for i:=0 to 255 do begin
  cs128[i]:=$70303000+128-32+Round(64*cos(i*PI/128));
 end;
end;

procedure WaterEffect;
const
 k=64;
 ky=12;
 kk=24;
 kx=48 div kk;
var
 water:array[0..3] of TD3DTLVertex;
 mx,my:integer;
 wx,wy:integer;
 x,y,z:integer;

 procedure color(var v:TD3DTLVertex; x,y:integer);
 begin
  v.sx:=x+ScrollX;
  v.sy:=y+ScrollY;
  v.color:=cs128[(x*y+z) and 255];
 end;

begin
 fillchar(water,sizeof(water),0);
 water[0].rhw:=1;
 water[1].rhw:=1;
 water[2].rhw:=1;
 water[3].rhw:=1;
 z:=(GetTickCount div 10) mod 255;
 for my:=0 to 4 do
 for mx:=0 to 10 do begin
  wx:= 40+48*mx+48*my+220;
  wy:=150-24*mx+24*my+556;
  for x:=0 to kx-1 do begin
   for y:=0 to kx-1 do begin
    color(water[0],wx+(x-y)*kk  ,wy+(x+y)*ky  );
    color(water[1],wx+(x-y+1)*kk,wy+(x+y+1)*ky);
    color(water[2],wx+(x-y-1)*kk,wy+(x+y+1)*ky);
    color(water[3],wx+(x-y)*kk  ,wy+(x+y+2)*ky);
    TADKScreen3D(ADKScreen).DrawPoly(water);
   end;
  end;
 end;
end;

procedure RenderMap;
var
 i:integer;
// Text:integer;
begin
// Text:=-1;
 ObjectText:=-1;
 if ADKScreen.Lock then begin
  try
   // afficher un texte
   ImageFlip:=-1;
   // compteur de tuiles
   drawCount:=0;
   ObjectID:=0;
   // images de fond
   for i:=0 to Map.ImageCount-1 do
    DrawImage(Map.Images[i]){ then begin
     with Map.Images[i] do begin
      if ifAutoFlip in Flags then ImageFlip:=Hidden else ImageFlip:=-1;
      if ifTextPanel in Flags then begin
       Text:=i;
       ImageRequest:=ifRequestText in Flags;
      end else begin
       Text:=-1;
      end;
     end;
    end};
   // position de la souris
   //DrawPos(Focus.Finder.Target,$ff0000);
   DrawPos(Focus.ScreenToCell(MousePos.x,MousePos.y),$ffffff);
  finally
   ADKScreen.UnLock;
  end;
 end;

// if ADKScreen is TADKScreen3D then WaterEffect;

 if ADKScreen.Lock then begin
  try
   // images en avant plan (et sprites si ncessaire)
   ObjectList.Sort(SortObjects);
   TopObject:=0;
   ObjectID:=Map.ImageCount;
   for i:=0 to Map.ItemCount-1 do
    DrawImage2(Map.Items[i])
    { then begin
     with Map.Items[i] do begin
      if ifAutoFlip in Flags then ImageFlip:=Hidden else ImageFlip:=-1;
      if ifTextPanel in Flags then begin
       Text:=Map.ImageCount+i;
       ImageRequest:=ifRequestText in Flags;
      end else begin
       Text:=-1;
      end;
     end;
    end};
   // afficher les sprites en avant plan
   for i:=TopObject to ObjectList.count-1 do TADKObject(ObjectList[i]).Draw;
   // raffiche le joueur en alpha
  // if Alpha and (Focus<>nil) then Focus.DrawAlpha;
   if ImageFlip>=0 then begin
    if ImageFlip<Map.ImageCount then
     ImageFlip:=Map.Images[ImageFlip].Hidden
    else
     ImageFlip:=Map.Items[ImageFlip-Map.ImageCount].Hidden;
   end;
   if ObjectText>=0 then ImageText:=Map.Text(ObjectText) else ImageText:='';
  finally
   ADKScreen.UnLock;
  end;
 end;
end;

procedure Idle(ms:cardinal);
var
 i:integer;
begin
// mise  jour des Sprites
 for i:=0 to ObjectList.Count-1 do TADKObject(ObjectList[i]).Update(ms);
// calcul du FPS
 inc(FrameTicks,ms);
 if FrameTicks>1000 then begin
  FramesPerSec:=FrameCount;
  FrameCount:=0;
  dec(FrameTicks,1000);
 end;
end;

initialization
 InitMath;
end.
