unit LoadMaps;

{
 projet ADK-ISO (c)2002-2003 Paul TOTH <tothpaul@free.fr>

 http://www.web-synergy.net/naug-land/

}

{
 Chargement d'une carte ADK (ct serveur = sans image)
 la fonction LoadMap retourne le TMap (compatible ADKPathFinder) sous sa forme IMap
 sinon TMap possde une fonction LoadFromFile()

  version 1 - lecture des cartes version 105
}

interface

uses
 Windows,Classes,SysUtils,
 ADKPathFinder, // dclaration de IMap
 ADKMaps;       // dclaration de l'entte des fichiers carte

type
 TMap=class(TInterfacedObject,IMap)
 private
  fCells:array of TCell;
  fWidth :integer;
  fHeight:integer;
 public
  function LoadFromFile(AFileName:string):boolean; virtual;
 // IMap (pour ADKPathFinder)
  function Width :integer;
  function Height:integer;
  function CanWalk(const Pos:TPoint):boolean;
 end;

// dfinition des obstacles franchissables
var
 Walkable:set of TObstacle=[TobsStandard..TobsWater_WaistDeep];

function LoadMap(FileName:string):IMap;

implementation

function LoadMap(FileName:string):IMap;
var
 Map:TMap;
begin
 Map:=TMap.Create;
 Map.LoadFromFile(FileName);
 Result:=Map; // as IMap
end;

function TMap.LoadFromFile(AFileName:string):boolean;
var
 f:TFileStream;
 h:THeader107;
 s:integer;
begin
// lecture via un flux fichier
 f:=TFileStream.Create(AFileName,fmOpenRead or fmShareDenyNone);
 try
  Result:=False;
  fWidth:=0;
  fHeight:=0;
  // lecture de l'entte
  f.ReadBuffer(h,SizeOf(h));
  // vrification de version
  if h.Signature<>cardinal(MAP_SIGNATURE) then exit;
  if h.Version<>MAP_VERSION then exit;
  // lecture des cases
  fWidth:=h.Width;
  fHeight:=h.Height;
  s:=fWidth*fHeight;
  SetLength(fCells,s);
  f.ReadBuffer(fCells[0],s);
  // ok
  Result:=True;
 finally
  f.Free;
 end;
end;

function TMap.Width:integer;
begin
 Result:=fWidth;
end;

function TMap.Height:integer;
begin
 Result:=fHeight;
end;

function TMap.CanWalk(const Pos:TPoint):boolean;
begin
 Result:=(Pos.X<fWidth)and(Pos.Y<fHeight)and(fCells[fWidth*Pos.Y+Pos.X].Obstacle in Walkable);
end;

end.
