unit ADKClient;

{
 Client le projet ADK-ISO/3D (c)2002 Paul TOTH <tothpaul@free.fr>

 http://www.web-synergy.net/naug-land/

}

interface

uses
  Windows, Classes, SysUtils, ADKServer, ADKNETData, Definitions;

type
// client
  TNegociateEvent = procedure(Sender: TObject; const Value: TNegociate) of object;
  TServerInfoEvent = procedure(Sender: TObject; const Value: TServerInfo) of object;
  TPlayerInfoEvent = procedure(Sender: TObject; const ID: Cardinal;
    const Cmd: TServCmd; const Value: TPlayerInfo) of object;
  TActifItemEvent = procedure(Sender: TObject; const ID: Cardinal;
    const Cmd: TServCmd; const Value: Tstream) of object;
  TEndGameEvent = procedure(Sender: TObject; const Reason: string) of object;
  TMessageEvent = procedure(Sender: TObject; const ID: Cardinal;
    const Cmd: TServCmd; Text: string; const Attr: TTextAttr) of object;
  TStringEvent = procedure(Sender: TObject; const ID: Cardinal;
    Cmd: TServCmd; Text: string) of object;
  TLoadMapEvent = procedure(Sender: TObject; Map: string) of object;
  TCardinalEvent = procedure(Sender: TObject; const ID: Cardinal;
    const Cmd: TServCmd; Value: Cardinal) of object;
  TStringEvent21 = procedure(Sender: TObject; const ID: Cardinal;
    Cmd: TServCmd; const IdDestinataire: Cardinal; Text: string) of object;
  TMessageEvent21 = procedure(Sender: TObject; const ID: Cardinal;
    const Cmd: TServCmd; const IdDestinataire: Cardinal; Text: string;
    const Attr: TTextAttr) of object;
  TPositionEvent = procedure(Sender: TObject; const ID: Cardinal;
    const Cmd: TServCmd; const Value: TPositionInfo) of object;
  TNoDataCmd = procedure(Sender: TObject; const ID: Cardinal; const Cmd: TServCmd) of object;


  TADKClient = class(TCustomADKClient)
  private
    //fPrompt: string;
    fClientVersion: Word;
    fIdClient: Cardinal; // id du PERSONNAGE emmeteur du message
    EOnNegociate: TNegociateEvent;
    EOnServerInfo: TServerInfoEvent;
    EOnPlayerInfo: TActifItemEvent;
    EOnStartGame: TNotifyEvent;
    EOnEndGame: TEndGameEvent;
    EOnMessage: TMessageEvent;
    EOnLoadMap: TLoadMapEvent;
    EOnString: TStringEvent;
    EOnActifItem: TActifItemEvent;
    EOnCardinal: TCardinalEvent;
    EOnString21: TStringEvent21;
    EOnMessage21: TMessageEvent21;
    EOnPosition: TPositionEvent;
    EOnStopMove: TNoDataCmd;

  public
    procedure Decode(out Data); override;
    procedure SendLogon(Name, Password: string);
    procedure SendNegociate(NumIp: string; NumUpdate: word);
  // Tout ce qui a trait  l'envoie de Texte
    procedure SendText(const Ident: Cardinal; const Commande: TServCmd;
      const TextAttr: TTextAttr; const Text: string);
    procedure Say(const IDent: cardinal; Prompt, Text: string);
  // Tout ce qui  trait  l'envoie d'un String (different de SendText car ici pas de formatage)
    procedure SendString(const Ident: Cardinal; const Commande: TServCmd; const Text: string);
    procedure SendNameExist(const Ident: Cardinal; const Name: string); //Le nom du perso que l'on envoi existe-il sur le serveur ?
  // Tout ce qui  trait  l'envoie d'un Cardinal
    procedure SendCardinal(const IDent: cardinal; const Commande: TServCmd; const CardinalValue: Cardinal);
    procedure Ping(const Ident: Cardinal);
    procedure DisconnectOne(const Ident, IdentAdeconnecter: Cardinal);
  // Tout ce qui  trait  l'envoie des donnes RAW (comme l'envoi d'un personnage "complet"
    procedure SendRawData(const ID: Cardinal; const Cmd: TServCmd; Value: TStream);
    procedure SendCreatePerso(const Ident: Cardinal; Value: TStream);
  //procedure SendPerso(const Ident: Cardinal; const Commande: TServCmd; PlayerInfo: TPlayerInfo);
  //procedure SendCreatePerso(const Ident: Cardinal; PlayerInfo: TPlayerInfo);
  // Tout ce qui a trait  l'envoie d'un position
    procedure SendPosition(const Ident: Cardinal; const Commande: TServCmd; const PositionInfo: TPositionInfo);

  published
    //property Prompt: string read fPrompt write fPrompt;
    property ClientVersion: Word read FClientversion write FClientversion;
    property OnNegociate: TNegociateEvent read EOnNegociate write EOnNegociate;
    property OnServerInfo: TServerInfoEvent read EOnServerInfo write EOnServerInfo;
    property OnPlayerInfo: TActifItemEvent read EOnPlayerInfo write EOnPlayerInfo;
    property OnStartGame: TNotifyEvent read EOnStartGame write EOnStartGame;
    property OnEndGame: TEndGameEvent read EOnEndGame write EOnEndGame;
    property OnMessage: TMessageEvent read EOnMessage write EOnMessage;
    property OnLoadMap: TLoadMapEvent read EOnLoadMap write EOnLoadMap;
    property OnString: TStringEvent read EOnString write EOnString;
    property OnActifItem: TActifItemEvent read EOnActifItem write EOnActifItem;
    property OnCardinal: TCardinalEvent read EOnCardinal write EOnCardinal;
    property OnString21: TStringEvent21 read EOnString21 write EOnString21;
    property OnMessage21: TMessageEvent21 read EOnMessage21 write EOnMessage21;
    property OnPosition: TPositionEvent read EOnPosition write EOnPosition;
    property OnStopMove: TNoDataCmd read EOnStopMove write EOnStopMove;
  end;

implementation
uses StrStuff, Globals;

//----------------------------------------------------------------------------//

procedure TADKClient.Decode(out Data);
var
  Block: TADKBlock absolute Data;
  RawData, Temp: TmemoryStream;
  SizeBlockHead: integer;

  procedure FillStream;
  begin
    Temp:= TmemoryStream.Create;
    try
      Temp.writebuffer(Block, Block.Size);
      SizeBlockHead:= sizeof(Block.Size) + sizeof(TBlockHeader);
      Temp.Position:= SizeBlockHead;
      RawData.CopyFrom(Temp, Block.size - SizeBlockHead);
    finally
      temp.free;
    end;
  end;
begin
 // Rcupration de l'ID du Personnage emmeteur
  fIdClient:= Block.Head.ID;
 // Quel commande doit-on traiter ?
  case Block.Head.Cmd of
    scNegociate: if Assigned(EOnNegociate) then EOnNegociate(Self, Block.Data.Negociate);
    scSpecialDatas: if Assigned(EOnServerInfo) then EOnServerInfo(Self, Block.Data.ServerInfo);
    scInitFinish: if Assigned(EOnStartGame) then EOnStartGame(Self);
    scCloseConnect: if Assigned(EOnEndGame) then with Block.Data.TextInfo do EOnEndGame(Self, Copy(Text, 1, Size));
    scDisConnect,
      scNameExist,
      scPersoWrited,
      scTextServ,
      scPatchDispo,
      scShowMessage,
      scGetNameAndPass: if assigned(EOnString) then with Block.Data.TextInfo do EOnString(Self, Block.Head.ID, Block.Head.Cmd, Copy(Text, 1, Size));
    scUpdatePClient: if Assigned(EOnPlayerInfo) then begin
        RawData:= TmemoryStream.Create;
        try
          FillStream;
          EOnPlayerInfo(Self, Block.Head.Id, Block.Head.Cmd, RawData);
        finally
          RawData.Destroy;
        end;
      end;
    scActifItem: if Assigned(EOnActifItem) then begin
        RawData:= TmemoryStream.Create;
        try
          FillStream;
          EOnActifItem(Self, Block.Head.Id, Block.Head.Cmd, RawData);
        finally
          RawData.Destroy;
        end;
      end;

    scText, scTextRp: if Assigned(EOnMessage) then with Block.Data.MessageInfo do
          EOnMessage(Self, Block.Head.Id, Block.Head.Cmd, Copy(Text, 1, Size), Attr);
    scLoadMap: if Assigned(EOnLoadMap) then with Block.Data.TextInfo do EOnLoadMap(Self, Copy(Text, 1, Size));
    scPing,
      scMiniPersoDeco,
      scRotate,
      scGetNbrIncrit: if Assigned(EOnCardinal) then EOnCardinal(Self, Block.Head.Id, Block.Head.Cmd, Block.Data.CardinalInfo);
    scString21: if assigned(EOnString21) then with Block.Data.TextInfo21 do EOnString21(Self, Block.Head.ID, Block.Head.Cmd, IdDestinataire, Copy(Text, 1, Size));
    scText21: if Assigned(EOnMessage21) then with Block.Data.MessageInfo21 do
          EOnMessage21(Self, Block.Head.Id, Block.Head.Cmd, IDDestinataire, Copy(Text, 1, Size), Attr);
    scPlaceAt,
      scTeleport,
      scMoveTo,
      scRunTo,
      scJump,
      scEndMove: if Assigned(EOnPosition) then EOnPosition(Self, Block.Head.Id, Block.Head.Cmd, Block.Data.PositionInfo);
    //scStoMove et scEndmove sont tres different. ScStopMove permet d'arreter un perso  tout instant
    //tandis que scEndmove indique simplement la ou le perso  fini son mouvement
    scStopmove: if Assigned(EOnStopMove) then EOnStopMove(Self, Block.Head.Id, Block.Head.Cmd);

  else raise Exception.create('procedure TADKClient.Decode(out Data); Ordre non gr ' + IntToStr(Ord(Block.Head.Cmd))); //AVANT >> FatalError('Ordre non gr '+IntToStr(Ord(Block.Head.Cmd)));
  end;
  tag:= 0; //Utilis pour savoir combien de temps cela fait que je n'ai rien reu
end;

procedure TADKClient.SendNegociate(NumIp: string; NumUpdate: word);
var
  Block: packed record
    size: integer;
    Head: TBlockHeader;
    Data: TNegociate;
  end;
begin
  with Block do begin
    size:= SizeOf(block);
    with Head do begin
      ID:= 0;
      Cmd:= scNegociate;
    end;
    data.Server:= NumIp;
    data.version:= fClientVersion;
    data.Update:= NumUpDate;
    data.Banish:= false;
  end;
  Provider.Encode(Block);
end;

procedure TADKClient.SendLogon(Name, Password: string);
var
  Block: packed record
    size: integer;
    Head: TBlockHeader;
    Data: TLoginInfo;
  end;
begin
  with Block do begin
    size:= SizeOf(block);
    with Head do begin
      ID:= CrcString2(name);
      Cmd:= scConnectMe;
    end;
    Data.name:= name;
    Data.pass:= password;
    Data.auth:= true;
  end;
  Provider.Encode(Block);
end;

procedure TADKClient.SendText(const Ident: Cardinal; const Commande: TServCmd;
  const TextAttr: TTextAttr; const Text: string);
var
  Block: packed record
    FixedPart: record
      size: integer;
      Head: TBlockHeader;
      Attr: TTextAttr;
      Len: integer;
    end;
    OtherPart: array[0..1024] of char;
  end;
begin
  with Block do begin
    with FixedPart do begin
      with Head do begin
        ID:= IDent;
        Cmd:= Commande;
      end;
      Attr:= TextAttr;
      Len:= Length(Text);
      if len > 1024 then Len:= 1024;
      Move(Text[1], OtherPart, len);
      Size:= SizeOf(FixedPart) + 4 + Len;
    end;
  end;
  Provider.Encode(Block);
end;

procedure TADKClient.Say(const IDent: cardinal; Prompt, Text: string);
var Attr: TTextAttr;
begin
  with Attr do begin
    Language:= 0;
    Color:= 0;
    Bold:= false;
    Italic:= False;
  end;
  //Text := fPrompt + Text; //Fprompt= Name+' >:'
  SendText(Ident, scText, Attr, Text);
end;

// Envoie un string

procedure TADKClient.SendString(const Ident: Cardinal; const Commande: TServCmd;
  const Text: string);
var
  Block: packed record
    FixedPart: record
      size: integer;
      Head: TBlockHeader;
      Len: integer;
    end;
    OtherPart: array[0..1024] of char;
  end;
begin
  with Block do begin
    with FixedPart do begin
      with Head do begin
        ID:= IDent;
        Cmd:= Commande;
      end;
      Len:= Length(Text);
      if len > 1024 then Len:= 1024;
      Move(Text[1], OtherPart, len);
      Size:= SizeOf(FixedPart) + 4 + Len;
    end;
  end;
  Provider.Encode(Block);
end;

procedure TADKClient.SendNameExist(const Ident: Cardinal; const Name: string);
begin
  // Le nom du perso Name existe-il sur le serveur ?
  SendString(Ident, scNameExist, Name);
end;

// Envoie d'un cardinal. La commande est a preciser dans "Commande"

procedure TADKClient.SendCardinal(const IDent: cardinal;
  const Commande: TServCmd; const CardinalValue: Cardinal);
var
  Block: packed record
    size: integer;
    Head: TBlockHeader;
    Data: Cardinal;
  end;
begin
  with Block do begin
    size:= SizeOf(Block);
    with Head do begin
      ID:= IDent;
      Cmd:= Commande;
    end;
    Data:= CardinalValue;
  end;
  Provider.Encode(Block);
end;

procedure TADKClient.Ping(const IDent: Cardinal);
begin
  SendCardinal(IDent, ScPing, GetTickCount); //Ping interne  l'appli
end;

procedure TADKClient.DisconnectOne(const Ident, IdentAdeconnecter: Cardinal);
begin
  //deconnecter le perso avec l'ID IdentAdeconnecter sans fermer la session.
  SendCardinal(IDent, scDisConnect, IdentAdeconnecter);
end;

procedure TADKClient.SendRawData(const ID: Cardinal; const Cmd: TServCmd; Value: TStream);
var MemoryStream: TmemoryStream;
  SizeStream: Integer;
begin
  MemoryStream:= TMemoryStream.Create;
  try
    MemoryStream.WriteBuffer(SizeStream, Sizeof(SizeStream));
    MemoryStream.WriteBuffer(Id, Sizeof(Id));
    MemoryStream.WriteBuffer(Cmd, Sizeof(cmd));
    MemoryStream.CopyFrom(Value, 0);
    MemoryStream.Position:= 0;
    SizeStream:= MemoryStream.size;
    MemoryStream.WriteBuffer(SizeStream, Sizeof(SizeStream));
    Provider.Encode(MemoryStream.Memory^);
  finally
    MemoryStream.destroy;
  end;
end;

procedure TADKClient.SendCreatePerso(const Ident: Cardinal; Value: TStream);
begin
  SendRawData(Ident, scCreatePerso2, Value);
end;

procedure TADKClient.SendPosition(const Ident: Cardinal;
  const Commande: TServCmd; const PositionInfo: TPositionInfo);
var
  Block: packed record
    size: integer;
    Head: TBlockHeader;
    Data: TPositionInfo;
  end;
begin
  with Block do begin
    size:= SizeOf(block);
    with Head do begin
      ID:= Ident;
      Cmd:= Commande;
    end;
    Data:= PositionInfo;
  end;
  Provider.Encode(Block);
end;

end.

