unit ADKCreate4;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  jpeg, ExtCtrls, StdCtrls, HandBook, HandBook2, Players, Spin;

type
  TFrame4 = class(TFrame)
    Label5: TLabel;
    Bevel4: TBevel;
    lbRace: TLabel;
    Image1: TImage;
    Label1: TLabel;
    seAge: TSpinEdit;
    lbAge: TLabel;
    lbTaille: TLabel;
    rbSexeMasculin: TRadioButton;
    rbSexeFeminin: TRadioButton;
    lbPoids: TLabel;
    BonusRace: TLabel;
    Label4: TLabel;
    MalusAge: TLabel;
    Bevel1: TBevel;
    pbBonus: TPaintBox;
    procedure rbSexeClick(Sender: TObject);
    procedure seAgeChange(Sender: TObject);
    procedure pbBonusPaint(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    race: TRace;
    CharacterOld: integer;
    procedure InfoRace;
  end;

implementation

{$R *.dfm}

uses
  ADKCreate, Player;

procedure TFrame4.InfoRace;
var
  c: TAbility;
begin
  with Character do begin
 // nom de la race
    lbRace.Caption := 'Vous avez choisi d''tre un ' + RaceNames[Race] + '.';
    for c := Low(TAbility) to High(TAbility) do begin
      Scores[c] := DiceRoll[c].total + RacialAbilityAdjustements[Race, c];
    end;
  end;
 // la premire fois, et  chaque fois qu'on change de race
  if (CharacterOld = 0) or (race <> Character.Race) then begin
    race := Character.Race;
    with Ages[race] do begin
      Character.Age := base + Roll(dice);
      Character.MaxAge := ages[3] + Roll(max);
      seAge.MinValue := base;
      seAge.MaxValue := ages[3];
      seAge.Value := Character.age;
      lbAge.Caption := 'ans, ' + AgeNames[CharacterOld];
    end;
    lbTaille.tag := Roll(AverageHeight[race].dice);
    lbPoids.tag := Roll(AverageWeight[race].dice);
    if Character.Sex = Male then
      rbSexeClick(rbSexeMasculin)
    else
      rbSexeClick(rbSexeFeminin);
  end;
end;

procedure TFrame4.rbSexeClick(Sender: TObject);
begin
  with Character do begin
    Sex := TSex(TRadioButton(Sender).Tag);
    Height := AverageHeight[race].base[Sex] + lbTaille.Tag;
    Weight := AverageWeight[race].base[Sex] + lbPoids.Tag;
    lbTaille.Caption := IntToStr(round(Height * 2.54)) + ' cm';
    lbPoids.Caption := IntToStr(round(Weight * 0.454)) + ' kg';
  end;
end;

procedure TFrame4.seAgeChange(Sender: TObject);
var
  v: integer;
begin
  Character.Age := seAge.Value;
  v := 3; while (v > 0) and (Character.Age < Ages[Race].Ages[v]) do dec(v);
  if CharacterOld <> v then begin
    CharacterOld := v;
    lbAge.Caption := 'ans, ' + AgeNames[v];
    Invalidate;
  end;
end;

procedure TFrame4.pbBonusPaint(Sender: TObject);
var
  c: TAbility;
  y, dy: integer;
  r, a, i: integer;
  s: string;
begin
  with pbBonus, Canvas do begin
    Brush.Style := bsClear;
    y := 0;
    dy := Height div 6;
    for c := Low(TAbility) to High(TAbility) do begin
      Font.Color := clWhite;
      TextOut(0, y, AbilityNames[c]);

      r := RacialAbilityAdjustements[Character.Race, c];
      s := IntToStr(r); if r >= 0 then s := '+' + s;
      if r > 0 then Font.Color := clBlue else
        if r < 0 then Font.Color := clRed else Font.Color := clWhite;
      TextOut(BonusRace.Left - TextWidth(s), y, s);

      a := 0;
      for i := 1 to CharacterOld do inc(a, AgingEffects[c, i]);

      s := IntToStr(a); if a >= 0 then s := '+' + s;
      if a > 0 then Font.Color := clBlue else
        if a < 0 then Font.Color := clRed else Font.Color := clWhite;
      TextOut(MalusAge.Left - TextWidth(s), y, s);

      inc(a, r);
      if a > 0 then Font.Color := clBlue else
        if a < 0 then Font.Color := clRed else Font.Color := clWhite;
      inc(a, DiceRoll[c].Total);
      Character.Scores[c] := a;

      s := IntToStr(a);
      TextOut(Left + Width - 16 - TextWidth(s), y, s);
      inc(y, dy);
    end;
  end;
end;

end.
