unit Definitions;

interface
uses Windows, Player, contnrs, classes, HandBook2, HandBook;

type

  TonNotifyBoolean = procedure(Sender: TObject; Value: boolean) of object;
  TonNotifyStr = procedure(Sender: TObject; Value: string) of object;

  TIndexCaract = (
    // Caract de TCharacter
    IcName, IcPassword,
    IcStrength, IcDexterity, IcConstitution, IcIntelligence, IcWisdom, IcCharisma, IcExStrength,
    IcRace, IcSex, IcHeight, IcWeight, IcAge, IcMaxAge,
    IcClasses, IcMagicSchool,
    IcThievPickPockets, IcThievOpenLocks, IcThievFindRemoveTraps, IcThievMoveSilently,
    IcThievHideInShadows, IcThievDetectNoise, IcThievClimbWalls, IcThievReadLanguages,
    IcAlignment, IcHitPoints,
    //Caract de TPersonnage
    IcPieces, IcMaxHitPoints, IcXp, IcPosition, IcCarte,
    IcCompetences, // Listes de comptences ouverte par le personnage
    IcCompsLevels, // Toute les comptences choisi par le personnage.
    IcPlacePierres,
    IcInventaire,
    IcSaoul, IcEtat, IcFatigue,
    IcVisible,
    IcResistFroid, IcResistChaud, IcResistMagie, IcResistElec, IcResistPoison,
    IcMuet, IcSourd, IcParalyser, IcMarche, IcGeler, IcLangues,
    //Autre Caract Renvoy " la vol"
    IcThaco, IcCA,
    IcNiveau
    );
  TIndexCaracts = set of TIndexCaract;

const
  TicString = [IcName..IcPassword];
  TicByte = [IcStrength..IcExStrength, IcMagicSchool, IcNiveau];
  TicShortInt = [IcThievPickPockets..IcThievReadLanguages, IcSaoul..IcFatigue,
    IcResistFroid..IcResistPoison, IcThaco..IcCA];
  TicEnsemble = [IcRace, IcSex, IcAlignment];
  TicSet = [IcClasses, IcCompetences];
  TicWord = [IcHeight..IcMaxAge, IcCarte];
  TicInteger = [IcHitPoints, IcMaxHitPoints, IcXp];
  TicPosition = [IcPosition]; // XYZ
  TicCompetences = [IcCompsLevels];
  Tic3pierres = [IcPlacePierres];
  TicInventaire = [IcInventaire];
  TicBoolean = [IcVisible, IcMuet..IcGeler];
  TicInt = TicByte + TicShortInt + TicWord + TicInteger;


type
  TlangueExtended = (
    leCommun,
    leElfe, leGnome, leHobbit, leNain,
    leGobelin, leHobgobelin,
    leOrque, leGnoll, leKobold,
    leMamiferesFouisseurs, leCreaturesSouterraines,
    leMD, leVoleurs, leReserved,
    leMageL1, leMageL2, leMageL3, leMageL4, leMageL5,
    leClercL1, leClercL2, leClercL3, leClercL4, leClercL5,
    leBarde, leSigne,
    le1, le2, le3, le4, le5, le6, le7, le8,
    leDieu);

  TLanguesExtended = set of TlangueExtended;

 // Les fameuse liste  "ouvrir" et qui donne acces
 // au TSortLeveled
  TListCompetence = (
    cwNull,
    cwGeneral, // Les comp non martiales (Liste ouverte par defaut ds le dbut du jeu ?)
    cwWarrior, // Competences gurrire
    cwThief, // Competences Voleurs
    //Off= Offensif; Def= Defensif
    cwMagic, //Magie en gnrale.. sert pour les magicien non "pur"
    cwBlackMagic, // Off/def: Competence Magie Noire: Ncromancienne
    cwRedMagic, // Off: Competences magie Rouge: feu
    cwGreenMagic, // Def: Competences magie Verte: (Magie des plantes et de la terre. Gel et froid: Druides par exemple (permet la cration de potions))
    cwBlueMagic, // Off: Competences magie Bleu: Electricit
    cwYellowMagic, // Off/def: Competence magie Jaune: Potions et poisons (ralisation de "grenades" aussi)
    cwMarronMagic, // Je sais pas/plus
    cwWhiteMagic, // Magie Clrical en gnrale
    cwR1, cwR2, cwR3, cwR4, cwR5, cwR6, cwR7, cwR8, cwR9, cwR10, cwR11,
    cwEnded);
  TListCompetences = set of TListCompetence;

type

  TCompByLevel = record //Competence qui evolue suivant le nombre de point que l'on veut bien y mettre
    Competence: word;
    LevelIncomp: Cardinal; //Ne donne pas rellement le niveau mais le nombre de point dans la comp. On dduit le niveau  partir du mobre de point
  end;

{ Sorts et autres competences martiales et non martiales }
  TCompLeveled = ({ w= Warrior, M= Mage, C= Clerc, B= barde}
    SlNull,
   { Competences non martiales associer avec un niveau permettant d'ameloir la competence avec 1 point de comp par niveau du personnage }
    BrassageBiere, { Permet de fair de l'alcool en gnrale. Niveau 1= Alcool mdiocre, Niveau 10= Alcool sublime ou nectar des dieux}
    ForgeArme, { Permet de forger une arme  partir de materiaux primaire. Niveau 1= petite armes. Niveau 10= Arme d'excellente qualit. Niveau 20= Arme de jets }
    Reparation, { Permet de reparer des objets. 1= rparation mdiocre, 10= Rparation 100% }
    Salaison, { permet de rendre une viande de meilleur qualit. Niveau 1= Qualit a peine mieux que crue. Niveau 10= Viande exellente. }
    Endurance, { Permet de courir ou de faire un effort en se fatiguant moins vite }

   { Competences de type Guerrire }
    W_FastFrappe, { Augmnete le nombre de coup par round niveau = 10% de vitesse en plus.. Niveau 10= 100% de vitesse en plus (tape deux fois plus) }
    W_BotteSpecial, { Un peu comme les combos dans les jeux de baston. Permet de raliser des coups spciaux Niveau 1= 5% de Combos dans une bagaree niveau max = 5}
    W_SupremeSpec, { Specialisation extreme dans une seule catgorie d'arme. Niveau max = 5 }
    W_ResistCoup, { Devellope la resistance au coup }
    W_BouclierSupreme, { Permet de develloper la parade au maximum Niveau max = 5 = 25 % de coups pars}

   { Competences de type sort }
    M_MissileFeu, { Missile de feu }
    M_MissileElec,
    M_MissileGlace,
    M_BouleFeu, { Boule de feu (effet de zone) }
    M_BouleElec,
    M_BouleGlace, { Vanille/fraise }
    M_BouclierFeu, { Sorts de protection }
    M_BouclierElec,
    M_BouclierGlace,
    M_ArmureFeu,
    M_ArmureElec,
    M_ArmureGlace,

    M_Murfeu, M_Colonnefeu, M_Torrentfeu, M_Chaleurinfernale,
    M_CorpsFoudroyant, M_Champfoudre, M_Mortbleu,
    M_Iceberg, M_Mortglaciale,


    C_MissileMentale, { Missile. Un peu pipo tout ca.. Juste pour differencier legerement le classes }
    C_ChocMentale, { Comme Missile mentale mais avec un effet de zone }
    C_BouclierMentale,
    C_ArmureMentale,
    C_Heal, { rtablie des point de vie. A haut niveau (10) = 100% des PV rtablit}

    B_MissileSonique,
    B_ExplosionSonique, {Comme Boule de feu des mage mais pour les bardes. Effets differents aussi}
    B_BouclierSonique,
    B_ArmureSonique,
    B_AppaiseMonstre, { Endort ou calme les animeaux  }
    SlEnd);

  { Array contenant les competences du personnage }
  TCompsLevels = array[0..30] of TCompByLevel; //Garder 3 emplacemet pour les competences non martiales
  Tcomplevel = array of TCompByLevel;
  { Pierres Magiques }
  TPierreColor = (pc_Null, pcNoire, pcRouge, pcVerte, pcBleu, pcJaune, pcBrune, pcBlanche);

  TMagePierre = record
    Color: TPierreColor; // Couleur de la magePierre
    Charge: byte; // Nombre de charge restante (255 max)
  end;

  T3Pierres = array[0..2] of TMagePierre; //emplacement ou l'on met les MagePierres. 3 maximum

 // Les emplacement ou l'on peut mettre des objets
  TEmplacement = (emNone, emOnAction, emCarquoi, emSac, emBourse, emObjRapide,
    emParTerre, emFourreau, emCeinture, emCasque, emCollier, emArmure,
    emCape, emEpe, emBouclier, emRing1, emRing2, emGantelet,
    emBotte);
  TsetEmplacement = set of TEmplacement;

const
  TSetEmplacementMini: TsetEmplacement = [emCasque, emArmure, emEpe, emBouclier, emBotte];
  TsetEmplacementVisible: TsetEmplacement = [emCarquoi, emCasque..emBotte];

type
  TOneObjet = record
    IdObjet: Word; // N d'identification de l'objet
    Emplacement: TEmplacement; // Emplacement sur le perso (Main, tete, sac etc)
    Pv: byte; // Durability
    Identifier: boolean; // L'Objet est identifi ?
    R1: byte; // Nombre d'objet (7 potions de soins par exemple)
  end;

  TActiveSort = record // sort (ou autre actif sur le perso).
    IdObjet: Word; // N d'identification de l'objet actif
    TimeRemaining: Word; // Temps restant avant fin du sort (en round)
  end;

  TTresor = array of TOneObjet;

const
  MaxInvPj = 69;
  MaxInvPnJ = 2;

type
  TInventaire = array[0..MaxInvPj] of TOneObjet;
  TInventaireMonstres = array[0..MaxInvPnJ] of TOneObjet;

  TSortsEnCour = array of TActiveSort;

const
  MaxSortEncourPJ = 15;
  MaxSortEncourPnJ = 3;

type
  TSortsActifs = array[0..MaxSortEncourPJ] of TActiveSort;
  TSortsActifsMonstres = array[0..MaxSortEncourPJ] of TActiveSort;

  TDirection = (DirN, DirNE, DirE, DirSE, DirS, DirSO, DirO, DirN0);

  Tr_Pos = packed record
    x, y: word;
    z: byte;
  end;

  TR_Position = packed record
    xyz: Tr_Pos; // XYZ: Emplacement. On Utilise Z pour garder la DIRECTION des personnages
    Map: word; // Map: Carte ou se trouve le perso (representer par le N ID fournit par le serveur)
    Dir: TDirection; // Dir: Direction vers laquelle est tourner le perso.
  end;


  TRegime = (rgOmnivore, rgHerbivore, rgCarnivore);

  TmaxminByte = packed record
    Min: byte;
    Max: byte;
    Fixe: byte;
  end;

  TResistance = (rsFroid, rsChaud, rsMagie, rsElec, rsPoison);
  TResistances = array[rsFroid..rsPoison] of ShortInt;

  TPNJMonstre = packed record //Record dfinisssant un PNJ de type "Monstre"
    ID: Cardinal;
    IDMaitre: Cardinal; //<< ID du matre du monstre. 0= Pas de maitre
    CurrentStatus: Byte; // << 0= Rester sur la position; 1= rester sur la position et se defendre etc.
    Visible: Byte;
    Position: TR_Position;
    Race: Word; // Type de la race. Par exemple 0= Humain, 2= Chien, 3= Cheval
    Sex: Tsex;
    CycleDiurne: Boolean;
    Regime: TRegime; //Voir dfinition juste au dessus
    Inteligence: byte; // 0=Humain, 1= animal 2..heuuuu je sais pas :-)
    Tresor: TInventaireMonstres;
    SortsActifs: TSortsActifsMonstres;
    Alignement: TAlignment;
    ArmorClass: Shortint;
    Vitesse: Byte;
    DesDeVie: Byte;
    PvMax: word;
    PvCourant: word;
    THACO: Shortint;
    NbrAttaque: byte;
    Degat: TmaxminByte; //Voir definition TmaxminByte plus haut
    AttaqueSpeciale,
      DefenseSpeciale: TOneObjet;
    Resistances: TResistances;
    Taille: word;
    Moral: Shortint;
    XPValue: word;
    R1, R2: byte;
  end;

  TPointRestant = (prLangue, prVol, prCompArme, prSpecialisation, prComp1, prComp2);
  TPointsRestants = array[prLangue..prComp2] of byte;
  TLivreSorts= Array[0..127] of Cardinal;
  TSortsConnus= Array of Cardinal;


  TPersonnage = packed record // enregistrement maitre de tout personnage
    CaractAdd: TCharacter;
    Pieces: Cardinal; // Piece
    MaxHitPoints: Integer; // Maximum de Pv du perso
    Xp: cardinal; // Le nombre de points d'eXPrience
    Position: TR_Position;
    Competences: TListCompetences; // Contient les listes ouverte par le perso.
    CompsLevels: TCompsLevels;
    PlacePierres: T3Pierres;
    Inventaire: TInventaire;
    SortsActifs: TSortsActifs;
    Saoul, Etat,
      Fatigue: ShortInt; // Saoul=0 =normal; Etat et fatigue de -10  10
    Visible: byte; // Le perso est'il Visible ? 0= Invisible. 255=Visible
    Resistances: TResistances;
    muet, sourd,
      paralyser,
      marche,
      geler: boolean;
    Langues: TLanguesExtended;
    PointsRestants: TPointsRestants;
    Dieu: Cardinal; // Dieu du perso sous forme d'index
    Rang: byte; // Rang du personnage
    LivreSorts: TLivreSorts;//Sorts que l'on connait ou qui sont dans notre Livre de sorts
    Mana: Cardinal;// Mago
    Reserve1: Integer; // Reseved futur Uses
    r2: ShortInt; 
  end;


implementation


end.

