unit HandBook2;

interface

// Step 1: Roll Ability Scores (chapter 1)
type
  TAbility = (abStrength, abDexterity, abConstitution, abIntelligence, abWisdom, abCharisma);
  TAbilities = array[TAbility] of byte;

type
  TStrengthAdj = record
    Score: byte;
    HitProb: shortint; // Hit Probability
    DmgAdj: shortint; // Damage Adjustment
    Weight: word; // Weight Allowance
    Press: word; // Maximum Press
    Doors: byte; // Open Doors (heavy or stuck door)
    Locked: byte; // Open Doors (locked, barred, or magically held door)
    Bend: byte; { % } // Bend Bars/Lift Gates
  end;

const
  StrengthAdjs: array[0..18] of TStrengthAdj = (
    (Score: 1; HitProb: - 5; DmgAdj: - 4; Weight: 1; Press: 3; Doors: 1; Locked: 0; Bend: 0),
    (Score: 2; HitProb: - 3; DmgAdj: - 2; Weight: 1; Press: 5; Doors: 1; Locked: 0; Bend: 0),
    (Score: 3; HitProb: - 3; DmgAdj: - 1; Weight: 5; Press: 10; Doors: 2; Locked: 0; Bend: 0),
    (Score: 4; HitProb: - 2; DmgAdj: - 1; Weight: 10; Press: 25; Doors: 3; Locked: 0; Bend: 0),
    (Score: 6; HitProb: - 1; DmgAdj: 0; Weight: 20; Press: 55; Doors: 4; Locked: 0; Bend: 0),
    (Score: 8; HitProb: 0; DmgAdj: 0; Weight: 35; Press: 90; Doors: 5; Locked: 0; Bend: 1),
    (Score: 10; HitProb: 0; DmgAdj: 0; Weight: 40; Press: 115; Doors: 6; Locked: 0; Bend: 2),
    (Score: 12; HitProb: 0; DmgAdj: 0; Weight: 45; Press: 140; Doors: 7; Locked: 0; Bend: 4),
    (Score: 14; HitProb: 0; DmgAdj: 0; Weight: 55; Press: 170; Doors: 8; Locked: 0; Bend: 7),
    (Score: 16; HitProb: 0; DmgAdj: + 1; Weight: 70; Press: 195; Doors: 9; Locked: 0; Bend: 10),
    (Score: 17; HitProb: + 1; DmgAdj: + 1; Weight: 85; Press: 220; Doors: 10; Locked: 0; Bend: 13),
    (Score: 18; HitProb: + 1; DmgAdj: + 2; Weight: 110; Press: 255; Doors: 11; Locked: 0; Bend: 16),
// Hill Giant
    (Score: 19; HitProb: + 3; DmgAdj: + 7; Weight: 485; Press: 640; Doors: 16; Locked: 8; Bend: 50),
// Stone Giant
    (Score: 20; HitProb: + 3; DmgAdj: + 8; Weight: 535; Press: 700; Doors: 17; Locked: 10; Bend: 60),
// Frost Giant
    (Score: 21; HitProb: + 4; DmgAdj: + 9; Weight: 635; Press: 810; Doors: 17; Locked: 12; Bend: 70),
// Fire Giant
    (Score: 22; HitProb: + 4; DmgAdj: + 10; Weight: 785; Press: 970; Doors: 18; Locked: 14; Bend: 80),
// Cloud Giant
    (Score: 23; HitProb: + 5; DmgAdj: + 11; Weight: 935; Press: 1130; Doors: 18; Locked: 16; Bend: 90),
// Storm Giant
    (Score: 24; HitProb: + 6; DmgAdj: + 12; Weight: 1235; Press: 1440; Doors: 19; Locked: 17; Bend: 95),
// Titan
    (Score: 25; HitProb: + 7; DmgAdj: + 14; Weight: 1535; Press: 1750; Doors: 19; Locked: 18; Bend: 99)
    );

  ExStrengthAdjs: array[0..4] of TStrengthAdj = (
    (Score: 01; HitProb: + 1; DmgAdj: + 3; Weight: 135; Press: 280; Doors: 12; Locked: 0; Bend: 20),
    (Score: 51; HitProb: + 2; DmgAdj: + 3; Weight: 160; Press: 305; Doors: 13; Locked: 0; Bend: 25),
    (Score: 76; HitProb: + 2; DmgAdj: + 4; Weight: 185; Press: 330; Doors: 14; Locked: 0; Bend: 30),
    (Score: 91; HitProb: + 2; DmgAdj: + 5; Weight: 235; Press: 380; Doors: 15; Locked: 3; Bend: 35),
    (Score: 100; HitProb: + 3; DmgAdj: + 6; Weight: 335; Press: 480; Doors: 16; Locked: 6; Bend: 40)
    );

type
  TDexterityAdj = record
    Score: byte;
    Reaction: ShortInt; // Reaction Adjustment
    Missile: ShortInt; // Missile Attack Adjustment
    Defense: ShortInt; // Defensive Adjustment
  end;

const
  DesterityAdjs: array[0..15] of TDexterityAdj = (
    (Score: 1; Reaction: - 6; Missile: - 6; Defense: + 5),
    (Score: 2; Reaction: - 4; Missile: - 4; Defense: + 5),
    (Score: 3; Reaction: - 3; Missile: - 3; Defense: + 4),
    (Score: 4; Reaction: - 2; Missile: - 2; Defense: + 3),
    (Score: 5; Reaction: - 1; Missile: - 1; Defense: + 2),
    (Score: 6; Reaction: 0; Missile: 0; Defense: + 1),
    (Score: 7; Reaction: 0; Missile: 0; Defense: 0),
    (Score: 8; Reaction: 0; Missile: 0; Defense: 0),
    (Score: 15; Reaction: 0; Missile: 0; Defense: - 1),
    (Score: 16; Reaction: + 1; Missile: + 1; Defense: - 2),
    (Score: 17; Reaction: + 2; Missile: + 2; Defense: - 3),
    (Score: 18; Reaction: + 2; Missile: + 2; Defense: - 4),
    (Score: 19; Reaction: + 3; Missile: + 3; Defense: - 4),
    (Score: 20; Reaction: + 3; Missile: + 3; Defense: - 4),
    (Score: 21; Reaction: + 4; Missile: + 4; Defense: - 5),
    (Score: 24; Reaction: + 5; Missile: + 5; Defense: - 6)
    );

type
  TConstitutionAdj = record
    HitPoint: ShortInt; // Hit Point Adjustment
    MinDice: byte;
    Shock: byte; // System Shock
    Resu: byte; // Resurrection Survival
    Poison: ShortInt; // Poison Save
    Regener: byte; // Regeneration (turns for 1 bit point, 0=never)
  end;

const
  ConstitutionsAdjs: array[1..25] of TConstitutionAdj = (
  { 1}(HitPoint: - 3; MinDice: 1; Shock: 25; Resu: 30; Poison: - 2; Regener: 0),
  { 2}(HitPoint: - 2; MinDice: 1; Shock: 30; Resu: 40; Poison: - 1; Regener: 0),
  { 3}(HitPoint: - 2; MinDice: 1; Shock: 35; Resu: 40; Poison: 0; Regener: 0),
  { 4}(HitPoint: - 1; MinDice: 1; Shock: 40; Resu: 45; Poison: 0; Regener: 0),
  { 5}(HitPoint: - 1; MinDice: 1; Shock: 45; Resu: 50; Poison: 0; Regener: 0),
  { 6}(HitPoint: - 1; MinDice: 1; Shock: 50; Resu: 55; Poison: 0; Regener: 0),
  { 7}(HitPoint: 0; MinDice: 1; Shock: 55; Resu: 60; Poison: 0; Regener: 0),
  { 8}(HitPoint: 0; MinDice: 1; Shock: 60; Resu: 65; Poison: 0; Regener: 0),
  { 9}(HitPoint: 0; MinDice: 1; Shock: 65; Resu: 70; Poison: 0; Regener: 0),
  {10}(HitPoint: 0; MinDice: 1; Shock: 70; Resu: 75; Poison: 0; Regener: 0),
  {11}(HitPoint: 0; MinDice: 1; Shock: 75; Resu: 80; Poison: 0; Regener: 0),
  {12}(HitPoint: 0; MinDice: 1; Shock: 80; Resu: 85; Poison: 0; Regener: 0),
  {13}(HitPoint: 0; MinDice: 1; Shock: 85; Resu: 90; Poison: 0; Regener: 0),
  {14}(HitPoint: 0; MinDice: 1; Shock: 88; Resu: 92; Poison: 0; Regener: 0),
  {15}(HitPoint: + 1; MinDice: 1; Shock: 90; Resu: 94; Poison: 0; Regener: 0),
  {16}(HitPoint: + 2; MinDice: 1; Shock: 95; Resu: 96; Poison: 0; Regener: 0),
 // HitPoint +2 for non-fighters
  {17}(HitPoint: + 3; MinDice: 1; Shock: 97; Resu: 98; Poison: 0; Regener: 0),
  {18}(HitPoint: + 4; MinDice: 1; Shock: 99; Resu: 100; Poison: 0; Regener: 0),
  {19}(HitPoint: + 5; MinDice: 1; Shock: 99; Resu: 100; Poison: 1; Regener: 0),
 // All 1s rolled for Hit Dice are automatically considered 2s.
  {20}(HitPoint: + 5; MinDice: 2; Shock: 99; Resu: 100; Poison: 1; Regener: 6),
 // All 1s and 2s rolled for Hit Dice are automatically considered 3s.
  {21}(HitPoint: + 6; MinDice: 3; Shock: 99; Resu: 100; Poison: 2; Regener: 5),
  {22}(HitPoint: + 6; MinDice: 3; Shock: 99; Resu: 100; Poison: 2; Regener: 4),
 // All 1s, 2s, and 3s rolled for Hit Dice are automatically considered 4s.
  {23}(HitPoint: + 6; MinDice: 4; Shock: 99; Resu: 100; Poison: 3; Regener: 3),
  {24}(HitPoint: + 7; MinDice: 4; Shock: 99; Resu: 100; Poison: 3; Regener: 2),
  {25}(HitPoint: + 7; MinDice: 4; Shock: 99; Resu: 100; Poison: 4; Regener: 1)
    );

type
  TIntelligenceAdj = record
    Score: byte;
    Lang: byte; // Number of Languages
    Spell: byte; // Spell Level
    Learn: byte; // Chance to Learn Spell
    SPL: byte; // Max # of Spells/Level
    Illu: byte; // Illusion Immunity
  end;

const
  IntelligenceAdjs: array[0..18] of TIntelligenceAdj = (
    (Score: 1; Lang: 0; Spell: 0; Learn: 0; SPL: 0; Illu: 0),
    (Score: 2; Lang: 1; Spell: 0; Learn: 0; SPL: 0; Illu: 0),
    (Score: 9; Lang: 2; Spell: 4; Learn: 35; SPL: 6; Illu: 0),
    (Score: 10; Lang: 2; Spell: 5; Learn: 40; SPL: 7; Illu: 0),
    (Score: 11; Lang: 2; Spell: 5; Learn: 45; SPL: 7; Illu: 0),
    (Score: 12; Lang: 3; Spell: 6; Learn: 50; SPL: 7; Illu: 0),
    (Score: 13; Lang: 3; Spell: 6; Learn: 55; SPL: 9; Illu: 0),
    (Score: 14; Lang: 4; Spell: 7; Learn: 60; SPL: 9; Illu: 0),
    (Score: 15; Lang: 4; Spell: 7; Learn: 65; SPL: 11; Illu: 0),
    (Score: 16; Lang: 5; Spell: 8; Learn: 70; SPL: 11; Illu: 0),
    (Score: 17; Lang: 6; Spell: 8; Learn: 75; SPL: 14; Illu: 0),
    (Score: 18; Lang: 7; Spell: 9; Learn: 85; SPL: 18; Illu: 0),
    (Score: 19; Lang: 8; Spell: 9; Learn: 95; SPL: 255; Illu: 1),
    (Score: 20; Lang: 9; Spell: 9; Learn: 96; SPL: 255; Illu: 2),
    (Score: 21; Lang: 10; Spell: 9; Learn: 97; SPL: 255; Illu: 3),
    (Score: 22; Lang: 11; Spell: 9; Learn: 98; SPL: 255; Illu: 4),
    (Score: 23; Lang: 12; Spell: 9; Learn: 99; SPL: 255; Illu: 5),
    (Score: 24; Lang: 15; Spell: 9; Learn: 100; SPL: 255; Illu: 6),
    (Score: 25; Lang: 20; Spell: 9; Learn: 100; SPL: 255; Illu: 7)
    );

type
  TWisdomAdj = record
    MagicalDefense: ShortInt;
    SpellBonus: array[0..1] of byte;
    SpellFailure: byte;
  end;

const
  WisdomAdjs: array[1..25] of TWisdomAdj = (
  { 1}(MagicalDefense: - 6; SpellBonus: (0, 0); SpellFailure: 80),
  { 2}(MagicalDefense: - 4; SpellBonus: (0, 0); SpellFailure: 60),
  { 3}(MagicalDefense: - 3; SpellBonus: (0, 0); SpellFailure: 50),
  { 4}(MagicalDefense: - 2; SpellBonus: (0, 0); SpellFailure: 45),
  { 5}(MagicalDefense: - 1; SpellBonus: (0, 0); SpellFailure: 40),
  { 6}(MagicalDefense: - 1; SpellBonus: (0, 0); SpellFailure: 35),
  { 7}(MagicalDefense: - 1; SpellBonus: (0, 0); SpellFailure: 30),
  { 8}(MagicalDefense: 0; SpellBonus: (0, 0); SpellFailure: 25),
  { 9}(MagicalDefense: 0; SpellBonus: (0, 0); SpellFailure: 20),
  {10}(MagicalDefense: 0; SpellBonus: (0, 0); SpellFailure: 15),
  {11}(MagicalDefense: 0; SpellBonus: (0, 0); SpellFailure: 10),
  {12}(MagicalDefense: 0; SpellBonus: (0, 0); SpellFailure: 5),
  {13}(MagicalDefense: 0; SpellBonus: (1, 0); SpellFailure: 0),
  {14}(MagicalDefense: 0; SpellBonus: (1, 0); SpellFailure: 0),
  {15}(MagicalDefense: + 1; SpellBonus: (2, 0); SpellFailure: 0),
  {16}(MagicalDefense: + 2; SpellBonus: (2, 0); SpellFailure: 0),
  {17}(MagicalDefense: + 3; SpellBonus: (3, 0); SpellFailure: 0),
  {18}(MagicalDefense: + 4; SpellBonus: (4, 0); SpellFailure: 0),
// Spell Immunity: cause fear, charm person, command, friends, hypnotism
  {19}(MagicalDefense: + 4; SpellBonus: (1, 3); SpellFailure: 0),
// Spell Immunity: forget, hold person, ray of enfeeblement, scare
  {20}(MagicalDefense: + 4; SpellBonus: (2, 4); SpellFailure: 0),
// Spell Immunity: fear
  {21}(MagicalDefense: + 4; SpellBonus: (3, 4); SpellFailure: 0),
// Spell Immunity: charm monster, confusion, emotion, fumble, suggestion
  {22}(MagicalDefense: + 4; SpellBonus: (4, 5); SpellFailure: 0),
// Spell Immunity: chaos, feeblemind, hold monster, magic jar, quest
  {23}(MagicalDefense: + 4; SpellBonus: (1, 6); SpellFailure: 0),
// Spell Immunity: geas, mass suggestion, rod of rulership
  {24}(MagicalDefense: + 4; SpellBonus: (5, 6); SpellFailure: 0),
// Spell Immunity: antipathy/sympathy, death spell, mass charm
  {25}(MagicalDefense: + 4; SpellBonus: (6, 7); SpellFailure: 0)
    );

type
  TCharismaAdj = record
    Henchmen: byte; // Maximum # of Henchmen
    Loyalty: shortint; // Loyalty Base
    Reaction: shortint; // Reaction Adjustment
  end;

const
  CharismaAdjs: array[1..25] of TCharismaAdj = (
  { 1}(Henchmen: 0; Loyalty: - 8; Reaction: - 7),
  { 2}(Henchmen: 1; Loyalty: - 7; Reaction: - 6),
  { 3}(Henchmen: 1; Loyalty: - 6; Reaction: - 5),
  { 4}(Henchmen: 1; Loyalty: - 5; Reaction: - 4),
  { 5}(Henchmen: 2; Loyalty: - 4; Reaction: - 3),
  { 6}(Henchmen: 2; Loyalty: - 3; Reaction: - 2),
  { 7}(Henchmen: 3; Loyalty: - 2; Reaction: - 1),
  { 8}(Henchmen: 3; Loyalty: - 1; Reaction: 0),
  { 9}(Henchmen: 4; Loyalty: 0; Reaction: 0),
  {10}(Henchmen: 4; Loyalty: 0; Reaction: 0),
  {11}(Henchmen: 4; Loyalty: 0; Reaction: 0),
  {12}(Henchmen: 5; Loyalty: 0; Reaction: 0),
  {13}(Henchmen: 5; Loyalty: 0; Reaction: + 1),
  {14}(Henchmen: 6; Loyalty: + 1; Reaction: + 2),
  {15}(Henchmen: 7; Loyalty: + 3; Reaction: + 3),
  {16}(Henchmen: 8; Loyalty: + 4; Reaction: + 5),
  {17}(Henchmen: 10; Loyalty: + 6; Reaction: + 6),
  {18}(Henchmen: 15; Loyalty: + 8; Reaction: + 7),
  {19}(Henchmen: 20; Loyalty: + 10; Reaction: + 8),
  {20}(Henchmen: 25; Loyalty: + 12; Reaction: + 9),
  {21}(Henchmen: 30; Loyalty: + 14; Reaction: + 10),
  {22}(Henchmen: 35; Loyalty: + 16; Reaction: + 11),
  {23}(Henchmen: 40; Loyalty: + 18; Reaction: + 12),
  {24}(Henchmen: 45; Loyalty: + 20; Reaction: + 13),
  {25}(Henchmen: 50; Loyalty: + 20; Reaction: + 14)
    );

// Step 2: Choose a Race (chapter 2)
type
  TRace = (Human, Elf, HalfElf, Gnome, Halfling, Dwarf);
  TRaces = set of TRace;

  TAbilityRange = record min, max: byte end;

  TSex = (Male, Female);

  TDice = record
    count, faces: byte;
  end;

  THeightAndWeight = record
    Base: array[TSex] of byte;
    Dice: TDice;
  end;

  TAge = record
    Base: byte;
    Dice: TDice;
    Ages: array[1..3] of word;
    Max: TDice;
  end;


const
  RacialAbilityRequirements: array[TRace, TAbility] of TAbilityRange = (
              { Strength       Dexterity      Constitution    Intelligence   Wisdom         Charisma     }
 { Human    }((min: 3; max: 18), (min: 3; max: 18), (min: 3; max: 18), (min: 3; max: 18), (min: 3; max: 18), (min: 3; max: 18)),
 { Elf      }((min: 3; max: 18), (min: 6; max: 18), (min: 7; max: 18), (min: 8; max: 18), (min: 3; max: 18), (min: 8; max: 18)),
 { Half-Elf }((min: 3; max: 18), (min: 6; max: 18), (min: 6; max: 18), (min: 4; max: 18), (min: 3; max: 18), (min: 3; max: 18)),
 { Gnome    }((min: 6; max: 18), (min: 3; max: 18), (min: 8; max: 18), (min: 6; max: 18), (min: 3; max: 18), (min: 3; max: 18)),
 { Halfling }((min: 7; max: 18), (min: 7; max: 18), (min: 10; max: 18), (min: 6; max: 18), (min: 3; max: 17), (min: 3; max: 18)),
 { Dwarf    }((min: 8; max: 18), (min: 3; max: 17), (min: 11; max: 18), (min: 3; max: 18), (min: 3; max: 18), (min: 3; max: 17))
    );

  RacialAbilityAdjustements: array[TRace, TAbility] of ShortInt = (
                { STR DEX CON INT WIS CHA }
  { Human     }(0, 0, 0, 0, 0, 0),
  { Elf       }(0, +1, -1, 0, 0, 0),
  { HalfElf   }(0, 0, 0, 0, 0, 0),
  { Gnome     }(0, 0, 0, +1, -1, 0),
  { Halfling  }(-1, +1, 0, 0, 0, 0),
  { Dwarf     }(0, 0, +1, 0, 0, -1)
    );

  AverageHeight: array[TRace] of THeightAndWeight = (//  Inches
  { Human    }(Base: (60, 59); dice: (count: 2; faces: 10)),
  { Elf      }(Base: (55, 50); dice: (count: 1; faces: 10)),
  { HalfElf  }(Base: (60, 58); dice: (count: 2; faces: 6)),
  { Gnome    }(Base: (38, 36); dice: (count: 1; faces: 6)),
  { Halfling }(Base: (32, 30); dice: (count: 2; faces: 8)),
  { Dwarf    }(Base: (43, 41); dice: (count: 1; faces: 10))
    );

  AverageWeight: array[TRace] of THeightAndWeight = (// Pounds
  { Human    }(Base: (140, 100); dice: (count: 6; faces: 10)),
  { Elf      }(Base: (90, 70); dice: (count: 3; faces: 10)),
  { HalfElf  }(Base: (110, 85); dice: (count: 3; faces: 12)),
  { Gnome    }(Base: (72, 68); dice: (count: 5; faces: 4)),
  { Halfling }(Base: (52, 48); dice: (count: 5; faces: 4)),
  { Dwarf    }(Base: (130, 105); dice: (count: 4; faces: 10))
    );

  Ages: array[TRace] of TAge = (
  { Human    }(base: (15); dice: (count: 1; faces: 4); ages: (45, 60, 90); max: (count: 2; faces: 20)),
  { Elf      }(base: (100); dice: (count: 5; faces: 6); ages: (175, 233, 350); max: (count: 4; faces: 100)),
  { HalfElf  }(base: (15); dice: (count: 1; faces: 6); ages: (62, 83, 125); max: (count: 3; faces: 20)),
  { Gnome    }(base: (60); dice: (count: 3; faces: 12); ages: (100, 133, 200); max: (count: 3; faces: 100)),
  { Hlafling }(base: (20); dice: (count: 3; faces: 4); ages: (50, 67, 100); max: (count: 1; faces: 100)),
  { Dwarf    }(base: (40); dice: (count: 5; faces: 6); ages: (125, 167, 250); max: (count: 2; faces: 100))
    );

  AgingEffects: array[TAbility, 1..3] of shortint = (
  { Strength     }(-1, -2, -1),
  { Dexterity    }(0, -2, -1),
  { Constitution }(-1, -1, -1),
  { Intelligence }(+1, 0, +1),
  { Wisdom       }(+1, +1, +1),
  { Charisma     }(0, 0, 0)
    );

// Step 3: Select a Class (chapter 3)
type
  TClass = (Fighter, Ranger, Paladin, Mage, Cleric, Druid, Thief, Bard);
  TClasses = set of TClass;

  TSchoolOfMagic = (
    generic,
    Abjuration,
    Alteration,
    Conjuration,
    Enchantment,
    Divination,
    Illusion,
    Invocation,
    Necromancy
    );

  TWizardRequirements = record
    Races: TRaces;
    Ability: TAbility;
    Score: byte;
  end;

  TThievingSkill = (
    tsPickPockets,
    tsOpenLocks,
    tsFindRemoveTraps,
    tsMoveSilently,
    tsHideInShadows,
    tsDetectNoise,
    tsClimbWalls,
    tsReadLanguages
    );
  TThievingSkills = array[TThievingSkill] of byte;

  TThievingSkillDexterityAdjustement = record
    score: byte;
    bonus: array[tsPickPockets..tsMoveSilently] of shortint;
  end;

  IsBard = boolean;

const
  Warrior = [Fighter, Ranger, Paladin];
  Wizard = [Mage];
  Priest = [Cleric, Druid];
  Rogue = [Thief, Bard];

  RaceClasses: array[TRace] of TClasses = (
  { Human           }[Fighter, Paladin, Ranger, Mage, Cleric, Druid, Thief, Bard],
  { Elf             }[Fighter, Ranger, Mage, Cleric, Thief],
  { HalfElf         }[Fighter, Ranger, Mage, Cleric, Druid, Thief, Bard],
  { Gnome           }[Fighter, Mage, Cleric, Thief],
  { Halfling        }[Fighter, Cleric, Thief],
  { Dwarf           }[Fighter, Cleric, Thief]
    );

  DualClasses: array[TRace, TClass] of TClasses = (
              {Fighter,Ranger,Paladin,Mage,Cleric, Druid, Thief, Bard }
  { Human    }([], [], [], [], [], [], [], []),
  { Elf      }([Thief, Mage], [], [], [{Fighter,}Thief], [], [], [{Fighter,Mage}], []),
  { HalfElf  }(// de plus, il peut tre tri-class MAGE !
    {Fighter }[Thief, Cleric, Druid, Mage],
    {Ranger  }[Cleric],
    {Paladin }[],
    {Mage    }[{Fighter,}Thief, Cleric],
    {Cleric  }[{Fighter,Ranger,Mage}],
    {Druid   }[{Fighter}],
    {Thief   }[{Fighter,Mage}],
    {Bard    }[]
    ),
  { Gnome    }([Thief, Cleric, Mage], [], [], [{Fighter,Cleric}], [{Fighter,Mage,}Thief], [], [{Fighter,Mage,Cleric}], []),
  { Halfling }([Thief], [], [], [], [], [], [{Fighter}], []),
  { Dward    }([Thief, Cleric], [], [], [], [{Fighter}], [], [{Fighter}], [])
    );

  ClassAbilityMinimums: array[TClass, TAbility] of byte = (
              { STR DEX CON INT WIS CHA }
  { Fighter  }(9, 0, 0, 0, 0, 0),
  { Ranger   }(13, 13, 14, 0, 14, 0),
  { Paladin  }(12, 0, 9, 0, 13, 17),
  { Mage     }(0, 0, 0, 9, 0, 0),
  { Cleric   }(0, 0, 0, 0, 9, 0),
  { Druid    }(0, 0, 0, 0, 12, 15),
  { Thief    }(0, 9, 0, 0, 0, 0),
  { Bard     }(0, 0, 0, 13, 0, 15)
    );

  WizardRequirements: array[TSchoolOfMagic] of TWizardRequirements = (
  { generic     }(Races: [Human, Elf, HalfElf]; Ability: abIntelligence; score: 9), // same as above
  { Abjuration  }(Races: [Human]; Ability: abWisdom; score: 15),
  { Alteration  }(Races: [Human]; Ability: abDexterity; score: 15),
  { Conjuration }(Races: [Human, HalfElf]; Ability: abConstitution; score: 15),
  { Enchantment }(Races: [Human, Elf, HalfElf]; Ability: abCharisma; score: 16),
  { Divination  }(Races: [Human, Elf, HalfElf]; Ability: abWisdom; score: 16),
  { Illusion    }(Races: [Human, Gnome]; Ability: abDexterity; score: 16),
  { Invocation  }(Races: [Human]; Ability: abConstitution; score: 16),
  { Necromancy  }(Races: [Human]; Ability: abWisdom; score: 16)
    );

  ThievingSkillBaseScores: array[TThievingSkill, IsBard] of ShortInt = (
  { Pick Pockets      *}(15, 10),
  { Open Locks         }(10, -1),
  { Find/Remove Traps  }(5, -1),
  { Move Silently      }(10, -1),
  { Hide in Shadows    }(5, -1),
  { Detect Noise      *}(15, 20),
  { Climb Walls       *}(60, 50),
  { Read Languages    *}(0, 5)
    );

  ThievingSkillRacialAdjustements: array[TRace, TThievingSkill] of shortint = (
  { Human    }(0, 0, 0, 0, 0, 0, 0, 0),
  { Elf      }(+5, -5, 0, +5, +10, +15, 0, 0),
  { HalfElf  }(+10, 0, 0, 0, +5, 0, 0, 0),
  { Gnome    }(0, +5, +10, +5, +5, +10, -15, 0),
  { Halfling }(+5, +5, +5, +10, +15, +5, -15, -5),
  { Dward    }(0, +10, +15, 0, 0, 0, -10, -5)
    );

  ThievingSkillDexterityAdjustements: array[0..8] of TThievingSkillDexterityAdjustement = (
    (score: 9; bonus: (-15, -10, -10, -20)),
    (score: 10; bonus: (-10, -5, -10, -15)),
    (score: 11; bonus: (-5, 0, -5, -10)),
    (score: 12; bonus: (0, 0, 0, -5)),
    (score: 13; bonus: (0, 0, 0, 0)),
    (score: 16; bonus: (0, +5, 0, 0)),
    (score: 17; bonus: (+5, +10, 0, +5)),
    (score: 18; bonus: (+10, +15, +5, +10)),
    (score: 19; bonus: (+15, +20, +10, +15))
    );

// Step 4: Choose an Alignment (chapter 4)
type
  TAlignment = (
    LG, NG, CG,
    LN, NN, CN,
    LE, NE, CE
    );
  TAlignments = set of TAlignment;

const
  ClassAlignments: array[TClass] of TAlignments = (
  { Fighter  }[LG, NG, CG, LN, NN, CN, LE, NE, CE],
  { Ranger   }[LG, NG, CG],
  { Paladin  }[LG],
  { Mage     }[LG, NG, CG, LN, NN, CN, LE, NE, CE],
  { Cleric   }[LG, NG, CG, LN, NN, CN, LE, NE, CE],
  { Druid    }[NN],
  { Thief    }[LG, NG, CG, LN, NN, CN, LE, NE, CE],
  { Bard     }[NG, LN, NN, CN, NE]
    );

// Step 5: Record Saving Throws and THAC0 (chapter 9)
// Step 6: Roll Hit Points (chapter 3)
// Step 7: Record Base Movement (chapter 14)
// Step 8: Select Proficiencies (optional, chapter 5)
type
  TProficiencies = record
    Initial: byte;
    PerLevel: byte;
  end;

  TProficiencySlot = record
    Classes: TClasses;
    Weapon: TProficiencies;
    Penality: ShortInt;
    NonWeapon: TProficiencies;
  end;

const
  ProficiencySlots: array[0..3] of TProficiencySlot = (
    (Classes: Warrior; Weapon: (Initial: 4; PerLevel: 3); Penality: - 2; NonWeapon: (Initial: 3; PerLevel: 3)),
    (Classes: Wizard; Weapon: (Initial: 1; PerLevel: 6); Penality: - 5; NonWeapon: (Initial: 4; PerLevel: 3)),
    (Classes: Priest; Weapon: (Initial: 2; PerLevel: 4); Penality: - 3; NonWeapon: (Initial: 4; PerLevel: 3)),
    (Classes: Rogue; Weapon: (Initial: 2; PerLevel: 4); Penality: - 3; NonWeapon: (Initial: 3; PerLevel: 4))
    );

// Step 9: Equip Your Character (chapter 6)
type
  TPiece = (Copper, Silver, Electrum, Gold, Platinium);
  TFunds = record
    Classes: TClasses;
    base: byte;
    dice: TDice;
  end;

const
  InitialFunds: array[0..3] of TFunds = (// *10 GP
    (Classes: Warrior; base: 0; Dice: (count: 5; faces: 4)),
    (Classes: Wizard; base: 1; Dice: (count: 1; faces: 4)),
    (Classes: Priest; base: 0; Dice: (count: 2; faces: 6)),
    (Classes: Rogue; base: 0; Dice: (count: 3; faces: 6))
    );

// Weapons
type
  TWeapon = (
    HandCrossbow, HeavyCrossbow,
    ShortBow, CompositeShortBow, LongBow, CompositeLongBow,
    Staff, Knife, Dagger, Scimitar,
    BastardSword, ShortSword, TwoHandSword,
    MorningStar, FootmansFlail, Club, BattleAxe, Warhammer,
    LanceLegere, LanceLourde,
    StaffSling, Dart, Sling,
    ThrowingAxe, ThrowingKnife
    );
  TWeapons = set of TWeapon;

const
  ClassWeapons: array[TClass] of TWeapons = (
  { Fighter  }[HandCrossbow..ThrowingKnife],
  { Ranger   }[HandCrossbow..ThrowingKnife],
  { Paladin  }[HandCrossbow..ThrowingKnife],
  { Mage     }[Staff..Dagger, Dart..Sling, ThrowingKnife],
  { Cleric   }[Staff, MorningStar, FootmansFlail..Club, Warhammer, Sling],
  { Druid    }[Staff, Dagger, Scimitar, Dart, Sling, Club, ThrowingKnife],
  { Thief    }[HandCrossbow, ShortBow, CompositeShortBow, Staff, Knife, Dagger, ShortSword, Dart, Sling, Club, ThrowingKnife],
  { Bard     }[HandCrossbow..ThrowingKnife]
    );
  ClassWeaponCount: array[TClass] of byte = (4, 4, 4, 1, 2, 2, 2, 2);

implementation

end.
