unit Personnage;

interface
uses windows, Contnrs, Classes, definitions, AdkNETData, HandBook2,
  AdkPathfinder, PathMap;

type

  TCustomPerso = class
  private
    fId: Cardinal;
    fPosition: TR_Position;
    fVisible: Byte;
  protected
    function GetId: Cardinal;
    function GetPosition: Tpoint;
    procedure SetPosition(Value: Tpoint);
    function GetName: string; virtual;
    function GetMapNumber: word;
    procedure SetMapNumber(value: word);
    function GetPositionInfo: TPositionInfo;
    procedure SetPositionInfo(Value: TPositionInfo);
    function GetTRPosition: TR_Position;
    procedure SetTRPosition(Value: TR_Position);
    function GetVisible: byte;
    procedure SetVisible(value: byte);
  public
    procedure Writedata(Datas: TStream); virtual; //renvoie le TStream pass en argument "remplie" avec les donnes
    procedure ReadData(Datas: TStream); virtual;
    //Property
    property ID: cardinal read GetId write FID;
    property Name: string read GetName;
    property Position: Tpoint read GetPosition write SetPosition;
    property PositionInfo: TPositionInfo read GetPositionInfo write SetPositionInfo;
    property TRPosition: TR_Position read GetTRPosition write SetTRPosition;
    property MapNumber: word read GetMapNumber write SetMapNumber;
    property Visible: Byte read GetVisible write SetVisible;
  end;

  TCustomPJPNJ = class(TCustomPerso)
  private
    FDestination: Tr_Pos; // Position finale que veut atteindre notre personnage
    FAMap: TMapFinder; //<< 
    fPathFinder: TADKPathFinder;
    // Var
    fname: string;
    fRace: word;
    fSex: Tsex;
    fInventaire: TTresor;
    fSortsActifs: TSortsEnCour;
    fAlignement: TAlignment;
    fPvMax, fPv: word;
    fResistances: TResistances;
    fXP: Cardinal;
    procedure VideTresor;
    procedure VideSortsEnCour;
  protected
    function GetRace: word;
    procedure SetRace(value: word);
    function GetSex: Tsex;
    procedure SetSex(value: Tsex);
    function GetInventaire: TTresor;
    procedure SetInventaire(Value: TTresor);
    function GetSortsActifs: TSortsEnCour;
    procedure SetSortsActifs(value: TSortsEnCour);
    function GetAlignement: TAlignment;
    procedure SetAlignement(value: TAlignment);
    function GetVitesse: byte; virtual; abstract;
    procedure SetVitesse(Value: Byte); virtual; abstract;
    function GetPvMax: word;
    procedure SetPvMax(value: word);
    function GetPv: word;
    procedure SetPv(value: word);
    function GetResistance(Indice: TResistance): ShortInt;
    procedure SetResistance(Indice: TResistance; Value: ShortInt);
    function GetResistances: TResistances;
    procedure SetResistances(Value: TResistances);
    function GetTaille: word; virtual; abstract;
    procedure SetTaille(value: word); virtual; abstract;
    function GetXp: Cardinal;
    procedure SetXp(value: Cardinal);

    function GetClassArmor: Shortint; virtual; abstract;
    procedure SetClassArmor(value: shortint); virtual; abstract;
    function GetLevel: Word; virtual; abstract;
    function GetThaco: shortint; virtual; abstract;
    procedure SetThaco(value: shortint); virtual; abstract;

    procedure SetIMap(value: TMapFinder);
  public
    constructor create;
    destructor destroy; override;
    function OnDestination: boolean; //SI Le perso est sur sa destination on renvoie true
    procedure Writedata(Datas: TStream); override; //renvoie le TStream pass en argument "remplie" avec les donnes
    procedure ReadData(Datas: TStream); override;
    //Property's
    property Race: word read GetRace write SetRace;
    property Sex: Tsex read GetSex write SetSex;
    property Inventaire: TTresor read GetInventaire write SetInventaire;
    property SortsActifs: TSortsEnCour read GetSortsActifs write SetSortsActifs;
    property Alignement: TAlignment read GetAlignement write SetAlignement;
    property Vitesse: Byte read GetVitesse write SetVitesse;
    property PvMax: Word read GetPvMax write SetPvMax;
    property Pv: Word read GetPv write SetPv;
    property ResistFroid: ShortInt index rsFroid read GetResistance write SetResistance;
    property ResistChaud: ShortInt index rsChaud read GetResistance write SetResistance;
    property ResistMagie: ShortInt index rsMagie read GetResistance write SetResistance;
    property ResistElec: ShortInt index rsElec read GetResistance write SetResistance;
    property ResistPoison: ShortInt index rsPoison read GetResistance write SetResistance;
    property Resistances: TResistances read GetResistances write SetResistances;
    property Taille: word read GetTaille write SetTaille;
    property Xp: Cardinal read GetXp write SetXP;

    //Proprit "spciales"
    property ClassArmor: ShortInt read GetClassArmor write SetClassArmor;
    property Level: word read GetLevel;
    property THACO: Shortint read GetThaco write SetThaco;

    property WalkableMap: TMapFinder read FAMap write SetIMap;
    property PathFinder: TADKPathFinder read fPathFinder;
  end;

  {TpnjPerso}
  TPnjPerso = class(TCustomPJPNJ)
  private
    //fDestination: Tr_Pos; // Position finale que veut atteindre notre personnage
    fArmorClass: ShortInt;
    fVitesse: Byte;
    fInteligence: Byte;
    fDesDeVie: byte;
    fTHACO: ShortInt;
    fTaille: Word;
    fIDMaitre: Cardinal;
    fCurrentStatus: Byte;
    fCycleDiurne: Boolean;
    fRegime: TRegime;
    fNbrAttaque: Byte;
    fdegat: TmaxminByte;
    fAttaqueSpeciale, fDefenseSpeciale: TOneObjet;
    fMoral: Shortint;

    function GetRecordPerso: TPNJMonstre;
    procedure setRecordPerso(Value: TPNJMonstre);
  protected

    function GetVitesse: byte; override;
    procedure SetVitesse(Value: Byte); override;
    function GetTaille: word; override;
    procedure SetTaille(value: word); override;
    function GetInteligence: Byte;
    procedure SetInteligence(value: byte);

    function GetClassArmor: Shortint; override;
    procedure SetClassArmor(value: shortint); override;
    function GetLevel: Word; override;
    function GetThaco: shortint; override;
    procedure SetThaco(value: shortint); override;

  public
    constructor create;
    procedure Writedata(Datas: TStream); override; //renvoie le TStream pass en argument "remplie" avec les donnes
    procedure ReadData(Datas: TStream); override;
    //Property's
    property RecordPerso: TPNJMonstre read GetRecordPerso write SetRecordPerso;
    property Inteligence: Byte read GetInteligence write SetInteligence;
  end;

  {TPjPerso}
  TPjPerso = class(TCustomPJPNJ)
  private
    //FRecordPerso: TPersonnage;
    //FDestination: Tr_Pos; // Position finale que veut atteindre notre personnage
    fPassword: string;
    fScores: TAbilities;
    fExStrength: byte;
    fTaille: Word;
    fPoids: word;
    fAge, fMaxAge: word;
    fClasses: TClasses;
    fMagicSchool: TSchoolOfMagic;
    fThievingSkills: TThievingSkills;
    fPieces: Cardinal;
    fCompetences: TListCompetences;
    fCompsLevels: Tcomplevel;
    fPlacePierres: T3Pierres;
    fSaoul, fEtat, fFatigue: ShortInt;
    fmuet, fSourd, fParalyser, fMarche, fGeler: boolean;
    fLangues: TLanguesExtended;
    fPointsRestants: TPointsRestants;
    fDieu: Cardinal;
    fRang: byte;
    fLivreSorts: TSortsConnus;
    fMana: Cardinal;// Mago

    function GetRecordPerso: TPersonnage;
    procedure SetRecordPerso(Value: TPersonnage);
  protected
    function GetName: string; override;
    procedure SetName(value: string);
    function GetVitesse: byte; override;
    procedure SetVitesse(Value: Byte); override;
    function GetTaille: word; override;
    procedure SetTaille(value: word); override;
    function GetPassword: string;
    procedure SetPassword(value: string);
    function GetScores: TAbilities;
    procedure SetScores(Value: TAbilities);
    function GetScore(Indice: TAbility): byte;
    procedure SetScore(Indice: TAbility; Value: byte);
    function GetExStrength: byte;
    procedure SetExStrength(value: byte);
    function GetPoids: word;
    procedure SetPoids(value: word);
    function GetAge: word;
    procedure SetAge(value: word);
    function GetMaxAge: word;
    procedure SetMaxAge(value: word);
    function GetClasses: TClasses;
    procedure SetClasses(value: TClasses);
    function GetMagicSchool: TSchoolOfMagic;
    procedure SetMagicSchool(Value: TSchoolOfMagic);
    function GetThievingSkills: TThievingSkills;
    procedure SetThievingSkills(value: TThievingSkills);
    function GetThievingSkill(indice: TThievingSkill): byte;
    procedure SetThievingSkill(indice: TThievingSkill; value: byte);
    function GetPieces: Cardinal;
    procedure SetPieces(value: Cardinal);
    function GetCompetences: TListCompetences;
    procedure SetCompetences(value: TListCompetences);
    function GetPlacePierres: T3Pierres;
    procedure SetPlacePierres(value: T3Pierres);
    function GetSaoul: ShortInt;
    procedure SetSaoul(value: ShortInt);
    function GetEtat: ShortInt;
    procedure SetEtat(value: ShortInt);
    function GetFatigue: ShortInt;
    procedure SetFatigue(value: ShortInt);
    function GetBlocages(indice: integer): boolean;
    procedure SetBlocages(indice: integer; value: boolean);
    function GetDieu: cardinal;
    procedure SetDieu(value: Cardinal);
    function GetRang: byte;
    procedure SetRang(value: byte);
    function GetLangues: TLanguesExtended;
    procedure SetLangues(value: TLanguesExtended);
    function GetPointsRestants: TPointsRestants;
    procedure SetPointsRestants(value: TPointsRestants);
    function GetPointRestant(indice: TPointRestant): byte;
    procedure SetPointRestant(indice: TPointRestant; value: byte);
    function GetLivreSorts: TSortsConnus;
    procedure SetLivreSorts(value: TSortsConnus);
    function GetMana: Cardinal;
    procedure SetMana(value: cardinal);


    // Methodes "ala vole"
    function GetClassArmor: Shortint; override;
    procedure SetClassArmor(value: shortint); override;
    function GetLevel: Word; override;
    function GetThaco: shortint; override;
    procedure SetThaco(value: shortint); override;
  public
    constructor create;
    destructor destroy; override;
    procedure Writedata(Datas: TStream); override; //renvoie le TStream pass en argument "remplie" avec les donnes
    procedure ReadData(Datas: TStream); override;
    procedure VidePointsRestants;
    // Property's
    property RecordPerso: TPersonnage read GetRecordPerso write SetRecordPerso;
    property Name: string read GetName write SetName;
    property Password: string read GetPassword write SetPassword;
    property Scores: TAbilities read GetScores write SetScores;
    property Strength: byte index abStrength read GetScore write SetScore;
    property Dexterity: byte index abDexterity read GetScore write SetScore;
    property Constitution: byte index abConstitution read GetScore write SetScore;
    property Intelligence: byte index abIntelligence read GetScore write SetScore;
    property Wisdom: byte index abWisdom read GetScore write SetScore;
    property Charisma: byte index abCharisma read GetScore write SetScore;
    property ExStrength: byte read GetExStrength write SetExStrength;
    property Poids: word read GetPoids write SetPoids;
    property Age: word read GetAge write SetAge;
    property MaxAge: word read GetMaxAge write SetMaxAge;
    property Classes: TClasses read GetClasses write SetClasses;
    property MagicSchool: TSchoolOfMagic read GetMagicSchool write SetMagicSchool;
    property ThievingSkills: TThievingSkills read GetThievingSkills write SetThievingSkills;
    property PickPockets: byte index tsPickPockets read GetThievingSkill write SetThievingSkill;
    property OpenLocks: byte index tsOpenLocks read GetThievingSkill write SetThievingSkill;
    property FindRemoveTraps: byte index tsFindRemoveTraps read GetThievingSkill write SetThievingSkill;
    property MoveSilently: byte index tsMoveSilently read GetThievingSkill write SetThievingSkill;
    property HideInShadows: byte index tsHideInShadows read GetThievingSkill write SetThievingSkill;
    property DetectNoise: byte index tsDetectNoise read GetThievingSkill write SetThievingSkill;
    property ClimbWalls: byte index tsClimbWalls read GetThievingSkill write SetThievingSkill;
    property ReadLanguages: byte index tsReadLanguages read GetThievingSkill write SetThievingSkill;
    property Pieces: Cardinal read GetPieces write SetPieces;
    property Competences: TListCompetences read GetCompetences write SetCompetences;
    property PlacePierres: T3Pierres read GetPlacePierres write SetPlacePierres;
    property Saoul: ShortInt read GetSaoul write SetSaoul;
    property Etat: ShortInt read GetEtat write SetEtat;
    property fatigue: ShortInt read Getfatigue write Setfatigue;
    property Muet: Boolean index 0 read GetBlocages write SetBlocages;
    property Sourd: Boolean index 1 read GetBlocages write SetBlocages;
    property Paralyser: Boolean index 2 read GetBlocages write SetBlocages;
    property Marche: Boolean index 3 read GetBlocages write SetBlocages;
    property Geler: Boolean index 4 read GetBlocages write SetBlocages;
    property Dieu: Cardinal read GetDieu write SetDieu;
    property Rang: Byte read GetRang write SetRang;
    property Langues: TLanguesExtended read GetLangues write SetLangues;
    property PointsRestants: TPointsRestants read GetPointsRestants write SetPointsRestants;
    property PointsLangue: byte index prLangue read GetPointRestant write SetPointRestant;
    property PointsVol: byte index prVol read GetPointRestant write SetPointRestant;
    property PointsCompArme: byte index prCompArme read GetPointRestant write SetPointRestant;
    property PointsSpecialisation: byte index prSpecialisation read GetPointRestant write SetPointRestant;
    property PointsComp1: byte index prComp1 read GetPointRestant write SetPointRestant;
    property PointsComp2: byte index prComp2 read GetPointRestant write SetPointRestant;
    property LivreSorts: TSortsConnus read GetLivreSorts write SetLivreSorts;
    property Mana: Cardinal read GetMana write SetMana;

  end;

  TonNotifyPerso = procedure(Sender: TObject; Value: TCustomPerso) of object; //<< Notification de personnage
  TPersosComplets = class;


  {TListPerso}
  TListPerso = class(Tobjectlist)
  private
    FItemIndex: integer;
    FOnAdd, FOnDelete: TonNotifyPerso;
    FParent: TPersosComplets;
    procedure SetItemIndex(const Value: integer);
  protected
    function GetItems(Index: Integer): TCustomPerso;
    procedure SetItems(Index: Integer; ACustomPerso: TCustomPerso);
    function GetIndexByName(Name: string): integer; // Index du personnage dans la liste. -1 si perso n'existe pas
    property ItemIndex: integer read FItemIndex write SetItemIndex;
  public
    constructor create;
    function Add(aCustomPerso: TCustomPerso): Integer;
    function Remove(aCustomPerso: TCustomPerso): Integer;
    function IndexOf(aCustomPerso: TCustomPerso): Integer;
    function GetPersoByName(name: string): TCustomPerso;
    function GetPersoByID(Id: Cardinal): TCustomPerso;

    procedure Insert(Index: Integer; aCustomPerso: TCustomPerso);
    procedure clear; override;
    procedure Delete(Index: Integer);
    procedure DeleteByID(const Id: Cardinal);
    property Parent: TPersosComplets read FParent write FParent;
    property Items[Index: Integer]: TCustomPerso read GetItems write SetItems; default;
    //Events
    property OnAdd: TonNotifyPerso read FOnAdd write FOnAdd; //<< Appel juste aprs l'ajout du perso
    property OnDelete: TonNotifyPerso read FOnDelete write FOnDelete; //<< Appel juste AVANT l'effacement du perso
    //property OnChangeIndex: TonNotifyPerso read FOnChangeIndex write FOnChangeIndex;
  end;

  TPersosComplets = class(Tcomponent)
  private
    FListPerso: TListPerso;
    FOnAdd, FOnDelete, FOnChangeIndex: TonNotifyPerso;
  protected
    function GetPersoActif: TCustomPerso;
    procedure AddedPerso(Sender: TObject; Value: TCustomPerso);
    procedure DeletedPerso(Sender: TObject; Value: TCustomPerso);
  public
    procedure ActivePersoByName(name: string);
    function ActivePersoByID(ID: Cardinal): boolean;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function GetPerso(name: string): TCustomPerso; overload; // Renvoie le perso qui a le nom "Name" (Nil si peso n'xiste pas)
    function GetPerso(Id: Cardinal): TCustomPerso; overload; // Renvoie le perso qui a l'ID "ID" (Nil si peso n'xiste pas)
    function GetIndexByName(Name: string): integer; // Index du personnage dans la liste. -1 si perso n'existe pas
    function count: integer;
    property ListPerso: TListPerso read FListPerso write FListPerso;
    property PersoActif: TCustomPerso read GetPersoActif; // Perso que l'on dirige
  published
    //Events
    property OnAdd: TonNotifyPerso read FOnAdd write FOnAdd;
    property OnDelete: TonNotifyPerso read FOnDelete write FOnDelete;
    property OnChangePerso: TonNotifyPerso read FOnChangeIndex write FOnChangeIndex;
  end;

procedure Register;


implementation
uses Sysutils, strStuff;



procedure Register;
begin
  RegisterComponents('MiniChat', [TPersosComplets]);
end;



{ TCustomPerso }

procedure TCustomPerso.ReadData(Datas: TStream);
begin
  Datas.position:= 0; //<< Normalement pas utile mais on ne sait jamais.
  with Datas do begin
    ReadBuffer(fId, sizeof(fId));
    ReadBuffer(fPosition, sizeof(fPosition));
    ReadBuffer(fVisible, sizeof(fVisible));
  end;
end;

procedure TCustomPerso.Writedata(Datas: TStream);
begin
  Datas.position:= 0; //<< Normalement pas utile mais on ne sait jamais.
  with Datas do begin
    WriteBuffer(fId, sizeof(fId));
    WriteBuffer(fPosition, sizeof(fPosition));
    WriteBuffer(fVisible, sizeof(fVisible));
  end;
end;

function TCustomPerso.GetId: Cardinal;
begin
  result:= FID;
end;

function TCustomPerso.GetPosition: Tpoint;
begin
  result:= Point(fPosition.xyz.x, fPosition.xyz.y);
end;

procedure TCustomPerso.SetPosition(Value: Tpoint);
begin
  with fPosition.xyz do begin
    if (x <> Value.x) or (y <> Value.y) then begin
      fPosition.xyz.x:= Value.x;
      fPosition.xyz.y:= Value.y;
    end;
  end;
end;

function TCustomPerso.GetName: string;
begin
  result:= 'La fonction GetName de base ne renvoit pas de nom ou mot utilisable pour dsign un lment';
end;

function TCustomPerso.GetMapNumber: word;
begin
  result:= FPosition.map;
end;

procedure TCustomPerso.SetMapNumber(value: word);
begin
  if FPosition.map <> Value then begin
    FPosition.map:= Value;
  end;
end;

function TCustomPerso.GetPositionInfo: TPositionInfo;
begin
  result.x:= fPosition.xyz.x;
  result.y:= fPosition.xyz.y;
  result.map:= fPosition.Map;
end;

procedure TCustomPerso.SetPositionInfo(Value: TPositionInfo);
begin
  with FPosition do begin
    if (xyz.x <> Value.x) or (xyz.y <> Value.y) or (map <> Value.map) then begin
      xyz.x:= Value.x;
      xyz.y:= Value.y;
      Map:= Value.map;
    end;
  end;
end;

function TCustomPerso.GetTRPosition: TR_Position;
begin
  result:= FPosition;
end;

procedure TCustomPerso.SetTRPosition(Value: TR_Position);
begin
  FPosition:= VAlue;
end;

function TCustomPerso.GetVisible: byte;
begin
  result:= fVisible;
end;

procedure TCustomPerso.SetVisible(value: byte);
begin
  if fVisible <> Value then begin
    fvisible:= value;
  end;
end;

{TCustomPJPNJ}

constructor TCustomPJPNJ.create;
begin
  inherited;
  {$ifdef notserver}
  fPathFinder:= TAdkPathFinder.Create(nil);
  {$endif}
end;

destructor TCustomPJPNJ.destroy;
begin
  {$ifdef notserver}
  fPathFinder.Free;
  {$endif}  
  finalize(fInventaire);
  finalize(fSortsActifs);
  inherited;
end;

function TCustomPJPNJ.OnDestination: boolean; //Renvoie TRUE si le perso est sur FDestination
begin
  result:= (FDestination.x = Position.x) and (FDestination.y = Position.y);
end;

procedure TCustomPJPNJ.ReadData(Datas: TStream);
var LenArray: ShortInt;
  i: shortInt;
begin
  inherited;
  with Datas do begin
    fname:= ReadBufferString(Datas);
    ReadBuffer(fRace, sizeof(fRace));
    ReadBuffer(fSex, sizeof(fSex));
    ReadBuffer(LenArray, sizeof(LenArray));
    if LenArray > -1 then begin
      SetLength(fInventaire, lenArray + 1);
      for i:= 0 to LenArray do
        ReadBuffer(fInventaire[i], sizeof(TOneObjet));
    end;
    ReadBuffer(LenArray, sizeof(LenArray));
    if LenArray > -1 then begin
      SetLength(fSortsActifs, lenArray + 1);
      for i:= 0 to LenArray do
        ReadBuffer(fSortsActifs[i], sizeof(TActiveSort));
    end;
    ReadBuffer(fAlignement, sizeof(fAlignement));
    ReadBuffer(fPvMax, sizeof(fPvMax));
    ReadBuffer(fPv, sizeof(fPv));
    ReadBuffer(fResistances, sizeof(fResistances));
    ReadBuffer(fXP, sizeof(fXP));
  end;
end;

procedure TCustomPJPNJ.Writedata(Datas: TStream);
var LenArray: ShortInt;
  i: shortint;
begin
  inherited;
  with Datas do begin
    WriteBufferString(Datas, fname);
    WriteBuffer(fRace, sizeof(fRace));
    WriteBuffer(fSex, sizeof(fSex));
    LenArray:= high(fInventaire);
    WriteBuffer(LenArray, sizeof(LenArray));
    if LenArray > -1 then
      for i:= 0 to LenArray do
        WriteBuffer(fInventaire[i], sizeof(TOneObjet));
    LenArray:= high(fSortsActifs);
    WriteBuffer(LenArray, sizeof(LenArray));
    if LenArray > -1 then
      for i:= 0 to LenArray do
        WriteBuffer(fSortsActifs[i], sizeof(TActiveSort));
    WriteBuffer(fAlignement, sizeof(fAlignement));
    WriteBuffer(fPvMax, sizeof(fPvMax));
    WriteBuffer(fPv, sizeof(fPv));
    WriteBuffer(fResistances, sizeof(fResistances));
    WriteBuffer(fXP, sizeof(fXP));
  end;
end;

function TCustomPJPNJ.GetRace: word;
begin
  result:= fRace;
end;

procedure TCustomPJPNJ.SetRace(value: word);
begin
  if value <> FRace then begin
    fRace:= Value;
  end;
end;

function TCustomPJPNJ.GetSex: Tsex;
begin
  result:= FSex;
end;

procedure TCustomPJPNJ.SetSex(value: Tsex);
begin
  if FSex <> Value then begin
    FSex:= Value;
  end;
end;

function TCustomPJPNJ.GetInventaire: TTresor;
begin
  result:= fInventaire;
//  for i:= Low(fInventaire) to high(fInventaire) do
//    result[i]:= fInventaire[i];
end;

procedure TCustomPJPNJ.VideTresor;
var i: byte;
begin
  for i:= Low(fInventaire) to high(fInventaire) do begin
    fInventaire[i].IdObjet:= 0;
    fInventaire[i].Emplacement:= emNone;
    fInventaire[i].Pv:= 0;
    fInventaire[i].Identifier:= False;
    fInventaire[i].R1:= 0;
  end;
end;

procedure TCustomPJPNJ.SetInventaire(Value: TTresor);
begin
  VideTresor;
  fInventaire:= Value;
//  for i:= Low(Value) to high(Value) do
//   fInventaire[i]:= value[i];
end;

function TCustomPJPNJ.GetSortsActifs: TSortsEnCour;
begin
  result:= fSortsActifs;
//  for i:= Low(fSortsActifs) to high(fSortsActifs) do
//    result[i]:= fSortsActifs[i];
end;

procedure TCustomPJPNJ.VideSortsEnCour;
var i: shortint;
begin
  for i:= Low(fSortsActifs) to high(fSortsActifs) do begin
    fSortsActifs[i].IdObjet:= 0;
    fSortsActifs[i].TimeRemaining:= 0;
  end;
end;

procedure TCustomPJPNJ.SetSortsActifs(value: TSortsEnCour);
begin
  VideSortsEnCour;
  finalize(fSortsActifs);
  fSortsActifs:= Value;

//  for i:= Low(value) to high(Value) do
//    fSortsActifs[i]:= Value[i];
end;

function TCustomPJPNJ.GetAlignement: TAlignment;
begin
  result:= FAlignement;
end;

procedure TCustomPJPNJ.SetAlignement(value: TAlignment);
begin
  if FAlignement <> Value then begin
    FAlignement:= Value;
  end;
end;

function TCustomPJPNJ.GetPvMax: word;
begin
  result:= FPvMax;
end;

procedure TCustomPJPNJ.SetPvMax(value: word);
begin
  if FPvMax <> Value then begin
    FPvMax:= value;
  end;
end;

function TCustomPJPNJ.GetPv: word;
begin
  result:= FPv;
end;

procedure TCustomPJPNJ.SetPv(value: word);
begin
  if FPv <> Value then begin
    FPv:= value;
  end;
end;

function TCustomPJPNJ.GetResistance(Indice: TResistance): ShortInt;
begin
  result:= FResistances[Indice];
end;

procedure TCustomPJPNJ.SetResistance(Indice: TResistance; Value: ShortInt);
begin
  if FResistances[Indice] <> Value then begin
    FResistances[Indice]:= Value;
  end;
end;

function TCustomPJPNJ.GetResistances: TResistances;
begin
  result:= fResistances;
end;

procedure TCustomPJPNJ.SetResistances(Value: TResistances);
var i: shortint;
begin
  for i:= ord(rsFroid) to ord(rsPoison) do
    SetResistance(TResistance(i), Value[TResistance(i)]);
end;

function TCustomPJPNJ.GetXp: Cardinal;
begin
  result:= FXp;
end;

procedure TCustomPJPNJ.SetXp(value: Cardinal);
begin
  if FXp <> Value then begin
    FXp:= Value;
  end;
end;

procedure TCustomPJPNJ.SetIMap(value: TMapFinder);
begin
  fAmap:= value;
  {#todo 1 Je ne suis pas sur que cela sois bon}
  if assigned(fPathFinder) then fPathFinder.Map:= fAmap;
end;


{ TPNJPerso}

constructor TPnjPerso.create;
begin
  //SetLength(fInventaire, MaxInvPnJ + 1);
  //SetLength(fSortsActifs, MaxSortEncourPnJ + 1);
  inherited;
end;

procedure TPnjPerso.ReadData(Datas: TStream);
begin
  inherited;
  with Datas do begin
    ReadBuffer(fArmorClass, sizeof(fArmorClass));
    ReadBuffer(fInteligence, sizeof(fInteligence));
    ReadBuffer(fVitesse, sizeof(fVitesse));
    ReadBuffer(fDesDeVie, sizeof(fDesDeVie));
    ReadBuffer(fTHACO, sizeof(fTHACO));
    ReadBuffer(fTaille, sizeof(fTaille));
    ReadBuffer(fIDMaitre, sizeof(fIDMaitre));
    ReadBuffer(fCurrentStatus, sizeof(fCurrentStatus));
    ReadBuffer(fCycleDiurne, sizeof(fCycleDiurne));
    ReadBuffer(fRegime, sizeof(fRegime));
    ReadBuffer(fNbrAttaque, sizeof(fNbrAttaque));
    ReadBuffer(fdegat, sizeof(fdegat));
    ReadBuffer(fAttaqueSpeciale, sizeof(fAttaqueSpeciale));
    ReadBuffer(fDefenseSpeciale, sizeof(fDefenseSpeciale));
    ReadBuffer(fMoral, sizeof(fMoral));
  end;
end;

procedure TPnjPerso.Writedata(Datas: TStream);
begin
  inherited;
  with Datas do begin
    WriteBuffer(fArmorClass, sizeof(fArmorClass));
    WriteBuffer(fInteligence, sizeof(fInteligence));
    WriteBuffer(fVitesse, sizeof(fVitesse));
    WriteBuffer(fDesDeVie, sizeof(fDesDeVie));
    WriteBuffer(fTHACO, sizeof(fTHACO));
    WriteBuffer(fTaille, sizeof(fTaille));
    WriteBuffer(fIDMaitre, sizeof(fIDMaitre));
    WriteBuffer(fCurrentStatus, sizeof(fCurrentStatus));
    WriteBuffer(fCycleDiurne, sizeof(fCycleDiurne));
    WriteBuffer(fRegime, sizeof(fRegime));
    WriteBuffer(fNbrAttaque, sizeof(fNbrAttaque));
    WriteBuffer(fdegat, sizeof(fdegat));
    WriteBuffer(fAttaqueSpeciale, sizeof(fAttaqueSpeciale));
    WriteBuffer(fDefenseSpeciale, sizeof(fDefenseSpeciale));
    WriteBuffer(fMoral, sizeof(fMoral));
  end;
end;

function TPnjPerso.GetRecordPerso: TPNJMonstre;
var i: shortint;
begin
  result.id:= fID;
  result.IDMaitre:= fIDMaitre;
  result.CurrentStatus:= fCurrentStatus;
  result.Visible:= fVisible;
  result.Position:= fPosition;
  result.Race:= fRace;
  result.Sex:= fSex;
  result.CycleDiurne:= fCycleDiurne;
  result.Regime:= fRegime;
  result.Inteligence:= fInteligence;
  // "Vider" Inventaire
  for i:= 0 to high(result.tresor) do begin
    result.tresor[i].IdObjet:= 0;
    result.tresor[i].Emplacement:= emNone;
    result.tresor[i].Pv:= 0;
    result.tresor[i].Identifier:= false;
    result.tresor[i].R1:= 0; // Nombre d'objet (7 potions de soins par exemple)
  end;
  for i:= Low(fInventaire) to high(fInventaire) do result.Tresor[i]:= fInventaire[i];
  //"Vider" Sorts Actifs
  for i:= 0 to high(result.SortsActifs) do begin
    result.SortsActifs[i].IdObjet:= 0; // N d'identification de l'objet actif
    result.SortsActifs[i].TimeRemaining:= 0;
  end;
  for i:= Low(fSortsActifs) to high(fSortsActifs) do result.SortsActifs[i]:= fSortsActifs[i];
  result.Alignement:= fAlignement;
  result.ArmorClass:= fArmorClass;
  result.Vitesse:= fVitesse;
  result.DesDeVie:= fDesDeVie;
  result.PvMax:= fPvMax;
  result.PvCourant:= fPv;
  result.THACO:= fTHACO;
  result.NbrAttaque:= fNbrAttaque;
  result.Degat:= fDegat;
  result.AttaqueSpeciale:= fAttaqueSpeciale;
  result.DefenseSpeciale:= fDefenseSpeciale;
  result.Resistances:= fResistances;
  result.Taille:= fTaille;
  result.Moral:= fMoral;
  result.XPValue:= fXP;
  // R1 et R2 pas fait puisque pour l'instant je ne les ai pas attribu
end;

procedure TPnjPerso.SetRecordPerso(Value: TPNJMonstre);
var i: shortint;
begin
  fID:= value.ID;
  fIDMaitre:= value.IDMaitre;
  fCurrentStatus:= value.CurrentStatus;
  fPosition:= value.Position;
  fRace:= value.Race;
  fSex:= value.Sex;
  fCycleDiurne:= value.CycleDiurne;
  fRegime:= value.Regime;
  fInteligence:= value.Inteligence;
  // "Vider" Inventaire
  for i:= 0 to high(value.tresor) do begin
    value.tresor[i].IdObjet:= 0;
    value.tresor[i].Emplacement:= emNone;
    value.tresor[i].Pv:= 0;
    value.tresor[i].Identifier:= false;
    value.tresor[i].R1:= 0; // Nombre d'objet (7 potions de soins par exemple)
  end;
  for i:= Low(fInventaire) to high(fInventaire) do fInventaire[i]:= value.Tresor[i];
  //"Vider" Sorts Actifs
  for i:= 0 to high(value.SortsActifs) do begin
    value.SortsActifs[i].IdObjet:= 0; // N d'identification de l'objet actif
    value.SortsActifs[i].TimeRemaining:= 0;
  end;
  for i:= Low(fSortsActifs) to high(fSortsActifs) do fSortsActifs[i]:= value.SortsActifs[i];
  fAlignement:= value.Alignement;
  fArmorClass:= value.ArmorClass;
  fVitesse:= value.Vitesse;
  fDesDeVie:= value.DesDeVie;
  fPvMax:= value.PvMax;
  fPv:= value.PvCourant;
  fTHACO:= value.THACO;
  fNbrAttaque:= value.NbrAttaque;
  fDegat:= value.Degat;
  fAttaqueSpeciale:= value.AttaqueSpeciale;
  fDefenseSpeciale:= value.DefenseSpeciale;
  fResistances:= value.Resistances;
  fTaille:= value.Taille;
  fMoral:= value.Moral;
  fXP:= value.XPValue;
end;

(*
procedure TPnjPerso.setFRecordPerso(const Value: TPNJMonstre);
begin
  FRecordPerso:= Value;
  //Id:=  l'ID des PNJ Mosntres est ralis par le serveur  leur cration
  FDestination:= FRecordPerso.Position.xyz;
end;
*)

function TPnjPerso.GetClassArmor: Shortint;
begin
  result:= FArmorClass;
end;

procedure TPnjPerso.SetClassArmor(value: shortint);
begin
  if FArmorClass <> Value then begin
    FArmorClass:= value;
  end;
end;

function TPnjPerso.GetInteligence: Byte;
begin
  result:= FInteligence;
end;

procedure TPnjPerso.SetInteligence(value: byte);
begin
  if FInteligence <> Value then begin
    FInteligence:= Value;
  end;
end;

function TPnjPerso.GetVitesse: byte;
begin
  result:= FVitesse;
end;

procedure TPnjPerso.SetVitesse(Value: Byte);
begin
  if FVitesse <> Value then begin
    FVitesse:= value;
  end;
end;

function TPnjPerso.GetLevel: Word;
begin
  result:= FDesDeVie;
end;

function TPnjPerso.GetThaco: shortint;
begin
  result:= FTHACO;
end;

procedure TPnjPerso.SetThaco(value: shortint);
begin
  if FTHACO <> Value then begin
    FTHACO:= value;
  end;
end;

function TPnjPerso.GetTaille: word;
begin
  result:= FTaille;
end;

procedure TPnjPerso.SetTaille(value: word);
begin
  if FTaille <> Value then begin
    FTaille:= value;
  end;
end;


{ TPJPerso}

constructor TPjPerso.create;
begin
//  SetLength(fInventaire, MaxInvPJ + 1);
//  SetLength(fSortsActifs, MaxSortEncourPJ + 1);
  inherited;
end;

destructor TPjPerso.destroy;
begin
  finalize(fCompsLevels);
  inherited;
end;

procedure TPjPerso.ReadData(Datas: TStream);
var LenArray: ShortInt;
  i: shortint;
begin
  inherited;
  with Datas do begin
    fPassword:= ReadBufferString(Datas);
    ReadBuffer(fScores, sizeof(fScores));
    ReadBuffer(fExStrength, sizeof(fExStrength));
    ReadBuffer(fTaille, sizeof(fTaille));
    ReadBuffer(fPoids, sizeof(fPoids));
    ReadBuffer(fAge, sizeof(fAge));
    ReadBuffer(fMaxAge, sizeof(fMaxAge));
    ReadBuffer(fClasses, sizeof(fClasses));
    if (Mage in fClasses) then
      ReadBuffer(fMagicSchool, sizeof(fMagicSchool))
    else fMagicSchool:= generic;
    if (Bard in FClasses) or (Thief in FClasses) then
      ReadBuffer(fThievingSkills, sizeof(fThievingSkills))
    else
      for i:= ord(PickPockets) to ord(ReadLanguages) do
        fThievingSkills[TThievingSkill(i)]:= 0;
    ReadBuffer(fPieces, sizeof(fPieces));
    ReadBuffer(fCompetences, sizeof(fCompetences));
    ReadBuffer(LenArray, sizeof(LenArray));
    if LenArray > -1 then begin
      SetLength(fCompsLevels, lenArray + 1);
      for i:= 0 to LenArray do
        ReadBuffer(fCompsLevels[i], sizeof(TCompByLevel));
    end;
    ReadBuffer(fPlacePierres, sizeof(fPlacePierres));
    ReadBuffer(fSaoul, sizeof(fSaoul));
    ReadBuffer(fEtat, sizeof(fEtat));
    ReadBuffer(fFatigue, sizeof(fFatigue));
    ReadBuffer(fmuet, sizeof(fmuet));
    ReadBuffer(fSourd, sizeof(fSourd));
    ReadBuffer(fParalyser, sizeof(fParalyser));
    ReadBuffer(fMarche, sizeof(fMarche));
    ReadBuffer(fGeler, sizeof(fGeler));
    ReadBuffer(fLangues, sizeof(fLangues));
    ReadBuffer(fPointsRestants, sizeof(fPointsRestants));
    ReadBuffer(fDieu, sizeof(fDieu));
    ReadBuffer(fRang, sizeof(fRang));
    LenArray:= high(fLivreSorts);
    WriteBuffer(LenArray, sizeof(LenArray));
    if LenArray > -1 then begin
      for i:= 0 to LenArray do
        WriteBuffer(fLivreSorts[i], sizeof(Cardinal));
    end;
    WriteBuffer(fmana, sizeof(fmana));
    
  end;
end;

procedure TPjPerso.Writedata(Datas: TStream);
var LenArray: ShortInt;
  i: shortint;
begin
  inherited;
  with Datas do begin
    WriteBufferString(Datas, fPassword);
    WriteBuffer(fScores, sizeof(fScores));
    WriteBuffer(fExStrength, sizeof(fExStrength));
    WriteBuffer(fTaille, sizeof(fTaille));
    WriteBuffer(fPoids, sizeof(fPoids));
    WriteBuffer(fAge, sizeof(fAge));
    WriteBuffer(fMaxAge, sizeof(fMaxAge));
    WriteBuffer(fClasses, sizeof(fClasses));
    if (Mage in fClasses) then
      WriteBuffer(fMagicSchool, sizeof(fMagicSchool));
    if (Bard in FClasses) or (Thief in FClasses) then
      WriteBuffer(fThievingSkills, sizeof(fThievingSkills));
    WriteBuffer(fPieces, sizeof(fPieces));
    WriteBuffer(fCompetences, sizeof(fCompetences));
    LenArray:= high(fCompsLevels);
    WriteBuffer(LenArray, sizeof(LenArray));
    if LenArray > -1 then begin
      for i:= 0 to LenArray do
        WriteBuffer(fCompsLevels[i], sizeof(TCompByLevel));
    end;
    WriteBuffer(fPlacePierres, sizeof(fPlacePierres));
    WriteBuffer(fSaoul, sizeof(fSaoul));
    WriteBuffer(fEtat, sizeof(fEtat));
    WriteBuffer(fFatigue, sizeof(fFatigue));
    WriteBuffer(fmuet, sizeof(fmuet));
    WriteBuffer(fSourd, sizeof(fSourd));
    WriteBuffer(fParalyser, sizeof(fParalyser));
    WriteBuffer(fMarche, sizeof(fMarche));
    WriteBuffer(fGeler, sizeof(fGeler));
    WriteBuffer(fLangues, sizeof(fLangues));
    WriteBuffer(fPointsRestants, sizeof(fPointsRestants));
    WriteBuffer(fDieu, sizeof(fDieu));
    WriteBuffer(fRang, sizeof(fRang));
    LenArray:= high(fLivreSorts);
    WriteBuffer(LenArray, sizeof(LenArray));
    if LenArray > -1 then begin
      for i:= 0 to LenArray do
        WriteBuffer(fLivreSorts[i], sizeof(Cardinal));
    end;
    WriteBuffer(fmana, sizeof(fmana));
  end;
end;

function TPjPerso.GetRecordPerso: TPersonnage;
var i: shortint;
begin
  with result do begin
    CaractAdd.Name:= fname;
    CaractAdd.Password:= fPassword;
    CaractAdd.Scores:= fScores;
    CaractAdd.ExStrength:= fExStrength;
    CaractAdd.Race:= Trace(fRace);
    CaractAdd.Sex:= fSex;
    CaractAdd.Height:= fTaille;
    CaractAdd.Weight:= fPoids;
    CaractAdd.Age:= fAge;
    CaractAdd.MaxAge:= fMaxAge;
    CaractAdd.Classes:= fClasses;
    CaractAdd.MagicSchool:= fMagicSchool;
    CaractAdd.Thieving:= fThievingSkills;
    CaractAdd.Alignment:= fAlignement;
    CaractAdd.HitPoints:= fPv;
  end;
  result.Pieces:= fPieces;
  result.MaxHitPoints:= FPvMax;
  result.Xp:= FXp;
  result.Position:= fPosition;
  result.Competences:= fCompetences; // Contient les listes ouverte par le perso.
  // "Vider" Comptence  niveaux
  for i:= 0 to high(result.CompsLevels) do begin
    result.CompsLevels[i].Competence:= 0;
    result.CompsLevels[i].LevelIncomp:= 0;
  end;
  for i:= 0 to high(fCompsLevels) do result.CompsLevels[i]:= fCompsLevels[i];
  result.PlacePierres:= fPlacePierres;
  // "Vider" Inventaire
  for i:= 0 to high(result.Inventaire) do begin
    result.Inventaire[i].IdObjet:= 0;
    result.Inventaire[i].Emplacement:= emNone;
    result.Inventaire[i].Pv:= 0;
    result.Inventaire[i].Identifier:= false;
    result.Inventaire[i].R1:= 0; // Nombre d'objet (7 potions de soins par exemple)
  end;
  for i:= Low(fInventaire) to high(fInventaire) do result.Inventaire[i]:= fInventaire[i];
  //"Vider" Sorts Actifs
  for i:= 0 to high(result.SortsActifs) do begin
    result.SortsActifs[i].IdObjet:= 0; // N d'identification de l'objet actif
    result.SortsActifs[i].TimeRemaining:= 0;
  end;
  for i:= Low(fSortsActifs) to high(fSortsActifs) do result.SortsActifs[i]:= fSortsActifs[i];
  result.Saoul:= fSaoul;
  result.Etat:= fEtat;
  result.Fatigue:= fFatigue;
  result.Visible:= fVisible;
  result.Resistances:= fResistances;
  result.muet:= fmuet;
  result.sourd:= fSourd;
  result.paralyser:= fParalyser;
  result.marche:= fMarche;
  result.geler:= fGeler;
  result.langues:= fLangues;
  result.PointsRestants:= fPointsRestants;
  result.dieu:= fDieu;
  result.rang:= fRang;
  //"Vider" Sorts connus
  for i:= 0 to high(result.LivreSorts) do
    result.LivreSorts[i]:= 0;
  for i:= Low(fLivreSorts) to high(fLivreSorts) do result.LivreSorts[i]:= fLivreSorts[i];
  Result.Mana:= fmana;

end;

procedure TPjPerso.SetRecordPerso(Value: TPersonnage);
var i: shortint;
begin
  FId:= GetIdFromName(Value.CaractAdd.name);
  FDestination:= value.Position.xyz;

  with value do begin
    fname:= CaractAdd.Name;
    fPassword:= CaractAdd.Password;
    fScores:= CaractAdd.Scores;
    fExStrength:= CaractAdd.ExStrength;
    fRace:= Ord(CaractAdd.Race);
    fSex:= CaractAdd.Sex;
    fTaille:= CaractAdd.Height;
    fPoids:= CaractAdd.Weight;
    fAge:= CaractAdd.Age;
    fMaxAge:= CaractAdd.MaxAge;
    fClasses:= CaractAdd.Classes;
    fMagicSchool:= CaractAdd.MagicSchool;
    fThievingSkills:= CaractAdd.Thieving;
    fAlignement:= CaractAdd.Alignment;
    fPv:= CaractAdd.HitPoints;
  end;
  fPieces:= value.Pieces;
  fPvMax:= value.MaxHitPoints;
  FXp:= value.Xp;
  fPosition:= value.Position;
  fCompetences:= value.Competences; // Contient les listes ouverte par le perso.
  // "Vider" Comptence  niveaux
  for i:= 0 to high(value.CompsLevels) do begin
    value.CompsLevels[i].Competence:= 0;
    value.CompsLevels[i].LevelIncomp:= 0;
  end;
  for i:=low(fCompsLevels) to high(fCompsLevels) do fCompsLevels[i]:= value.CompsLevels[i];
  fPlacePierres:= value.PlacePierres;
  // "Vider" Inventaire
  for i:= 0 to high(value.Inventaire) do begin
    value.Inventaire[i].IdObjet:= 0;
    value.Inventaire[i].Emplacement:= emNone;
    value.Inventaire[i].Pv:= 0;
    value.Inventaire[i].Identifier:= false;
    value.Inventaire[i].R1:= 0; // Nombre d'objet (7 potions de soins par exemple)
  end;
  for i:= Low(fInventaire) to high(fInventaire) do fInventaire[i]:= value.Inventaire[i];
  //"Vider" Sorts Actifs
  for i:= 0 to high(value.SortsActifs) do begin
    value.SortsActifs[i].IdObjet:= 0; // N d'identification de l'objet actif
    value.SortsActifs[i].TimeRemaining:= 0;
  end;
  for i:= Low(fSortsActifs) to high(fSortsActifs) do fSortsActifs[i]:= value.SortsActifs[i];
  fSaoul:= value.Saoul;
  fEtat:= value.Etat;
  fFatigue:= value.Fatigue;
  fVisible:= value.Visible;
  fResistances:= value.Resistances;
  fmuet:= value.muet;
  fSourd:= value.sourd;
  fParalyser:= value.paralyser;
  fMarche:= value.marche;
  fGeler:= value.geler;
  fLangues:= value.Langues;
  fPointsRestants:= Value.PointsRestants;
  fdieu:= Value.Dieu;
  fRang:= Value.Rang;
  //"Vider" Sorts connus
  for i:= 0 to high(value.LivreSorts) do
    value.LivreSorts[i]:= 0;
  for i:= Low(fLivreSorts) to high(fLivreSorts) do fLivreSorts[i]:= value.LivreSorts[i];
  fmana:= Value.Mana;
end;

function TPjPerso.GetName: string;
begin
  result:= fname;
end;

procedure TPjPerso.SetName(value: string);
begin
  if fname <> value then begin
    fname:= value;
  end;
end;

function TPjPerso.GetPassword: string;
begin
  result:= fPassword;
end;

procedure TPjPerso.SetPassword(value: string);
begin
  if fPassword <> value then begin
    fpassword:= Value;
  end;
end;

function TPjPerso.GetClassArmor: Shortint;
begin
  raise exception.Create('Retrouver l''unit ou est dfinit comment se caclcul ClassArmor (ancien ADK 3.8)');
end;

procedure TPjPerso.SetClassArmor(value: shortint);
begin
  exit;
end;

function TPjPerso.GetVitesse: byte;
begin
  raise exception.Create('Reprendre le type de calcul suivant l''emcobrement comme sur ADK 3.8');
end;

procedure TPjPerso.SetVitesse(Value: Byte);
begin
  exit;
end;

function TPjPerso.GetLevel: Word;
begin
  raise exception.Create('Trouver comment est calculer le niveau d''un personnage');
end;

function TPjPerso.GetThaco: shortint;
begin
  raise exception.Create('Placer ici le calcul qui permet d''avoir le Thaco d''un PJ');
end;

procedure TPjPerso.SetThaco(value: shortint);
begin
  exit;
end;

function TPjPerso.GetTaille: word;
begin
  result:= FTaille;
end;

procedure TPjPerso.SetTaille(value: word);
begin
  if FTaille <> Value then begin
    FTaille:= value;
  end;
end;

function TPjPerso.GetScores: TAbilities;
begin
  result:= fScores;
end;

procedure TPjPerso.SetScores(Value: TAbilities);
begin
  fScores:= Value;
end;

function TPjPerso.GetScore(Indice: TAbility): byte;
begin
  result:= fScores[indice];
end;

procedure TPjPerso.SetScore(Indice: TAbility; Value: byte);
begin
  if fScores[indice] <> value then begin
    fScores[indice]:= value;
  end;
end;

function TPjPerso.GetExStrength: byte;
begin
  result:= fExStrength;
end;

procedure TPjPerso.SetExStrength(value: byte);
begin
  if fExStrength <> value then begin
    fExStrength:= value;
  end;
end;

function TPjPerso.GetPoids: word;
begin
  result:= fPoids;
end;

procedure TPjPerso.SetPoids(value: word);
begin
  if fPoids <> Value then begin
    fPoids:= Value;
  end;
end;

function TPjPerso.GetAge: word;
begin
  result:= fAge;
end;

procedure TPjPerso.SetAge(value: word);
begin
  if fAge <> Value then begin
    fAge:= Value;
  end;
end;

function TPjPerso.GetMaxAge: word;
begin
  result:= fMaxAge;
end;

procedure TPjPerso.SetMaxAge(value: word);
begin
  if fMaxAge <> Value then begin
    fMaxAge:= Value;
  end;
end;

function TPjPerso.GetClasses: TClasses;
begin
  result:= fClasses;
end;

procedure TPjPerso.SetClasses(value: TClasses);
begin
  fClasses:= Value;
end;

function TPjPerso.GetMagicSchool: TSchoolOfMagic;
begin
  result:= fMagicSchool;
end;

procedure TPjPerso.SetMagicSchool(Value: TSchoolOfMagic);
begin
  if fMagicSchool <> value then begin
    fMagicSchool:= value;
  end;
end;

function TPjPerso.GetThievingSkills: TThievingSkills;
begin
  result:= fThievingSkills;
end;

procedure TPjPerso.SetThievingSkills(value: TThievingSkills);
begin
  fThievingSkills:= Value;
end;

function TPjPerso.GetThievingSkill(indice: TThievingSkill): byte;
begin
  result:= fThievingSkills[indice];
end;

procedure TPjPerso.SetThievingSkill(indice: TThievingSkill; value: byte);
begin
  if fThievingSkills[indice] <> Value then begin
    fThievingSkills[indice]:= Value
  end;
end;

function TPjPerso.GetPieces: Cardinal;
begin
  result:= fPieces;
end;

procedure TPjPerso.SetPieces(value: Cardinal);
begin
  if fPieces <> Value then begin
    fPieces:= Value;
  end;
end;

function TPjPerso.GetCompetences: TListCompetences;
begin
  result:= fCompetences;
end;

procedure TPjPerso.SetCompetences(value: TListCompetences);
begin
  fCompetences:= value;
end;

function TPjPerso.GetPlacePierres: T3Pierres;
begin
  result:= fPlacePierres;
end;

procedure TPjPerso.SetPlacePierres(value: T3Pierres);
begin
  fPlacePierres:= value;
end;

function TPjPerso.GetSaoul: ShortInt;
begin
  result:= fSaoul;
end;

procedure TPjPerso.SetSaoul(value: ShortInt);
begin
  if fSaoul <> Value then begin
    fSaoul:= Value;
  end;
end;

function TPjPerso.GetEtat: ShortInt;
begin
  result:= fEtat;
end;

procedure TPjPerso.SetEtat(value: ShortInt);
begin
  if fEtat <> Value then begin
    fEtat:= Value;
  end;
end;

function TPjPerso.GetFatigue: ShortInt;
begin
  result:= fFatigue;
end;

procedure TPjPerso.SetFatigue(value: ShortInt);
begin
  if fFatigue <> value then begin
    fFatigue:= value;
  end;
end;

function TPjPerso.GetBlocages(indice: integer): boolean;
begin
  case indice of
    0: result:= fmuet;
    1: result:= fSourd;
    2: result:= fParalyser;
    3: result:= fMarche;
    4: result:= fGeler;
  else result:= false end;
end;

procedure TPjPerso.SetBlocages(indice: integer; value: boolean);
begin
  case indice of
    0: if fmuet <> value then begin
        fmuet:= value;
      end;
    1: if fSourd <> Value then begin
        fSourd:= value;
      end;
    2: if fParalyser <> value then begin
        fParalyser:= value;
      end;
    3: if fMarche <> value then begin
        fMarche:= value;
      end;
    4: if fGeler <> value then begin
        fGeler:= value;
      end;
  else end;
end;

function TPjPerso.GetDieu: cardinal;
begin
  result:= fDieu;
end;

procedure TPjPerso.SetDieu(value: Cardinal);
begin
  if fDieu <> value then begin
    fDieu:= value;
  end;
end;

function TPjPerso.GetRang: byte;
begin
  result:= fRang;
end;

procedure TPjPerso.SetRang(value: byte);
begin
  if fRang <> value then begin
    frang:= value;
  end;
end;

function TPjPerso.GetLangues: TLanguesExtended;
begin
  result:= fLangues;
end;

procedure TPjPerso.SetLangues(value: TLanguesExtended);
begin
  flangues:= value;
end;

function TPjPerso.GetPointsRestants: TPointsRestants;
begin
  result:= fPointsRestants;
end;

procedure TPjPerso.VidePointsRestants;
var i: byte;
begin
  for i:= ord(prLangue) to ord(prComp2) do
    fPointsRestants[TPointRestant(i)]:= 0;
end;

procedure TPjPerso.SetPointsRestants(value: TPointsRestants);
begin
  fPointsRestants:= value;
end;

function TPjPerso.GetPointRestant(indice: TPointRestant): byte;
begin
  result:= fPointsRestants[indice];
end;

procedure TPjPerso.SetPointRestant(indice: TPointRestant; value: byte);
begin
  fPointsRestants[indice]:= value;
end;

function TPjPerso.GetLivreSorts: TSortsConnus;
begin
  result:= fLivreSorts;
end;

procedure TPjPerso.SetLivreSorts(value: TSortsConnus);
begin
  fLivreSorts:= value;
end;

function TPjPerso.GetMana: Cardinal;
begin
  result:= fMana;
end;

procedure TPjPerso.SetMana(value: cardinal);
begin
  if fmana <> value then begin
    fmana:= value;
  end;
end;



{ TListPerso }

function TListPerso.Add(ACustomPerso: TCustomPerso): Integer;
begin
  Result:= inherited Add(ACustomPerso);
  //if FItemIndex= -1 then FItemindex:= result;
  if assigned(FOnAdd) then FOnAdd(self, ACustomPerso);
end;

procedure TListPerso.clear;
begin
  inherited;
  FItemIndex:= -1;
end;

constructor TListPerso.create;
begin
  inherited;
  FItemIndex:= -1;
end;

procedure TListPerso.Delete(Index: Integer);
var StrTemp: string;
begin
  if ItemIndex <> -1 then strtemp:= Items[ItemIndex].Name;
  if assigned(FOnDelete) then FOnDelete(self, Items[Index]);
  inherited;
  if ItemIndex <> -1 then ItemIndex:= GetIndexByName(strtemp);
end;

procedure TListPerso.DeleteByID(const Id: Cardinal);
var i: integer;
begin
  for i:= 0 to Count - 1 do
    if ID = Items[i].ID then
    begin
      Delete(i);
      exit;
    end;
end;

function TListPerso.GetIndexByName(Name: string): integer;
var i: integer;
begin
  result:= -1;
  for i:= 0 to count - 1 do
    if ansisametext(Items[i].Name, Name) then
    begin
      result:= i;
      exit;
    end;
end;

function TListPerso.GetPersoByName(name: string): TCustomPerso;
var i: integer;
begin
  result:= nil;
  for i:= 0 to Count - 1 do
    if ansisametext(Items[i].Name, Name) then
    begin
      result:= TCustomPerso(inherited Items[i]);
      exit;
    end;
end;

function TListPerso.GetPersoByID(Id: Cardinal): TCustomPerso;
var i: integer;
begin
  result:= nil;
  for i:= 0 to Count - 1 do
    if ID = Items[i].ID then
    begin
      result:= TCustomPerso(inherited Items[i]);
      exit;
    end;
end;

function TListPerso.GetItems(Index: Integer): TCustomPerso;
begin
  Result:= TCustomPerso(inherited Items[Index]);
end;

function TListPerso.IndexOf(ACustomPerso: TCustomPerso): Integer;
begin
  Result:= inherited IndexOf(ACustomPerso);
end;

procedure TListPerso.Insert(Index: Integer; ACustomPerso: TCustomPerso);
var StrTemp: string;
begin
  if ItemIndex <> -1 then strtemp:= Items[ItemIndex].Name;
  inherited Insert(Index, ACustomPerso);
  if ItemIndex <> -1 then ItemIndex:= GetIndexByName(strtemp);
  if assigned(FOnAdd) then FOnAdd(self, ACustomPerso);
end;

function TListPerso.Remove(ACustomPerso: TCustomPerso): Integer;
var StrTemp: string;
begin
  if ItemIndex <> -1 then strtemp:= Items[ItemIndex].Name;
  if assigned(FOnDelete) then FOnDelete(self, ACustomPerso);
  Result:= inherited Remove(ACustomPerso);
  if ItemIndex <> -1 then ItemIndex:= GetIndexByName(strtemp);
end;

procedure TListPerso.SetItems(Index: Integer; ACustomPerso: TCustomPerso);
begin
  inherited Items[Index]:= ACustomPerso;
  if assigned(FOnAdd) then FOnAdd(self, ACustomPerso);
end;

procedure TListPerso.SetItemIndex(const Value: integer);
begin
  if FItemIndex <> Value then begin
    FItemIndex:= Value;
    if Assigned(FParent) then begin
      if FItemIndex = -1 then FParent.ActivePersoByID(0)
      else FParent.ActivePersoByID(Items[FItemIndex].ID);
    end;
  end;
end;

{ TPersosComplets }

function TPersosComplets.count: integer;
begin
  result:= ListPerso.Count;
end;

procedure TPersosComplets.AddedPerso(Sender: TObject; Value: TCustomPerso);
begin
  if ListPerso.ItemIndex = -1 then begin
    if assigned(FOnChangeIndex) then FOnChangeIndex(Self, Value);
    ListPerso.ItemIndex:= ListPerso.indexof(Value);
  end;
  if assigned(FOnAdd) then FOnAdd(Sender, Value);
end;

procedure TPersosComplets.ActivePersoByName(name: string);
begin
  if not ActivePersoByID(GetIdFromName(name)) then
    raise Exception('Erreur F290F1: Le personnage: ' + name + ' n''existe pas et ne peut pas tre activ.');
end;

function TPersosComplets.ActivePersoByID(ID: Cardinal): boolean;
var i: integer;
  strTemp: string;
begin
  result:= true;
  strTemp:= '';
  if (ListPerso.ItemIndex > -1) then
    if assigned(FListPerso[FListPerso.ItemIndex]) then
      strTemp:= FListPerso[FListPerso.ItemIndex].Name;
  for i:= 0 to FListPerso.count - 1 do
    if Id = FListPerso[i].ID then begin
      FListPerso.ItemIndex:= i;
      if not ansisametext(strTemp, FListPerso[ListPerso.ItemIndex].Name) then
        if assigned(FOnChangeIndex) then FOnChangeIndex(Self, FListPerso[ListPerso.ItemIndex]);
      exit;
    end;
  // SI on arrive jusqu'ici c'est que le perso n'existe pas
  if assigned(FOnChangeIndex) then FOnChangeIndex(Self, nil);
  //Raise Exception('Erreur F290F1: Le personnage: avec l''ID'+ IntToStr(ID) + ' n''existe pas et ne peut pas tre activ.');
  result:= false;
end;

constructor TPersosComplets.Create(AOwner: TComponent);
begin
  inherited;
  FListPerso:= TListPerso.create;
  FListPerso.FOnAdd:= AddedPerso;
  FListPerso.FOnDelete:= DeletedPerso;
  FListPerso.Parent:= Self;
end;

procedure TPersosComplets.DeletedPerso(Sender: TObject; Value: TCustomPerso);
begin
  if assigned(FOnDelete) then FOnDelete(Sender, Value);
end;

destructor TPersosComplets.Destroy;
begin
  FListPerso.free;
  inherited;
end;

function TPersosComplets.GetPerso(name: string): TCustomPerso;
begin
  result:= FListPerso.GetPersoByName(name);
end;

function TPersosComplets.GetPerso(Id: Cardinal): TCustomPerso;
begin
  result:= FListPerso.GetPersoByID(ID);
end;

function TPersosComplets.GetPersoActif: TCustomPerso;
begin
  if (FListPerso.ItemIndex > -1) and (FListPerso.ItemIndex < FListPerso.count) then
    result:= FListPerso.Items[FListPerso.ItemIndex]
  else result:= nil;
end;

function TPersosComplets.GetIndexByName(Name: string): integer;
begin
  result:= GetIndexByName(Name);
end;

end.

