unit StartADK1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, jpeg, IniFiles,ShellAPI;

type
  TMainForm = class(TForm)
    Background: TImage;
    TopBottom: TImage;
    LeftRight: TImage;
    Image1: TImage;
    lbConnexion: TLabel;
    Label2: TLabel;
    edPassword: TEdit;
    Image2: TImage;
    lbPerso: TListBox;
    bvConnexion: TBevel;
    lbNouveau: TLabel;
    bvNouveau: TBevel;
    Label1: TLabel;
    procedure FormPaint(Sender: TObject);
    procedure lbConnexionMouseEnter(Sender: TObject);
    procedure lbConnexionMouseLeave(Sender: TObject);
    procedure lbNouveauMouseEnter(Sender: TObject);
    procedure lbNouveauMouseLeave(Sender: TObject);
    procedure lbNouveauMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lbNouveauMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure lbConnexionMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    Path:string;
//    Thread:THandle;
 //   procedure WMUser(Var Msg:TMessage); message wm_user;
    procedure WMEraseBkGnd(Var Msg:TMessage); message wm_erasebkgnd;
    procedure StartADK;
  public
    { Dclarations publiques }
  end;

var
  MainForm: TMainForm;

function GetADKServer(var ip:string; var port:word):boolean;

implementation

uses HttpSock,Player, handbook, handbook2;

{$R *.dfm}

function GetADKServer(var ip:string; var port:word):boolean;
 var
  s:string;
  rq:string;
  i:integer;
 begin
  result:=false;
  s:=''; // http header
  rq:=HttpGet('perso.wanadoo.fr','/adk/ipadk.ip',s);
  if rq='' then exit;
  i:=pos(';',rq);
  if i<0 then exit;
  ip:=copy(rq,1,i-1);
  delete(rq,1,i);
  val(rq,port,i);
  if port=0 then exit;
  result:=true;
 end;

procedure TMainForm.WMEraseBkGnd(Var Msg:TMessage);
 begin
  Msg.Result:=1;
 end;

procedure TMainForm.FormPaint(Sender: TObject);
 var
  a,b,x,y,w,h:integer;
 begin
 // image du fond
  w:=Background.Width;
  h:=Background.Height;
  for y:=0 to (ClientHeight div h) do
   for x:=0 to (clientWidth div w) do begin
    Canvas.Draw(x*w,y*h,Background.Picture.Graphic);
   end;
 // bordure droite/gauche
  w:=LeftRight.Width;
  h:=LeftRight.Height;
  a:=-w div 2;
  b:=ClientWidth+a;
  for y:=0 to (ClientHeight div h) do begin
   Canvas.Draw(a,y*h,LeftRight.Picture.Graphic);
   Canvas.Draw(b,y*h,LeftRight.Picture.Graphic);
  end;
 // bordure haut/bas
  w:=TopBottom.Width;
  h:=TopBottom.Height;
  a:=-h div 2;
  b:=ClientHeight+a;
  for x:=0 to (ClientWidth div w) do begin
   Canvas.Draw(x*w,a,TopBottom.Picture.Graphic);
   Canvas.Draw(x*w,b,TopBottom.Picture.Graphic);
  end;
 end;

procedure TMainForm.lbConnexionMouseEnter(Sender: TObject);
begin
 bvConnexion.Show;
end;

procedure TMainForm.lbConnexionMouseLeave(Sender: TObject);
begin
 bvConnexion.Hide;
end;

procedure TMainForm.lbNouveauMouseEnter(Sender: TObject);
begin
 bvNouveau.show;
end;

procedure TMainForm.lbNouveauMouseLeave(Sender: TObject);
begin
 bvNouveau.Hide;
end;

procedure TMainForm.lbNouveauMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 bvNouveau.Style:=bsLowered;
 SetCaptureControl(lbNouveau);
end;

function NewCharacter(var ACharacter: TCharacter;
  out Langues: TLangues; out Armes: TWeapons;
  out ReserveArme: byte; out ReserveVoleur: byte; out ReserveLangue: byte): boolean; external 'ADKPC.DLL';

procedure TMainForm.lbNouveauMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var ReserveArme, ReserveVoleur, ReserveLangue: byte;
  Langues: TLangues; Armes: TWeapons;
begin
 bvNouveau.style:=bsRaised;
 if (X>=0)and(Y>=0)and(X<lbNouveau.Width)and(Y<lbNouveau.Height) then begin
  if NewCharacter(Character, langues, Armes, ReserveArme, ReserveVoleur, ReserveLangue) then begin
   with TIniFile.Create(path+'ADK.INI') do begin
    WriteString('MyPerso','P'+IntToStr(lbPerso.Count),Character.Name);
    Free;
   end;
   lbPerso.ItemIndex:=lbPerso.Items.Add(Character.Name);
   edPassword.Text:=Character.Password;
   StartADK;
  end;
 end;
end;

var
 AdresseIP:string;

function GetIP(sender:TMainForm):integer; stdcall;
var
 s:string;
begin
 s:='';
 AdresseIP:=HttpGet('perso.wanadoo.fr','/adk/ipadk.ip',s);
 PostMessage(sender.Handle,wm_user,0,0);
 Result:=0;
end;
{
procedure TMainForm.WMUSER(Var Msg:TMessage);
 begin
  CloseHandle(Thread);
  if AdresseIP='' then
   Label1.Caption:='Accs au serveur impossible.'
  else
   Label1.Caption:=AdresseIP;
 end;
}
procedure TMainForm.FormCreate(Sender: TObject);
var
// id:cardinal;
 i:integer;
 s:string;
begin
 s:='';
// Thread:=CreateThread(nil,0,@GetIP,pointer(self),0,id);
// Label1.Caption:=HttpGet('perso.wanadoo.fr','/adk/ipadk.ip',s);
 path:=ExtractFilePath(Application.ExeName);
 s:=path+'ADK.INI';
 with TIniFile.Create(s) do begin
  i:=0;
  s:=ReadString('MyPerso','P'+IntToStr(i),'');
  if s<>'' then lbPerso.Clear;
  while s<>'' do begin
   lbPerso.Items.Add(Copy(s,1,pos(';',s)-1));
   inc(i);
   s:=ReadString('MyPerso','P'+IntToStr(i),'');
  end;
  Free;
 end;
end;

procedure TMainForm.lbConnexionMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
 begin
  StartADK;
 end;

procedure TMainForm.StartADK;
var
 i:integer;
 ip:string;
 s:string;
 port:word;
 path:string;
begin
 i:=lbPerso.ItemIndex;
 if i<0 then exit;
 // on lance ADK.EXE
 if not GetADKServer(ip,port) then begin
  ShowMessage('Impossible de se connecter au serveur ADK.');
  exit;
 end;
 s:=ip+'|'+IntToStr(port)+'|0.7|'+lbPerso.Items[i]+'|'+edPassword.Text;
// ShowMessage(s);
 ShellExecute(handle,nil,'ADK.EXE',pchar(s),pchar(path),CmdShow);
end;

end.
