unit Globals;

interface
uses SysUtils, classes, WIndows;

const
  ChrGuillemet = '"';
  ChrVirgule = ',';
  ChrPVirgule = ';';
  ChrBarre = '|';
  ChrPoint = '.';
  ChrEspace = ' ';
  ChrEgal = '=';
  ChrPercent = '%';

  StrTrue = 'true';
  StrFalse = 'false';

  LbaRep = 'libs';
  MapsRep = 'maps';
  MapsPartRep = 'parts';

  defaultNameFilePnjPj: string = 'Pnj-Pj.lpa'; //.lpa= Liste Personnages Adk
  LaunchPath: string = '';
  CopyColleFile: string = '~Colle.tmp';

  // A deplacer dans une autre unit
  Ext_Librairie = 'lba';
  Ext_Map = 'ma2';
  Ext_PartsMap = 'mae';
  Ext_ini = 'ini';

  Librairie_Filter = 'Librairie d''images  Adk (*.lba)|*.lba|Stockage d''image Adk (*.sta)|*.sta|Stockage d''animation Adk (*.saa)|*.saa|Tous les formats connus|*.lba;*.sta;*.saa';
  Map_Filter = 'Map Adk version 2 (*.' + Ext_Map + ')|*.' + Ext_Map;
  MapParts_Filter = 'Parts of Map Adk (*.' + Ext_PartsMap + ')|*.' + Ext_PartsMap;

  C_IniOptions = 'Options'; // Fichier Prj_serveur.ini
  C_IniStr = 'STR'; // Prj_serveur.ini
  C_IniGUID = 'GUID'; // Prj_serveur.ini
  C_IniCarteNais = 'CartesNaissance'; // Prj_serveur.ini
  C_PNJToConnect = 'PNJToConnect'; // Fichier Adkpnj.ini

  Chr_Encode = '9';
  C_StrNULL = 'NULL';

  C_NextMove: word = $FF67; // Voir dans le prog server. Si on a trouver un emplacemnt permettant d'aller vers la position souhaiter on renvoie ca dans Tr_position.map
  C_StopMove: word = $FF68; // sinon, si on ne trouve pas de chemin pour aller vers la destination on Stop.


type

  TXYTilde = record
    x: Integer;
    y: Integer;
  end;


  TModeMagie = (mmNone, mmNormal, mmAltered, mmInverted);
  //              Noire,   Verte,   Rouge,  Bleu,  Brune,      Blanche,       Jaune
  TElementMagie = (emMort, emNature, emFeu, emEau, emMinerale, emElectrique, emChimique);

  P_IdClass = ^R_IdClass;
  R_IdClass = record
    FId: Cardinal;
    FClass: TClass;
  end;

procedure RegisterOwnClass(const AClass: TClass);
function ClassFromId(const Id_Class: Cardinal): TClass; //Get Class by IdClass

//Si value plus petit que Min alors value= Min. Si value plus grand que Max alors value= Max.
function LimiteValue(Value, Min, Max: Integer): integer;
procedure invertValue(var A, b: integer); //A devient =  B et B devient egal  A
function RectValueAdjst(Arect: TRect): TRect;

//procedure merdum(Me: Tstream);

implementation
uses StrStuff {, Adkdata};


var listRegistered: Tlist;
  IdClass: P_IdClass;
  Conteur: Integer;

procedure RegisterOwnClass(const AClass: TClass);
begin
  if not Assigned(listRegistered) then listRegistered.Create;
  New(IdClass);
  IdClass^.FId := CrcString2(AClass.ClassName);
  IdClass^.FClass := AClass;
  listRegistered.Add(IdClass);
end;

function ClassFromId(const Id_Class: Cardinal): TClass;
var i: Integer;
begin
  for i := 0 to listRegistered.Count - 1 do
    if P_IdClass(listRegistered.Items[i])^.FId = Id_Class then begin
      Result := P_IdClass(listRegistered.Items[i]).FClass;
      exit;
    end;
  //Si on est arriv ici c'est que la Class n'est pas enregistrer
  raise Exception.Create('La class avec le n d''ID: ' +
    IntToStr(Id_Class) + ' n''est pas enregistre.');
end;

function LimiteValue(Value, Min, Max: Integer): Integer;
begin
  Result := Value;
  if Min > Max then Exit;
  if Min = Max then Result := Min;
  if Value < Min then Result := Min;
  if Value > Max then Result := Max;
end;


procedure invertValue(var A, b: integer); //A devient =  B et B devient egal  A
var c: integer;
begin
  C := A;
  A := B;
  B := C;
end;

function RectValueAdjst(Arect: TRect): TRect;
begin
  result := Arect;
  if result.left > result.Right then invertValue(result.left, result.Right);
  if result.top > result.bottom then invertValue(result.top, result.bottom);
end;

initialization
  listRegistered := Tlist.Create;

finalization
  { Nettoyage: libre les lments de la liste de classes ainsi que la liste }
  if Assigned(listRegistered) then begin
    for Conteur := 0 to (listRegistered.Count - 1) do
    begin
      IdClass := listRegistered.Items[Conteur];
      Dispose(IdClass);
    end;
    listRegistered.Free;
  end;
end.
