unit StrStuff;

interface
uses SysUtils, classes;

type
  TCharSet = TSysCharSet;


function GetIdFromName(const S: string): Cardinal;
function CrcString2(const S: string): cardinal; // Utiliser pour donner une ID au persos. Celle ci devrait donner un Integer vraiment unique

function ReadBufferString(const Stream: TStream): string;
procedure WriteBufferString(const Stream: TStream; Value: string);

function CopyAndDel(var Value: string; const Symb: Char): string;
function XorEncode(const Key, Source: string): string;
function XorDecode(const Key, Source: string): string;
function ExtractWord(N: Integer; const S: string;
  const WordDelims: TCharSet): string;
function RemplaceStr(const Phrase, StrToReplc: string;
  ArrayStrings: array of string): string;
function RemplaceMot(const Text, OldWord, NewWord: string): string;
function GetLastWord(AText: string; Separateur: string): string;

implementation

function CrcString2(const S: string): cardinal; //Celle ci devrait donner un Integer vraiment unique
var i: Integer;
begin
  //On renvoit un n integer unique pour une chaine
  Result := 0;
  for i := 1 to length(s) do Inc(Result, (i + length(s)) * Ord(S[i]));
end;

function GetIdFromName(const S: string): Cardinal;
begin
  result := CrcString2(Uppercase(S));
end;

function ReadBufferString(const Stream: TStream): string;
var i, j: Integer;
begin
  Stream.ReadBuffer(i, SizeOf(i));
  SetLength(Result, i);
  for j := 1 to i do
    Stream.ReadBuffer(result[j], SizeOf(Result[j]));
    {#todo 1: On doit pouvoir lire la chaine en une seule fois quand mme}
end;

procedure WriteBufferString(const Stream: TStream; Value: string);
var i: Integer;
begin
  i := Length(Value);
  Stream.WriteBuffer(i, SizeOf(i));
  for i := 1 to Length(Value) do
    Stream.WriteBuffer(Value[i], SizeOf(Value[i]));
end;

//Copy2SymbDel de StrUtils n'efface pas le Symb ..ici oui
// exemple ('Salut,toit,comment) Et bien Copy2SymbDel laisse une chaine
//(',toit,comment) et je voudrais ('toit,comment) Remarquer qu'il manque la virgule de debut

function CopyAndDel(var Value: string; const Symb: Char): string;
var P: Integer;
begin
  P := Pos(Symb, value);
  if P = 0 then P := Length(value) + 1;
  Result := Copy(value, 1, P - 1);
  value := Copy(value, P + 1, length(Value));
end;

function XorEncode(const Key, Source: string): string;
var
  I: Integer;
  C: Byte;
begin
  Result := '';
  for I := 1 to Length(Source) do begin
    if Length(Key) > 0 then
      C := Byte(Key[1 + ((I - 1) mod Length(Key))]) xor Byte(Source[I])
    else
      C := Byte(Source[I]);
    Result := Result + AnsiLowerCase(IntToHex(C, 2));
  end;
end;

function XorDecode(const Key, Source: string): string;
var
  I: Integer;
  C: Char;
begin
  Result := '';
  for I := 0 to Length(Source) div 2 - 1 do begin
    C := Chr(StrToIntDef('$' + Copy(Source, (I * 2) + 1, 2), Ord(' ')));
    if Length(Key) > 0 then
      C := Chr(Byte(Key[1 + (I mod Length(Key))]) xor Byte(C));
    Result := Result + C;
  end;
end;

function WordPosition(const N: Integer; const S: string;
  const WordDelims: TCharSet): Integer;
var
  Count, I: Integer;
begin
  Count := 0;
  I := 1;
  Result := 0;
  while (I <= Length(S)) and (Count <> N) do begin
    { skip over delimiters }
    while (I <= Length(S)) and (S[I] in WordDelims) do Inc(I);
    { if we're not beyond end of S, we're at the start of a word }
    if I <= Length(S) then Inc(Count);
    { if not finished, find the end of the current word }
    if Count <> N then
      while (I <= Length(S)) and not (S[I] in WordDelims) do Inc(I)
    else Result := I;
  end;
end;

function ExtractWord(N: Integer; const S: string;
  const WordDelims: TCharSet): string;
var
  I: Integer;
  Len: Integer;
begin
  Len := 0;
  I := WordPosition(N, S, WordDelims);
  if I <> 0 then
    { find the end of the current word }
    while (I <= Length(S)) and not (S[I] in WordDelims) do begin
      { add the I'th character to result }
      Inc(Len);
      SetLength(Result, Len);
      Result[Len] := S[I];
      Inc(I);
    end;
  SetLength(Result, Len);
end;


function RemplaceStr(const Phrase, StrToReplc: string;
  ArrayStrings: array of string): string;
var i, X: integer;
  Source: string;
begin
  Source := Phrase;
  Result := '';
  for i := low(ArrayStrings) to High(ArrayStrings) do begin
    x := pos(StrToReplc, Source);
    if X > 0 then begin
      Result := Result + Copy(Source, 1, X - 1) + ArrayStrings[i];
      Source := Copy(Source, X + Length(StrToReplc), MaxInt);
    end else begin
      Result := Result + Source;
      exit;
    end;
  end;
end;

function RemplaceMot(const Text, OldWord, NewWord: string): string;
var X: integer;
begin
  Result := text;
  x := pos(OldWord, result);
  if X > 0 then begin
    Result := Copy(text, 1, X - 1) + NewWord;
    result := result + Copy(text, X + Length(oldWord), MaxInt);
  end;
end;

function GetLastWord(AText: string; Separateur: string): string;
var i: integer;
begin
  // renvoie le mot apres le dernier separateur
  // Ex: GetLastWord('/adk/eklerman.ip, '/');
  // renvoie 'eklerman.ip';
  // Si ya pas de separateur dans le text
  // on renvoie tout le texte
  result := Atext; //< Resulat par dfaut.
  for i := length(Atext) downto 0 do begin
    if Atext[i] = Separateur then begin
      result := copy(Atext, i + 1, length(Atext));
      exit;
    end;
  end;
end;

end.
